#
#  TTSP
#      TOPPERS Test Suite Package
# 
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2009-2011 by Digital Craft Inc.
#  Copyright (C) 2009-2011 by NEC Communication Systems, Ltd.
#  Copyright (C) 2009-2011 by FUJISOFT INCORPORATED
# 
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
# 
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
# 
#  $Id: kernel_lib.sh 2 2012-05-09 02:23:52Z nces-shigihara $
# 

# ͥ饤֥ᥤ˥塼
kernel_lib_main()
{
	while true
	do
		cat<<EOS

$DOUBLE_LINE
 $KERNEL_LIBRARY_MENU
$DOUBLE_LINE
 1: $L_ALL
 2: $L_MKDIR
 3: $L_DEPEND
 4: $L_BUILD
 5: $L_CLEAN
 6: $L_REALCLEAN
 r: $BACK_TO_MAIN_MENU
 q: $EXIT_TOOL
$SINGLE_LINE
EOS
echo -n " $INPUT_NO "
		# ɤ߹
		read key
		echo ""
		# ɤ߹ˤäʬ
		case ${key} in
			1)
			 header_double "$L_ALL"
			 build_kernel_library
			 ;;
			2)
			 header_double "$L_MKDIR"
			 rm -rf $KERNEL_LIB
			 mkdir -p $KERNEL_LIB
			 cd $KERNEL_LIB
			 perl ../../configure $CONFIG_KERNEL_LIB "$INCLUDE_DIR"
			 cd $TTSP_DIR
			 ;;
			3)
			 header_double "$L_DEPEND"
			 rule=$RULE_DEPEND
			 dir_name=$KERNEL_LIB
			 appli_name=$L_APPLI_NAME
			 make_for_no_manifest
			 ;;
			4)
			 header_double "$L_BUILD"
			 rule=$RULE_BUILD
			 dir_name=$KERNEL_LIB
			 appli_name=$L_APPLI_NAME
			 make_for_no_manifest
			 ;;
			5)
			 header_double "$L_CLEAN"
			 rule=$RULE_CLEAN
			 dir_name=$KERNEL_LIB
			 make_for_no_manifest
			 ;;
			6)
			 header_double "$L_REALCLEAN"
			 rule=$RULE_REALCLEAM
			 dir_name=$KERNEL_LIB
			 make_for_no_manifest
			 ;;
			r)
			 go_main_flg=1
			 ;;
			q)
			 exit 0
			 ;;
			*)
			 echo " $key $ERR_INVALID_NO"
			 ;;
		esac
		if [ $go_main_flg -eq 1 ]
		then
			go_main_flg=0
			break
		fi
	done

}

build_kernel_library()
{
	rm -rf $KERNEL_LIB
	mkdir -p $KERNEL_LIB
	cd $KERNEL_LIB
	perl ../../configure $CONFIG_KERNEL_LIB "$INCLUDE_DIR" 
	( make depend $MAKE_OPT KERNEL_COBJS="$KERNEL_COBJS_COMMON $KERNEL_COBJS_TARGET" 2>&1; echo $? >status_file ) | tee $RESULT_MAKE_DEPEND
	status=`cat status_file`
	rm -rf status_file
	if [ $status = 0 ]
	then
		make $MAKE_OPT KERNEL_COBJS="$KERNEL_COBJS_COMMON $KERNEL_COBJS_TARGET" 2>&1 | tee $RESULT_MAKE
	else
		echo "$ERR_DEPEND_FAIL "$KERNEL_LIB
	fi
	cd $TTSP_DIR
}

# 
kernel_lib_main
