/*
 *  TTSP
 *      TOPPERS Test Suite Package
 * 
 *  Copyright (C) 2010-2012 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010-2011 by Digital Craft Inc.
 *  Copyright (C) 2010-2011 by NEC Communication Systems, Ltd.
 *  Copyright (C) 2010-2012 by FUJISOFT INCORPORATED
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: out.h 2 2012-05-09 02:23:52Z nces-shigihara $
 */

#include "ttsp_target_test.h"

/*
 *  ߤȯʤäȽǤ
 *  (sil_dly_nse()ΰǻ)
 */
#define TTSP_WAIT_NOT_RAISE_INT  1000000

/* sil_dly_nse()ǥƥȤٱ  */
#define SIL_DLY_TIME      10000000
#define SIL_DLY_TIME_SUB  SIL_DLY_TIME / 1000000

/* ɤ߽񤭤ǻѤǡ */
#define R_DATA8       0x12
#define R_DATA16      0x1234
#define R_DATA32      0x12345678
#define W_DATA8       0x21
#define W_DATA16      0x4321
#define W_DATA32      0x87654321
#define CLEAR32       0x00000000

/* ƥȽ */
typedef enum e_test_type {
	CHG_IPM,
	DIS_DSP
} E_TEST_TYPE;

extern void main_task(intptr_t exinf);
extern void texhdr(TEXPTN texptn, intptr_t exinf);
extern void almhdr(intptr_t exinf);
extern void cychdr(intptr_t exinf);
extern void exchdr(void* p_excinf);
extern void inirtn(intptr_t exinf);
extern void terrtn(intptr_t exinf);

extern void inthdr_for_int_test(void);

extern void all_test(ID prcid, bool_t int_spn_flg);
extern void part_test(ID prcid, E_TEST_TYPE test_type, bool_t int_spn_flg);

extern void test_of_sil_mem(ID prcid, bool_t ter_flg);
extern void test_of_sil_dly_nse(ID prcid);
extern void test_of_sil_get_pid(ID prcid, bool_t ter_flg);
extern void test_of_sns_ker(ID prcid, bool_t flag, bool_t ter_flg);
extern void test_of_SIL_LOC_INT_SPN(ID prcid, bool_t int_spn_flg);

extern void wait_raise_int(ID prcid);
extern void check_of_sil_mem(void);

#if defined(TTSP_INTNO_B) || defined(TTSP_INTNO_PE2_B) || defined(TTSP_INTNO_PE3_B) || defined(TTSP_INTNO_PE4_B)
extern void inthdr(void);
#endif /* defined(TTSP_INTNO_B) || defined(TTSP_INTNO_PE2_B) || defined(TTSP_INTNO_PE3_B) || defined(TTSP_INTNO_PE4_B) */

#if defined(TTSP_INTNO_C) || defined(TTSP_INTNO_PE2_C) || defined(TTSP_INTNO_PE3_C) || defined(TTSP_INTNO_PE4_C)
extern void isr(intptr_t exinf);
#endif /* defined(TTSP_INTNO_C) || defined(TTSP_INTNO_PE2_C) || defined(TTSP_INTNO_PE3_C) || defined(TTSP_INTNO_PE4_C) */

extern void ttsp_test_lib_init(intptr_t exinf);
