#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: ASPBuilder.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/CommonModule.rb"
require "bin/builder/ProfileBuilder.rb"

module TTG

  #==================================================================
  # 饹̾: ASPBuilder
  #     : ƥȥʥꥪѤ֥ɤ륯饹
  #==================================================================
  class ASPBuilder < ProfileBuilder
    include CommonModule

    #================================================================
    #   : 󥹥ȥ饯
    #================================================================
    def initialize()
      super()

      # ASPǤGCOV
      if (@cConf.enable_gcov?())
        # GCOVѴؿ
        @cIMCode.add_gcov_resume_asp()
        @cIMCode.add_gcov_pause_asp()
      end

      # ؿСƥﹹǧؿ
      if (@cConf.get_func_time())
        @cIMCode.add_gain_tick_asp()
      end
    end

    #================================================================
    #   : pre_condition뤿֥ɤ
    #================================================================
    def build_pre_condition()
      # pre_conditionΥϥåɲä
      @cIMCode.set_condition_level(TSR_LBL_PRE)

      #
      # pre_conditionǿʤ֤
      #
      @cTS.set_pre_gain_tick()


      #
      # 㳰ľ֤
      #
      if (@cTS.exist_pre_task_tex_ena() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_tex_ena())
      end


      #
      # Ԥ֥Ȥ
      #

      # Ʊ֥̿Ȥν
      if (@cTS.exist_pre_scobj_data() == true)
        @cIMCode.add_element(@cTS.gc_pre_scobj_data())
      end

      # ֥Ԥ
      if (@cTS.exist_pre_task_scobj_waiting() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_scobj_waiting())
      end


      #
      # ¹Ծ֤ǤϤʤƥȤ
      #

      # Ԥ(꡼סǥ쥤)Υ
      # Ԥ֤Ԥ(꡼סǥ쥤)
      if (@cTS.exist_pre_task_waiting() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_waiting())
      end

      # ԤԤ֤Υ
      # Ԥ֤ζԤ֤
      if (@cTS.exist_pre_task_suspended() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_suspended())
      end

      # ¹Բǽ֤Υ
      if (@cTS.exist_pre_task_ready() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_ready())
      end


      #
      # α㳰װ(running,dormant,֥ԤʳΥ)
      #
      if (@cTS.exist_pre_task_tex_pndptn() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_tex_pndptn())
      end


      #
      # ͥ٤Ƚͥ٤ۤʤ륿(running,dormantʳΥ)
      #
      if (@cTS.exist_pre_task_pri_chg() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_pri_chg())
      end


      #
      # ư֡Txxx_STAˤΥ।٥ȥϥɥ
      #
      if (@cTS.exist_time_event_sta() == true)
        @cIMCode.add_element(@cTS.gc_pre_time_event_sta())
      end


      #
      # ľ֤γߤ(ena_int򥵥ݡȤƤΤ)
      #
      if ((@cTS.exist_interrupt_ena() == true) && (@cConf.get_api_support_ena_int() == true))
        @cIMCode.add_element(@cTS.gc_pre_interrupt_ena())
      end


      #
      # ¹Ծ֤ΥƥȤ
      # ʥ㳰
      #
      if (@cTS.exist_task_running() == true)
        # ư֡ACTIVATEˤΥ㳰ʤ
        if (@cTS.exist_pre_task_texhdr_activate() == false)
          @cIMCode.add_element(@cTS.gc_pre_task_running())
        # ư֡ACTIVATEˤΥ㳰
        else
          @cIMCode.add_element(@cTS.gc_pre_task_texhdr_activate())
        end
      end


      # ǥѥåػߤ
      if (@cTS.check_dis_dsp() == true)
        @cIMCode.add_element(@cTS.gc_pre_dis_dsp())
      end


      # ͥ٥ޥ
      # (󥿥ư뤳Ȥˤäѹ줿ѹʤ)
      if (@cTS.check_chg_ipm() == true)
        @cIMCode.add_element(@cTS.gc_pre_set_ipm())
      end


      #
      # ư֡ACTIVATEˤ󥿥ƥȤ
      #
      if (@cTS.exist_nontask_activate() == true)
        @cIMCode.add_element(@cTS.gc_pre_nontask_activate())
      end


      #
      # Ԥ֤ˤƤ¹Բǽ֤Υε
      #
      if (@cTS.exist_pre_task_ready() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_ready_porder())
      end


      #
      # ư׵ᥭ塼󥰤
      #
      if (@cTS.exist_task_queueing() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_queueing())
      end


      #
      # CPUå֤
      #
      if (@cTS.check_cpu_loc() == true)
        @cIMCode.add_element(@cTS.gc_pre_cpu_loc())
      end


      #
      # ֺǡ¹νñ̤
      # ֥Ȥrefɤ
      #
      @cIMCode.add_element(@cTS.gc_obj_ref())


      #
      # ξ֤˹ԤΥᥤ󥿥
      #
      @cIMCode.add_element(@cTS.gc_pre_maintask_set())

    end

    #================================================================
    #   : do_condition뤿֥ɤ
    #================================================================
    def build_do(nIndex)
      check_class(Integer, nIndex)  # do/postΥֹ

      # doΥϥåɲä
      @cIMCode.set_condition_level(TSR_LBL_DO + "_#{@cTS.get_seqnum(nIndex)}_#{@cTS.get_timetick(nIndex)}")

      # doν
      if (@cTS.check_do_info(nIndex) == true)
        @cIMCode.add_element(@cTS.gc_do(nIndex))
      end

      # ΥǥǵưACTIVATE󥿥¸ߤ硤ưԤ
      @cIMCode.add_element(@cTS.gc_wait_non_task_activate(nIndex))
    end

    #================================================================
    #   : post_conditionνλ뤿֥ɤ
    #         
    #================================================================
    def build_lastpost_condition(nIndex)
      check_class(Integer, nIndex)  # do/postΥֹ

      # post_conditionΥϥåɲä
      @cIMCode.set_condition_level(TSR_LBL_POST + "_#{@cTS.get_seqnum(nIndex)}_#{@cTS.get_timetick(nIndex)}")

      # ֥Ȥrefɤ֤
      @cIMCode.add_element(@cTS.gc_obj_ref(nIndex))

      # ǥѥåα֤ͥ٤ž֤readyΥslp_tsk
      # (ǥѥåǼ¹Ծ֤ΥѤäƤslp_tskˤäơcRunning¹Ծ֤ˤʤ)
      if ((@cTS.exist_nontask_activate(nIndex) == true) ||
          (@cTS.check_cpu_loc(nIndex) == true) ||
          (@cTS.check_dis_dsp(nIndex) == true) ||
          (@cTS.check_chg_ipm(nIndex) == true))
        @cIMCode.add_element(@cTS.gc_lastpost_ready_sleep())
      end

      #
      # λ
      # 

      # ¹Ծ֤νñ̤CPUå
      if (@cTS.check_cpu_loc(nIndex) == true)
        @cIMCode.add_element(@cTS.gc_lastpost_cpu_unl())
      end

      # ¹Ծ֤Υư(ACTIVATE)󥿥硤ᥤ󥿥򵯤
      if (@cTS.exist_task_running(nIndex) == true || @cTS.exist_nontask_activate(nIndex) == true)
        @cIMCode.add_element(@cTS.gc_lastpost_maintask_wup(nIndex))
      end

      # ǥѥåػߤβ
      if (@cTS.check_dis_dsp(nIndex) == true)
        @cIMCode.add_element(@cTS.gc_lastpost_ena_dsp())
      end

      # ͥ٥ޥν
      if (@cTS.check_chg_ipm(nIndex) == true)
        @cIMCode.add_element(@cTS.gc_lastpost_set_ini_ipm())
      end

      #
      # λǥᥤ󥿥¹Ծ֤ȤʤäƤ
      #

      # ưǤ̲᤹뤳ȤΤʤåݥȤƥɲ
      @cIMCode.add_element(@cTS.gc_checkpoint_zero())

      # ư֡Txxx_STAˤΥ।٥ȥϥɥ߽
      if (@cTS.exist_time_event_sta(nIndex) == true)
        @cIMCode.add_element(@cTS.gc_lastpost_time_event_stp())
      end

      #
      # ľ֤γߤζػ߽(dis_int򥵥ݡȤƤΤ)
      #
      if ((@cTS.exist_interrupt_ena(nIndex) == true) && (@cConf.get_api_support_dis_int() == true))
        @cIMCode.add_element(@cTS.gc_lastpost_interrupt_dis())
      end

      # ư׵ᥭ塼󥰤ν
      if (@cTS.exist_task_queueing(nIndex) == true)
        @cIMCode.add_element(@cTS.gc_lastpost_task_can_queueing())
      end

      # ᥤ󥿥Ǥ٤ƤΥter_tsk
      @cIMCode.add_element(@cTS.gc_lastpost_all_task_ter())

    end


    #================================================================
    #   : post_condition뤿֥ɤ
    #================================================================
    def build_post_condition(nIndex)
      check_class(Integer, nIndex)  # do/postΥֹ

      # post_conditionΥϥåɲä
      @cIMCode.set_condition_level(TSR_LBL_POST + "_#{@cTS.get_seqnum(nIndex)}_#{@cTS.get_timetick(nIndex)}")

      # ֥Ȥrefɤ֤
      @cIMCode.add_element(@cTS.gc_obj_ref(nIndex))

      # Υǥػ֤κʤ
      if (@cTS.exist_post_timetick(nIndex) == true)
        @cTS.get_post_time(nIndex).times{
          @cIMCode.add_element(@cTS.gc_tick_gain(nIndex))
        }
      end

      # ξ֤˹ԤΥᥤ󥿥Υɤ֤
      @cIMCode.add_element(@cTS.gc_post_maintask_set(nIndex, @cTS.exist_post_timetick(nIndex)))

    end

    #================================================================
    #   : ᥤ󥿥GCOV򳫻Ϥ
    #================================================================
    def build_main_task_gcov_start()
      cElement = IMCodeElement.new(:common)
      cElement.set_code(@cIMCode.hMainTask, "#{TTG_NL}#{TTG_TB}#{FNC_GCOV_C_PAUSE}")
      @cIMCode.add_element(cElement)
    end

    #================================================================
    #   : ᥤ󥿥ߤȯ
    #================================================================
    def build_int_raise(cElement, snIntNo, nPrcid)
      check_class(IMCodeElement, cElement)    # 
      check_class([String, Integer], snIntNo) # ֹ
      check_class(Integer, nPrcid, true)      # ץåID(ASPǤԻ)

      cElement.set_code(@cIMCode.hMainTask, "#{FNC_INT_RAISE}(#{snIntNo})")
    end

    #================================================================
    #   : ᥤ󥿥dis_int¹Ԥ
    #================================================================
    def build_dis_int(cElement, snIntNo, nPrcid)
      check_class(IMCodeElement, cElement)    # 
      check_class([String, Integer], snIntNo) # ֹ
      check_class(Integer, nPrcid, true)      # ץåID(ASPǤԻ)

      cElement.set_syscall(@cIMCode.hMainTask, "#{API_DIS_INT}(#{snIntNo})")
    end

  end
end
