#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: FMPBuilder.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "bin/builder/ProfileBuilder.rb"

module TTG

  #==================================================================
  # 饹̾: FMPBuilder
  #   : ƥȥʥꥪѤ֥ɤ륯饹
  #==================================================================
  class FMPBuilder < ProfileBuilder
    include CommonModule

    #================================================================
    # : 󥹥ȥ饯
    #================================================================
    def initialize()
      super()

      # FMPǤGCOV
      if (@cConf.enable_gcov?())
        # Х/λ롼
        build_gcov_ini_ter_rtn()

        # GCOVѴؿ
        @cIMCode.add_gcov_resume_fmp()
        @cIMCode.add_gcov_pause_fmp()
      end
    end

    #================================================================
    #   : pre_condition뤿֥ɤ
    #================================================================
    def build_pre_condition()
      # pre_conditionΥϥåɲä
      @cIMCode.set_condition_level(TSR_LBL_PRE)

      #
      # pre_conditionǿʤ֤
      #
      @cTS.set_pre_gain_tick()


      #
      # ľ֤γߤ(ena_int򥵥ݡȤƤΤ)
      #
      if ((@cTS.exist_interrupt_ena() == true) && (@cConf.get_api_support_ena_int() == true))
        @cIMCode.add_element(@cTS.gc_pre_interrupt_ena_fmp())
      end


      #
      # ٻ߾֤Υ
      #
      @cIMCode.add_element(@cTS.gc_pre_task_dormant_fmp())

      #
      # Υ।٥ȥϥɥ(륿Τ)
      #
      if (@cConf.is_timer_local?())
        @cIMCode.add_element(@cTS.gc_pre_time_event_stp_other_fmp())
      end

      #
      # 㳰ľ֤
      #
      if (@cTS.exist_pre_task_tex_ena() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_tex_ena())
      end


      #
      # Ԥ֥Ȥ
      #

      # Ʊ֥̿Ȥν
      if (@cTS.exist_pre_scobj_data() == true)
        @cIMCode.add_element(@cTS.gc_pre_scobj_data())
      end

      # ֥Ԥ
      if (@cTS.exist_pre_task_scobj_waiting() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_scobj_waiting_fmp())
      end


      #
      # ¹Ծ֤ǤϤʤƥȤ
      #


      # Ԥ(꡼סǥ쥤)Υ
      # Ԥ֤Ԥ(꡼סǥ쥤)
      if (@cTS.exist_pre_task_waiting() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_waiting_fmp())
      end


      # ԤԤ֤Υ
      # Ԥ֤ζԤ֤
      if (@cTS.exist_pre_task_suspended() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_suspended_fmp())
      end

      # ¹Բǽ֤Υ
      if (@cTS.exist_pre_task_ready() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_ready_fmp())
      end


      #
      # α㳰װ(running,dormantʳΥ)
      #
      if (@cTS.exist_pre_task_tex_pndptn() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_tex_pndptn())
      end


      #
      # ͥ٤Ƚͥ٤ۤʤ륿
      # (running,dormant,running-suspend,֥ԤʳΥ)
      #
      if (@cTS.exist_pre_task_pri_chg_fmp() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_pri_chg())
      end


      #
      # ư֡Txxx_STAˤΥ।٥ȥϥɥ
      #
      if (@cTS.exist_time_event_sta() == true)
        @cIMCode.add_element(@cTS.gc_pre_time_event_sta_fmp())
      end


      # ǥѥåػߤ
      @cIMCode.add_element(@cTS.gc_pre_dis_dsp_fmp())


      # ͥ٥ޥ
      @cIMCode.add_element(@cTS.gc_pre_set_ipm_fmp())


      #
      # ¹Ծ֤ΥƥȤ
      # ʥ㳰
      #
      if (@cTS.exist_task_running_fmp() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_running_texhdr_activate_fmp())
      end

      #
      # ư֡ACTIVATEˤ󥿥ƥȤ
      #
      if (@cTS.exist_nontask_activate_fmp() == true)
        @cIMCode.add_element(@cTS.gc_pre_nontask_activate_fmp())
      end


      # ¹ԽƱ
      @cIMCode.add_element(@cTS.gc_exec_sequence_sync())


      #
      # Ԥ֤ˤƤ¹Բǽ֤Υε
      #
      if (@cTS.exist_pre_task_ready() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_ready_porder_fmp())
      end


      #
      # ư׵ᥭ塼󥰤
      #
      if (@cTS.exist_task_queueing() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_queueing_fmp())
      end


      #
      # ԥå֤
      #
      @cIMCode.add_element(@cTS.gc_pre_spin_loc_fmp())


      #
      # CPUå֤
      #
      @cIMCode.add_element(@cTS.gc_pre_cpu_loc_fmp())


      #
      # Ͼ֤ΥƥȤ
      #
      if (@cTS.exist_pre_task_running_suspended_fmp() == true)
        @cIMCode.add_element(@cTS.gc_pre_task_running_suspended_fmp())
      end

      #
      # ֺǡ¹νñ̤
      # ֥Ȥrefɤ
      #
      @cIMCode.add_element(@cTS.gc_obj_ref_fmp())


      #
      # ХꥢƱ
      #
      @cIMCode.set_condition_level(IMC_CONDITION_SYNC)
      @cIMCode.add_element(@cTS.gc_barrier_sync())


      #
      # ξ֤˹ԤΥᥤ󥿥
      #
      @cIMCode.add_element(@cTS.gc_pre_maintask_set())

    end

    #================================================================
    #   : do_condition뤿֥ɤ
    #================================================================
    def build_do(nIndex)
      check_class(Integer, nIndex)  # do/postΥֹ

      # doΥϥåɲä
      @cIMCode.set_condition_level(TSR_LBL_DO + "_#{@cTS.get_seqnum(nIndex)}_#{@cTS.get_timetick(nIndex)}")

      # doν
      if (@cTS.check_do_info(nIndex) == true)
        @cIMCode.add_element(@cTS.gc_do_fmp(nIndex))
      end

      # ԥåԤ¸ߤƱʤ
      if (@cTS.exist_wait_spinlock_fmp(nIndex) == true)
        return
      end

      #
      # ƼƱ
      #
      @cIMCode.add_element(@cTS.gc_do_start_sync(nIndex))
      @cIMCode.add_element(@cTS.gc_do_finish_sync(nIndex))
      @cIMCode.add_element(@cTS.gc_gcov_pause_after_sync(nIndex))
      @cIMCode.set_condition_level(IMC_CONDITION_SYNC)
      @cIMCode.add_element(@cTS.gc_exec_sequence_sync(nIndex))
      @cIMCode.add_element(@cTS.gc_barrier_sync(nIndex))
    end

    #================================================================
    #   : post_conditionνλ뤿֥ɤ
    #         
    #================================================================
    def build_lastpost_condition(nIndex)
      check_class(Integer, nIndex)  # do/postΥֹ

      # post_conditionΥϥåɲä
      @cIMCode.set_condition_level(TSR_LBL_POST + "_#{@cTS.get_seqnum(nIndex)}_#{@cTS.get_timetick(nIndex)}")

      # ֥Ȥrefɤ֤
      @cIMCode.add_element(@cTS.gc_obj_ref_fmp(nIndex))

      # Ǹrefλޤ¾ץåθߤƤƱ
      @cIMCode.add_element(@cTS.gc_last_running_sync())

      # ǥѥåα֤ͥ٤ž֤readyΥslp_tsk
      # (ǥѥåǼ¹Ծ֤ΥѤäƤslp_tskˤäơcRunning¹Ծ֤ˤʤ)
      if ((@cTS.exist_nontask_activate_fmp(nIndex) == true) ||
          (@cTS.check_cpu_loc(nIndex) == true) ||
          (@cTS.check_dis_dsp(nIndex) == true) ||
          (@cTS.check_chg_ipm(nIndex) == true))
        @cIMCode.add_element(@cTS.gc_lastpost_ready_sleep_fmp())
      end

      #
      # λ
      # 

      # ԥåʼνñ̤Ԥ
      @cIMCode.add_element(@cTS.gc_lastpost_spin_unl_fmp())

      # ¹Ծ֤νñ̤CPUåʤ줾ΥץåԤ
      @cIMCode.add_element(@cTS.gc_lastpost_cpu_unl_fmp())

      # ¹Ծ֤Υư(ACTIVATE)󥿥硤ᥤ󥿥򵯤
      if (@cTS.exist_task_running_fmp(nIndex) == true || @cTS.exist_nontask_activate_fmp(nIndex) == true)
        @cIMCode.add_element(@cTS.gc_lastpost_maintask_wup(nIndex))
      end

      # ǥѥåػߤβʤ줾ΥץåԤ
      @cIMCode.add_element(@cTS.gc_lastpost_ena_dsp_fmp())

      # ͥ٥ޥνʤ줾ΥץåԤ
      @cIMCode.add_element(@cTS.gc_lastpost_set_ini_ipm_fmp())


      #
      # λǥᥤ󥿥¹Ծ֤ȤʤäƤ
      #

      # ư֡Txxx_STAˤΥ।٥ȥϥɥ߽
      if (@cTS.exist_time_event_sta(nIndex) == true)
        @cIMCode.add_element(@cTS.gc_lastpost_time_event_stp())
      end

      #
      # ľ֤γߤζػ߽
      #
      if (@cTS.exist_interrupt_ena(nIndex) == true)
        @cIMCode.add_element(@cTS.gc_lastpost_interrupt_dis_fmp())
      end

      # ư׵ᥭ塼󥰤ν
      if (@cTS.exist_task_queueing(nIndex) == true)
        @cIMCode.add_element(@cTS.gc_lastpost_task_can_queueing())
      end

      # ᥤ󥿥Ǥ٤ƤΥter_tsk
      @cIMCode.add_element(@cTS.gc_lastpost_all_task_ter_fmp())
    end

    #================================================================
    #   : post_condition뤿֥ɤ
    #================================================================
    def build_post_condition(nIndex)
      check_class(Integer, nIndex)  # do/postΥֹ

      # post_conditionΥϥåɲä
      @cIMCode.set_condition_level(TSR_LBL_POST + "_#{@cTS.get_seqnum(nIndex)}_#{@cTS.get_timetick(nIndex)}")

      # ԥåԤ¸ߤٱ䤵ǼΥǥ˿ʤ
      if (@cTS.exist_wait_spinlock_fmp(nIndex) == true)
        @cIMCode.add_element(@cTS.gc_delay_wait_spin_fmp(nIndex))
        return
      end

      # ֥Ȥrefɤ֤
      @cIMCode.add_element(@cTS.gc_obj_ref_fmp(nIndex))

      # ХꥢƱ
      @cIMCode.set_condition_level(IMC_CONDITION_SYNC)
      @cIMCode.add_element(@cTS.gc_barrier_sync(nIndex))

      # Υǥػ֤κʤ
      if (@cTS.exist_post_timetick(nIndex) == true)
        @cIMCode.add_element(@cTS.gc_tick_gain_fmp(nIndex))
      end

      # ξ֤˹ԤΥᥤ󥿥Υɤ֤
      @cIMCode.add_element(@cTS.gc_post_maintask_set(nIndex, @cTS.exist_post_timetick(nIndex)))
    end

    #================================================================
    #   : GCOVѤΥХ/λ롼Υɤ
    #         
    #================================================================
    def build_gcov_ini_ter_rtn()
      cElement = IMCodeElement.new(:common)
      # ñ(bootcnt0)
      cElement.set_proc_unit(FNC_GCOV_INI, TTG_MAIN_BOOTCNT)
      cElement.set_proc_unit(FNC_GCOV_TER, TTG_MAIN_BOOTCNT)

      # إå
      cElement.set_header(FNC_GCOV_INI, TSR_OBJ_INIRTN)
      cElement.set_header(FNC_GCOV_TER, TSR_OBJ_TERRTN)

      # եե
      cElement.set_config("#{API_ATT_INI}({#{KER_TA_NULL}, 0, #{FNC_GCOV_INI}});", IMC_NO_CLASS)
      cElement.set_config("#{API_ATT_TER}({#{KER_TA_NULL}, 0, #{FNC_GCOV_TER}});", IMC_NO_CLASS)

      # GCOVϢ
      hGcovIniRtn = {:id => FNC_GCOV_INI, :prcid => @cConf.get_main_prcid(), :bootcnt => TTG_MAIN_BOOTCNT}
      hGcovTerRtn = {:id => FNC_GCOV_TER, :prcid => @cConf.get_main_prcid(), :bootcnt => TTG_MAIN_BOOTCNT}
      cElement.set_code(hGcovIniRtn, FNC_GCOV_C_PAUSE)
      cElement.set_code(hGcovTerRtn, FNC_GCOV_C_RESUME)
      cElement.set_code(hGcovTerRtn, FNC_GCOV_C_DUMP)

      @cIMCode.add_element(cElement)
    end

    #================================================================
    #   : ƥȥ饤֥ѿѤΥХ롼
    #         Υɤ
    #================================================================
    def build_initialize_test_lib_ini_rtn()
      cElement = IMCodeElement.new(:common)
      # ñ(bootcnt0)
      cElement.set_proc_unit(FNC_TEST_LIB_INI, TTG_MAIN_BOOTCNT)

      # إå
      cElement.set_header(FNC_TEST_LIB_INI, TSR_OBJ_INIRTN)

      # եե
      cElement.set_config("#{API_ATT_INI}({#{KER_TA_NULL}, 0, #{FNC_TEST_LIB_INI}});", IMC_NO_CLASS)

      # ƥȥ饤֥ѿ
      hIniRtn = {:id => FNC_TEST_LIB_INI, :prcid => @cConf.get_main_prcid(), :bootcnt => TTG_MAIN_BOOTCNT}
      cElement.set_code(hIniRtn, FNC_INITIALIZE_TEST_LIB)

      @cIMCode.add_element(cElement)
    end

    #================================================================
    #   : FMPǤϥХ롼Ѥ뤿Ჿ⤷ʤ
    #================================================================
    def build_main_task_gcov_start()
    end

    #================================================================
    #   : FMPǤŬڤʥץåإᥤ󥿥ޥ졼
    #         Ƥߤȯ
    #================================================================
    def build_int_raise(cElement, snIntNo, nPrcid)
      check_class(IMCodeElement, cElement)    # 
      check_class([String, Integer], snIntNo) # ֹ
      check_class(Integer, nPrcid)            # ץåID

      nMainPrcid = @cConf.get_main_prcid()

      # ᥤ󥿥оIntHdr/ISRΥץåۤʤϥᥤ󥿥ư
      if (nMainPrcid != nPrcid)
        cElement.set_syscall(@cIMCode.hMainTask, "#{API_MIG_TSK}(#{TTG_TSK_SELF}, #{nPrcid})")
      end

      cElement.set_code(@cIMCode.hMainTask, "#{FNC_INT_RAISE}(#{snIntNo})")

      # dis_int򥵥ݡȤƤʤ硤ǥᥤץå
      if ((nMainPrcid != nPrcid) && (@cConf.get_api_support_dis_int() == false))
        cElement.set_syscall(@cIMCode.hMainTask, "#{API_MIG_TSK}(#{TTG_TSK_SELF}, #{nMainPrcid})")
      end
    end

    #================================================================
    #   : FMPǤŬڤʥץåإᥤ󥿥ޥ졼
    #         Ƥdis_int¹Ԥ
    #================================================================
    def build_dis_int(cElement, snIntNo, nPrcid)
      check_class(IMCodeElement, cElement)    # 
      check_class([String, Integer], snIntNo) # ֹ
      check_class(Integer, nPrcid)            # ץåID

      nMainPrcid = @cConf.get_main_prcid()

      cElement.set_syscall(@cIMCode.hMainTask, "#{API_DIS_INT}(#{snIntNo})")

      # Ǹɬᥤץå
      if (nMainPrcid != nPrcid)
        cElement.set_syscall(@cIMCode.hMainTask, "#{API_MIG_TSK}(#{TTG_TSK_SELF}, #{nMainPrcid})")
      end
    end

  end
end
