#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: HTMLBuilder.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "bin/builder/CodeBuilder.rb"
require "bin/product/HTMLCode.rb"

#ޥץåʬ顼ꥹ
DEEP_COLOR_LIST = ["#FFFFFF", "lightcoral", "steelblue", "aquamarine", "#FFFFD7"]
PALE_COLOR_LIST = ["#FFFFFF", "#FFE3E3", "#E3EEFF", "#E3FFE3", "#FFFFD7"]
# ϴؿƱȤϰʲ򥢥󥳥
# STDOUT.sync = true
module TTG

  #==================================================================
  # 饹̾: HTMLBuilder
  #   : ֥ɤѤHTMLե륯饹
  #==================================================================
  class HTMLBuilder < CodeBuilder
    include CommonModule

    #================================================================
    # : 󥹥ȥ饯
    #================================================================
    def initialize()
      @sHTMLCode  = ""   # HTMLϤʸŪݻ
      @@cHTMLCode = nil  # HTMLɤݻ
      @nRowSpan   = 0    # ǥιԿݻ
      @aProcUnits = []   # о줹ñ̤ݻ
      @sTestID    = ""   # ƥȥʥꥪID
      @cConf      = Config.new() # ե
    end


    #================================================================
    # : ֥ɤHTMLեƽϤ
    #================================================================
    def build(cIntermediateCode)
      check_class(IntermediateCode, cIntermediateCode) # ֥ɤΥ󥹥
      cnt = 0

      # إåɲ
      add_header()

      cIntermediateCode.aCode.each{ |hScenarioes|
        hScenarioes.each{ |sScenarioID, aScenario|
          if (sScenarioID == IMC_COMMON)
            next
          end

          @sTestID    = sScenarioID
          @aProcUnits = []
          @aScenario  = aScenario # ®Τ

          # о줹ñ̤ȴФ
          cIntermediateCode.hProcUnitInfo.each_key{ |sProcUnit|
            sScenarioIDLow = sScenarioID.downcase
            sProcUnitLow   = sProcUnit.downcase

            if (/\A#{sScenarioIDLow}/ =~ sProcUnitLow)
              @aProcUnits.push(sProcUnit.sub(@sTestID+"_", ""))
            end
          }
          @aProcUnits.sort!

          # ƥȥʥꥪȤɽɲ
          @sHTMLCode.concat(%Q[<font size = "6">#{@sTestID}</font><br>#{TTG_NL}])
          @sHTMLCode.concat("<table border=1>#{TTG_NL}")
          make_body()
          @sHTMLCode.concat("</table>#{TTG_NL}")
          @sHTMLCode.concat("<br>#{TTG_NL}")
        }
      }

      # եåɲ
      add_footer()

      # HTMLɤ
      @@cHTMLCode = HTMLCode.new(@sHTMLCode)
    end


    #================================================================
    # : إåΥɤɲä
    #================================================================
    def add_header()
      sHeader = <<-EOS
<html>
<head>
</head>
<body>
      EOS
      @sHTMLCode.concat(sHeader)

      # 顼ɲ
      if (@cConf.is_fmp?())
        1.upto(@cConf.get_prc_num()){ |prcid|
          @sHTMLCode.concat(%Q[<font style="font-size:24px; background-color:#{PALE_COLOR_LIST[prcid]}">ץå#{prcid}</font>#{TTG_NL}])
        }
        @sHTMLCode.concat("<br><br>#{TTG_NL}")
      end
    end


    #================================================================
    # : եåΥɤɲä
    #================================================================
    def add_footer()
      sFooter = <<-EOS
</body>
</html>
      EOS

      @sHTMLCode.concat(sFooter)
    end


    #================================================================
    # : ֥ɤHTMLɤʬ
    #================================================================
    def make_body()

      @aScenario.each{ |hCondition|
        hCondition.each{ |sCondition, aBlocks|
          if (aBlocks.empty?())
            # ConditionSyncФ
            next
          end

          # ǥ󤴤Ȥ˽ñ̹ԤͿ
          add_processing_units(sCondition)

          aBlocks.each{ |hBlocks|
            hBlocks.each{ |sBlock, aCodeInfo|
              @aCodeInfo = aCodeInfo # ®Τ
              # ֥åȤ˽
              add_lines()
            }
          @sHTMLCode.concat("#{TTG_NL}")
          }

          # ǺԤηԿ
          replace_rowspan(sCondition)
        }
      }
    end


    #================================================================
    # : ñ̹Ԥɲä
    #================================================================
    def add_processing_units(sConditionID)
      check_class(String, sConditionID) # ǥID

      @sHTMLCode.concat(%Q[<tr><th rowspan = "SPAN:#{sConditionID}">#{sConditionID}</th>])

      @aProcUnits.each{ |sProcUnit|
        @sHTMLCode.concat("#{TTG_NL}")
        @sHTMLCode.concat(%Q[<th bgcolor = "gainsboro">#{sProcUnit}</th>])
      }

      @sHTMLCode.concat("</tr>#{TTG_NL}")
    end


    #================================================================
    # : rowspan°֤
    #================================================================
    def replace_rowspan(sConditionID)
      @sHTMLCode = @sHTMLCode.sub("SPAN:#{sConditionID}", "#{@nRowSpan+1}")
      @nRowSpan = 0
    end


    #================================================================
    # : Ϳ줿ɾɲä
    #================================================================
    def add_lines()
      @aCodeInfo.each{|sObjID, sCode, nBootCnt, nPrcID, lAtr|
        nColumn = @aProcUnits.index(sObjID.sub(@sTestID+"_", "")) # 
        if (@cConf.is_fmp?())
          sColor  = PALE_COLOR_LIST[nPrcID]                       # 顼
        else
          sColor  = PALE_COLOR_LIST[1]
        end
        sCode   = sCode.sub(@sTestID+"_", "")                     # ϥ

        if (is_hidden?(lAtr))
          next
        end

        # Կ󥿡Υ󥯥
        @nRowSpan += 1

        @sHTMLCode.concat("#{TTG_TB}")
        @sHTMLCode.concat("<tr>")

        nColumnSize = @aProcUnits.size()
        nColumnSize.times{ |index|
          if (index == nColumn)
            @sHTMLCode.concat(%Q[<td bgcolor = "#{sColor}"> #{sCode} </td>])
          else
            @sHTMLCode.concat("<td></td>")
          end
        }

        @sHTMLCode.concat("</tr>#{TTG_NL}")
      }
    end


    #=================================================================
    #   : °򸫤ơɤɤȽǤ
    #=================================================================
    def is_hidden?(lAtr)
      check_class(Symbol, lAtr) # °

      return false  # [Bool]Ϥʤɤ
    end

    #=================================================================
    #   : 줿ɤե벽
    #=================================================================
    def output_code_file(cHTMLCode, sFileName)
      check_class(HTMLCode, cHTMLCode) # HTMLCodeΥ󥹥
      check_class(String, sFileName)   # ϻΥե̾

      cHTMLCode.output_code_file(sFileName)
    end

    #=================================================================
    #   : ɥ饹֤
    #=================================================================
    def get_result()
      return @@cHTMLCode  # [HTMLCode]ɥ饹
    end

  end
end
