#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2012 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: ProfileBuilder.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/CommonModule.rb"
require "common/bin/Config.rb"
require "common/bin/IMCodeElement.rb"
require "common/bin/test_scenario/TestScenario.rb"
require "bin/product/IntermediateCode.rb"

module TTG

  #==================================================================
  # 饹̾: ProfileBuilder
  #   : ASP / FMP BuilderΥѡ饹
  #==================================================================
  class ProfileBuilder
    include CommonModule

    #================================================================
    # : 󥹥ȥ饯
    #================================================================
    def initialize()
      # ֥ɤνƥȥʥꥪ̤ξɲä
      @cIMCode = IntermediateCode.new()

      @cConf = Config.new() # ե
    end

    #================================================================
    #   : ƥȥʥꥪ롼Υɤ
    #================================================================
    def build_ini_rtn(aIniRtn)
      check_class(Array, aIniRtn) # 롼󥯥饹

      # Х롼Ƭ˻äƤ
      aSortIniRtn = []
      aIniRtn.each{|cIniRtn|
        if (cIniRtn.hState[TSR_PRM_GLOBAL] == true)
          aSortIniRtn.push(cIniRtn)
        end
      }

      # Х롼ʳ
      aIniRtn.each{|cIniRtn|
        if (cIniRtn.hState[TSR_PRM_GLOBAL] != true)
          aSortIniRtn.push(cIniRtn)
        end
      }

      bFirstFlg = true
      aSortIniRtn.each{|cIniRtn|
        # 롼ñΤΥƥID
        @cIMCode.set_testid_level("#{IMC_TTG_INIRTN}_#{cIniRtn.sObjectID}")

        # 롼Υǥ٥
        @cIMCode.set_condition_level(TTG_LBL_INIRTN)

        # 롼ɬפʤ٤ƤΥ
        @cIMCode.add_element(cIniRtn.gc_ini_rtn(bFirstFlg))

        # ΤtrueȤ
        bFirstFlg = false
      }
    end

    #================================================================
    #   : ƥȥʥꥪ齪λ롼Υɤ
    #================================================================
    def build_ter_rtn(aTerRtn)
      check_class(Array, aTerRtn) # λ롼󥯥饹

      # Х뽪λ롼Ƭ˻äƤ
      aSortTerRtn = []
      aTerRtn.each{|cTerRtn|
        if (cTerRtn.hState[TSR_PRM_GLOBAL] == true)
          aSortTerRtn.push(cTerRtn)
        end
      }

      # Х뽪λ롼ʳ
      aTerRtn.each{|cTerRtn|
        if (cTerRtn.hState[TSR_PRM_GLOBAL] != true)
          aSortTerRtn.push(cTerRtn)
        end
      }

      aSortTerRtn.each{|cTerRtn|
        # λ롼ñΤΥƥID
        @cIMCode.set_testid_level("#{IMC_TTG_TERRTN}_#{cTerRtn.sObjectID}")

        # λ롼Υǥ٥
        @cIMCode.set_condition_level(TTG_LBL_TERRTN)

        # λ롼ɬפʥåݥȰʳΥ
        @cIMCode.add_element(cTerRtn.gc_ter_rtn_info())
      }

      # åݥȤսǽϤ
      aSortTerRtn.reverse.each{|cTerRtn|
        @cIMCode.add_element(cTerRtn.gc_ter_rtn_checkpoint())
      }

      # ǽνλ롼˥ƥȽλå(սǼ¹Ԥ뤿)
      @cIMCode.add_element(aSortTerRtn[0].gc_finish_message())
    end

    #================================================================
    #   : ƥȥʥꥪν롼̵֤ͭ
    #================================================================
    def exist_ini_rtn(cTestScenario)
      check_class(TestScenario, cTestScenario) # ƥȥʥꥪ饹

      return cTestScenario.exist_ini_rtn()  # [Bool]롼̵ͭ
    end

    #================================================================
    #   : ƥȥʥꥪνλ롼̵֤ͭ
    #================================================================
    def exist_ter_rtn(cTestScenario)
      check_class(TestScenario, cTestScenario) # ƥȥʥꥪ饹

      return cTestScenario.exist_ter_rtn()  # [Bool]λ롼̵ͭ
    end

    #================================================================
    #   : ƥȥʥꥪ֥ɤ
    #================================================================
    def build(cTestScenario, bPrevGainTime)
      check_class(TestScenario, cTestScenario) # ƥȥʥꥪ饹
      check_class(Bool, bPrevGainTime)         # Υƥȥʥꥪˤưե饰

      @cTS = cTestScenario.dup()
      @hTestMain = @cTS.get_main_task_proc() # ᥤ󥿥ID

      # ƥȥʥꥪϽ
      start_test_scenario(bPrevGainTime)

      # pre_condition
      build_pre_condition()

      # dopost_condition
      @cTS.get_do_post_index().each{|nIndex|
        # doν
        build_do(nIndex)

        # post_conditionν
        if (@cTS.check_lastpost_condition(nIndex) == true)
          build_lastpost_condition(nIndex)
        else
          build_post_condition(nIndex)
        end
      }
    end

    #================================================================
    # : ƥȥʥꥪϽ
    #================================================================
    def start_test_scenario(bPrevGainTime)
      check_class(Bool, bPrevGainTime)  # Υƥȥʥꥪˤưե饰

      hMainTask  = @cIMCode.hMainTask
      hCheckMain = @cIMCode.hCheckMain

      # Υƥȥʥꥪо줹ñ̤ɲ
      # ǽŪʵưƱ˹Ԥ
      cElement = IMCodeElement.new(:common)
      cElement.set_proc_unit(@hTestMain[:id], @hTestMain[:bootcnt])
      @cTS.get_proc_units(cElement)


      # Х/ѿɲ(ñ̤TSR_PRM_VARƤ)
      @cTS.gc_global_local_var(cElement)


      # ץȥɲ
      cElement.set_header(@hTestMain[:id], IMC_FUNC_TYPE)
      @cTS.gc_header(cElement)


      # ŪAPIɲ
      @cTS.gc_config(cElement)


      # ƥIDϤsyslog
      cElement.set_code(hMainTask, "#{TTG_NL}#{TTG_TB}syslog_0(LOG_NOTICE, \"#{@cTS.sTestID}: Start\")")


      # ư˴ؤѲ̵硤⤷ʤ
      if (@cTS.bGainTime == bPrevGainTime)
      # ֤ư(=ΥƥȥʥꥪǤϻ)֤ư
      elsif (@cTS.bGainTime == true)
        cElement.set_code(hMainTask, "#{FNC_START_TICK}()")
      # ֤ưʤ(=ΥƥȥʥꥪǤϻư)֤ߤ
      else
        cElement.set_code(hMainTask, "#{FNC_STOP_TICK}()")
      end


      # ACTIVATEǤߥϥɥ餬硤Хѿӥ󥯥
      if (@cTS.exist_int_hdr() == true)
        aIntHdrID = @cTS.get_activate_proc_unit_id(TSR_OBJ_INTHDR)
        aIntHdrID.each{|sObjectID|
          cElement.set_global_var("#{sObjectID}_#{VAR_BOOTCNT}", "enum ENUM_#{sObjectID}", "#{sObjectID}_#{TTG_ENUM_INVALID}")
          cElement.set_code(hMainTask, "#{sObjectID}_#{VAR_BOOTCNT}++")
        }
      end

      # ACTIVATEǤߥӥ롼󤬤硤Хѿӥ󥯥
      # (ߥӥ롼ξ硤1ĤΥХIPǤ褤)
      if (@cTS.exist_isr() == true)
        aIsrID = @cTS.get_activate_proc_unit_id(TSR_OBJ_ISR)
        if (!aIsrID.empty?())
          cElement.set_global_var("#{TTG_LBL_ISR}_#{VAR_BOOTCNT}", "enum ENUM_#{TTG_LBL_ISR}", "#{TTG_LBL_ISR}_#{TTG_ENUM_INVALID}")
          cElement.set_code(hMainTask, "#{TTG_LBL_ISR}_#{VAR_BOOTCNT}++")
        end
      end

      # ACTIVATEǤCPU㳰ϥɥ餬硤Хѿӥ󥯥
      if (@cTS.exist_exception() == true)
        aExcID = @cTS.get_activate_proc_unit_id(TSR_OBJ_EXCEPTION)
        aExcID.each{|sObjectID|
          cElement.set_global_var("#{sObjectID}_#{VAR_BOOTCNT}", "enum ENUM_#{sObjectID}", "#{sObjectID}_#{TTG_ENUM_INVALID}")
          cElement.set_code(hMainTask, "#{sObjectID}_#{VAR_BOOTCNT}++")
        }
      end


      # TA_STA°μϥɥ餬硤Хѿե饰򥻥åȡ
      if (@cTS.exist_cyclic_sta() == true)
        hCycle = @cTS.get_all_object_info(TSR_OBJ_CYCLE)
        hCycle.each{|sObjectID, hObjectInfo|
          if (hObjectInfo.hState[TSR_PRM_ATR] == KER_TA_STA)
            cElement.set_global_var("#{sObjectID}_flg", TYP_BOOL_T, false)
            cElement.set_code(hMainTask, "#{sObjectID}_flg = true")

            # оݼϥɥƬǼϥɥ餬ưʤ褦returnԤ
            cElement.set_pre_code(sObjectID, "if (#{sObjectID}_flg == false) {", false)
            cElement.set_pre_code(sObjectID, "#{TTG_TB}return")
            cElement.set_pre_code(sObjectID, "}", false)
          end
        }
      end


      # GCOVξ硤resume
      if (@cConf.enable_gcov?() && (@cTS.bGcovAll == true))
        cElement.set_code(hMainTask, FNC_GCOV_TTG_C_RESUME)
      end

      cElement.set_code(hMainTask, "#{@hTestMain[:id].downcase()}()")

      # GCOVξ硤pause
      if (@cConf.enable_gcov?() && (@cTS.bGcovAll == true))
        cElement.set_code(hMainTask, FNC_GCOV_TTG_C_PAUSE)
      end


      # ᥤ󥿥ξ֥å
      cElement.set_code(hMainTask, "#{hCheckMain[:id]}()")

      # ƥIDλsyslog
      cElement.set_code(hMainTask, "syslog_0(LOG_NOTICE, \"#{@cTS.sTestID}: OK\")")
      @cIMCode.add_element(cElement)

      # ƥID٥ɲä
      @cIMCode.set_testid_level(@cTS.sTestID)

      # ɬפʥåθĿ򥢥åץǡ
      @cIMCode.update_stack_size(@cTS.get_stack_num())
    end

    #================================================================
    # : checkfinishΥɤ
    #================================================================
    def build_finish_cp(bIsTerRtn)
      check_class(Bool, bIsTerRtn) # λ롼̵ͭե饰

      cElement = IMCodeElement.new(:common)

      # λ롼̵Сcheck_finish
      if (bIsTerRtn == false)
        # GCOVν
        if (@cConf.enable_gcov?() && @cConf.is_asp?())
          cElement.set_code(@cIMCode.hMainTask, "#{TTG_NL}#{TTG_TB}#{FNC_GCOV_C_RESUME}")
          cElement.set_code(@cIMCode.hMainTask, FNC_GCOV_C_DUMP)
        end
        cElement.set_checkfinish(@cIMCode.hMainTask)
      # λ롼󤬤Сcheck_point
      else
        cElement.set_checkpoint(@cIMCode.hMainTask)
        cElement.set_code(@cIMCode.hMainTask, "#{API_EXT_KER}()")
      end

      @cIMCode.add_element(cElement)
    end

    #================================================================
    #   : ؿͭñ̤νԤɤ
    #================================================================
    def build_shared_proc_unit(hSharedProcUnitInfo, sObjectType)
      check_class(Hash, hSharedProcUnitInfo) # ؿͭñ̤ξ
      check_class(String, sObjectType)       # оݤȤñ̥

      cElement = IMCodeElement.new()

      aEnaIntIntHdr = []

      # оݤȤñ̤ɬפʾ
      hSharedProcUnitInfo.sort.each{|aObjectInfo|
        # ñ̾ɲ
        cElement.set_proc_unit(aObjectInfo[0], aObjectInfo[1].hState[TSR_PRM_BOOTCNT])

        # ץȥɲ
        cElement.set_header(aObjectInfo[0], sObjectType)

        # ŪAPIɲ
        aObjectInfo[1].gc_config(cElement)

        # ߥϥɥϰΧƬǳ׵ե饰ꥢؿ(ϻ)¹Ԥ
        if (sObjectType == TSR_OBJ_INTHDR)
          cElement.set_pre_code(aObjectInfo[0], "#{FNC_I_BEGIN_INT}(#{aObjectInfo[1].hState[TSR_PRM_INTNO]})")
          # Ūʳ׵᥯ꥢ
          # (ġΥǥХФ׵Υꥢ/åȰ¸)
          cElement.set_pre_code(aObjectInfo[0], "#{FNC_CLEAR_INT_REQ}(#{aObjectInfo[1].hState[TSR_PRM_INTNO]})")

          # ߥϥɥϰΧƬǳ׵ե饰ꥢؿ(λ)¹Ԥ
          cElement.set_post_code(aObjectInfo[0], "#{FNC_I_END_INT}(#{aObjectInfo[1].hState[TSR_PRM_INTNO]})")

          # TA_ENAINT°γߥϥɥξǼƤ
          if (aObjectInfo[1].hState[TSR_PRM_ATR] == KER_TA_ENAINT)
            hProcUnitInfo = {:id => aObjectInfo[0], :prcid => aObjectInfo[1].hState[TSR_PRM_PRCID], :bootcnt => TTG_MAIN_BOOTCNT}
            aEnaIntIntHdr.push([hProcUnitInfo, aObjectInfo[0], aObjectInfo[1].hState[TSR_PRM_INTNO], aObjectInfo[1].hState[TSR_PRM_PRCID]])
          end
        # CPU㳰ϥɥϰΧƬǥեåؿ¹Ԥ
        elsif (sObjectType == TSR_OBJ_EXCEPTION)
          cElement.set_pre_code(aObjectInfo[0], "#{FNC_CPUEXC_HOOK}(#{aObjectInfo[1].hState[TSR_PRM_EXCNO]}, #{@cConf.get_exception_arg_name()})")
        end
      }

      @cIMCode.add_element(cElement)

      # TA_ENAINT°γߥϥɥ餬硤ƬǳߥϥɥεưǧԤdis_int
      aEnaIntIntHdr.each{|aIntHdr|
        cElementCommon = IMCodeElement.new(:common)
        cElementCommon.set_global_var("#{aIntHdr[1]}_#{VAR_BOOTCNT}", "enum ENUM_#{aIntHdr[1]}", "#{aIntHdr[1]}_#{TTG_ENUM_INVALID}")
        cElementCommon.set_code(@cIMCode.hMainTask, "#{TTG_NL}#{TTG_TB}#{aIntHdr[1]}_#{VAR_BOOTCNT}++")
        build_int_raise(cElementCommon, aIntHdr[2], aIntHdr[3])
        cElementCommon.set_syscall(@cIMCode.hMainTask, "#{API_SLP_TSK}()")
        if (@cConf.get_api_support_dis_int() == true)
          build_dis_int(cElementCommon, aIntHdr[2], aIntHdr[3])
        end
        cElementCommon.set_checkpoint(@cIMCode.hMainTask)
        @cIMCode.add_element(cElementCommon)

        @cIMCode.set_testid_level("#{TTG_LBL_CHK_ENAINT}")
        @cIMCode.set_condition_level("#{TTG_LBL_CHK_ENAINT}")
        cElementIntHdr = IMCodeElement.new()
        cElementIntHdr.set_syscall(aIntHdr[0], "#{API_IWUP_TSK}(#{TTG_MAIN_TASK})")
        @cIMCode.add_element(cElementIntHdr)
      }
    end

    #================================================================
    #   : ᥤ󥿥GCOV򳫻Ϥ
    #================================================================
    def build_main_task_gcov_start()
      # ֥饹ǥС饤ɤѤ
      abort(ERR_MSG % [__FILE__, __LINE__])
    end

    #================================================================
    #   : ᥤ󥿥ߤȯ
    #================================================================
    def build_int_raise()
      # ֥饹ǥС饤ɤѤ
      abort(ERR_MSG % [__FILE__, __LINE__])
    end

    #================================================================
    #   : ᥤ󥿥dis_int¹Ԥ
    #================================================================
    def build_dis_int()
      # ֥饹ǥС饤ɤѤ
      abort(ERR_MSG % [__FILE__, __LINE__])
    end

    #================================================================
    # : TA_STA°μϥɥstp_cycȯԤ륳ɤ
    #================================================================
    def build_stp_cyc(hCyclicStaInfo)
      check_class(Hash, hCyclicStaInfo) # TA_STA°μϥɥϥå

      cElement = IMCodeElement.new(:common)

      hCyclicStaInfo.each{|sObjectID, cObjectInfo|
        # ᥤ󥿥Ƭ°ǧȥϥɥ߽Ԥ
        cObjectInfo.gc_obj_ref_only_cyc(cElement, @cIMCode.hMainTask);
        cElement.set_syscall(@cIMCode.hMainTask, "#{API_STP_CYC}(#{sObjectID})")
        cElement.set_checkpoint(@cIMCode.hMainTask)
      }

      @cIMCode.add_element(cElement)
    end

    #================================================================
    # : TA_ENAINT°γߥӥ롼󤬳ĤƤ
    #         ֹФƵưǧѤγߥӥ롼
    #         ưdis_int
    #         (ߥϥɥbuild_shared_proc_unitǼ»)
    #================================================================
    def build_ena_int_isr(hEnaIntIsrInfo)
      check_class(Hash, hEnaIntIsrInfo) # TA_ENAINT°γߥӥ롼ξ

      aEnaIntIsr = []
      aChkIsr = []

      # оݤȤñ̤ɬפʾ
      hEnaIntIsrInfo.each{|sObjectID, cObjectInfo|
        # ƱֹϽ
        if (!aChkIsr.include?(cObjectInfo.hState[TSR_PRM_INTNO]))
          hTempObject = cObjectInfo.dup
          hTempObject.sObjectID = "#{TTG_LBL_ISR}_#{cObjectInfo.hState[TSR_PRM_INTNO]}_#{TTG_LBL_CHK_ENAINT}";
          hTempObject.hState[TSR_PRM_ISRPRI] = 1;
          aEnaIntIsr.push(hTempObject)
        end

        aChkIsr.push(cObjectInfo.hState[TSR_PRM_INTNO])
      }

      # ưǧѤγߥӥ롼Ͽưdis_int
      aEnaIntIsr.each{|cEnaIntIsr|
        cElementCommon = IMCodeElement.new(:common)
        cElementCommon.set_global_var("#{TTG_LBL_ISR}_#{VAR_BOOTCNT}", "enum ENUM_#{TTG_LBL_ISR}", "#{TTG_LBL_ISR}_#{TTG_ENUM_INVALID}")
        cElementCommon.set_code(@cIMCode.hMainTask, "#{TTG_NL}#{TTG_TB}#{TTG_LBL_ISR}_#{VAR_BOOTCNT}++")
        build_int_raise(cElementCommon, cEnaIntIsr.hState[TSR_PRM_INTNO], cEnaIntIsr.hState[TSR_PRM_PRCID])
        cElementCommon.set_syscall(@cIMCode.hMainTask, "#{API_SLP_TSK}()")
        if (@cConf.get_api_support_dis_int() == true)
          build_dis_int(cElementCommon, cEnaIntIsr.hState[TSR_PRM_INTNO], cEnaIntIsr.hState[TSR_PRM_PRCID])
        end
        cElementCommon.set_checkpoint(@cIMCode.hMainTask)
        @cIMCode.add_element(cElementCommon)

        @cIMCode.set_testid_level("#{cEnaIntIsr.hState[TSR_PRM_INTNO]}_#{TTG_LBL_CHK_ENAINT}")
        @cIMCode.set_condition_level("#{cEnaIntIsr.hState[TSR_PRM_INTNO]}_#{TTG_LBL_CHK_ENAINT}")
        cElementIntIsr = IMCodeElement.new()
        cElementIntIsr.set_proc_unit(cEnaIntIsr.sObjectID, cEnaIntIsr.hState[TSR_PRM_BOOTCNT])
        cElementIntIsr.set_header(cEnaIntIsr.sObjectID, TSR_OBJ_ISR)
        cEnaIntIsr.gc_config(cElementIntIsr)
        hProcUnitInfo = {:id => cEnaIntIsr.sObjectID, :prcid => cEnaIntIsr.hState[TSR_PRM_PRCID], :bootcnt => TTG_MAIN_BOOTCNT}
        cElementIntIsr.set_syscall(hProcUnitInfo, "#{API_IWUP_TSK}(#{TTG_MAIN_TASK})")
        @cIMCode.add_element(cElementIntIsr)
      }

    end

    #================================================================
    # : ᥤ󥿥Ƭcp_stateå륳ɤ
    #================================================================
    def build_check_cp_state()
      cElement = IMCodeElement.new(:common)

      cElement.set_local_var(@cIMCode.hMainTask[:id], VAR_STATE, TYP_BOOL_T)
      cElement.set_code(@cIMCode.hMainTask, "#{TTG_NL}#{TTG_TB}#{VAR_STATE} = #{FNC_GET_CP_STATE}()")
      cElement.set_code(@cIMCode.hMainTask, "if (#{VAR_STATE} == false) {", false)
      cElement.set_indent(1)
      cElement.set_code(@cIMCode.hMainTask, "#{API_EXT_KER}()")
      cElement.unset_indent()
      cElement.set_code(@cIMCode.hMainTask, "}")

      @cIMCode.add_element(cElement)
    end

    #================================================================
    # : ᥤ󥿥ƬǳƽԤɤ
    #================================================================
    def build_initialize()
      cElement = IMCodeElement.new(:common)

      # ƥȥ饤֥ѿ
      cElement.set_code(@cIMCode.hMainTask, FNC_INITIALIZE_TEST_LIB)

      @cIMCode.add_element(cElement)
    end

    #================================================================
    # : ֥ɤ֤
    #================================================================
    def get_result()
      return @cIMCode  # [IntermediateCode]֥
    end

  end
end
