#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Do_PostCondition.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: Do_PostCondition
  #     : dopost_conditionξ륯饹
  #===================================================================
  class Do_PostCondition < Condition

    #=================================================================
    #   : DoνIMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_do_fmp(aPrevObjectInfo)
      check_class(Array, aPrevObjectInfo)  # ΥǥΥ֥Ⱦ

      cElement        = IMCodeElement.new()
      cCallObjectInfo = nil
      # id˵ܤIDȰפƤñ̤
      aPrevObjectInfo.each{ |cObjectInfo|
        if (!cObjectInfo.nil?())
          if (cObjectInfo.sObjectID == @hDo[TSR_PRM_ID])
            cCallObjectInfo = cObjectInfo
          end
        end
      }
      if (cCallObjectInfo.nil?())
        abort(ERR_MSG % [__FILE__, __LINE__])
      end

      hProcUnitInfo = get_proc_unit_info(cCallObjectInfo)

      # Ƚ
      cElement.set_comment(hProcUnitInfo, "#{TSR_UNS_DO}#{@nSeqNum}_#{@nTimeTick}")
      # GCOVγϤ⤷ϺƳ
      gc_gcov_resume(cElement, hProcUnitInfo)
      # оݤνñ̤󥿥Ʊʤ
      # resume/pauseνƱΤΥåݥȤȯԤƤ
      if (@cConf.enable_gcov?() && @hDo[TSR_PRM_GCOV] == true)
        cElement.set_checkpoint(hProcUnitInfo)
      end

      # syscall
      bIsReturn = true
      if (@hDo.has_key?(TSR_PRM_SYSCALL))
        if (@hDo.has_key?(TSR_PRM_ERCD))
          cElement.set_syscall(hProcUnitInfo, @hDo[TSR_PRM_SYSCALL], @hDo[TSR_PRM_ERCD])
        elsif (@hDo.has_key?(TSR_PRM_ERUINT))
          cElement.set_syscall(hProcUnitInfo, @hDo[TSR_PRM_SYSCALL], @hDo[TSR_PRM_ERUINT], TYP_ER_UINT)
        elsif (@hDo.has_key?(TSR_PRM_BOOL))
          cElement.set_syscall(hProcUnitInfo, @hDo[TSR_PRM_SYSCALL], @hDo[TSR_PRM_BOOL], TYP_BOOL_T)
        else
          cElement.set_syscall(hProcUnitInfo, @hDo[TSR_PRM_SYSCALL], nil)
          bIsReturn = false
        end
      else
        # "#"Ϥޤ륳ɤϥߥͿʤ
        bSemicolon = true
        if (@hDo[TSR_PRM_CODE] =~ /^\#.*/)
          bSemicolon = false
        end
        cElement.set_code(hProcUnitInfo, @hDo[TSR_PRM_CODE], bSemicolon)
        bIsReturn = false
      end

      # GCOV
      # ͤ硤¹Ծ֤ˤʤ뤿APIȯԤñ̤ǹԤ
      @nGcovAfterSyncFlg = false
      if (bIsReturn == true)
        gc_gcov_pause(cElement, hProcUnitInfo)
      # resumeȯԤץå˼ΥǥǼ¹νñ̤
      # νñ̤GCOVǤ
      elsif (!@aActivate[hProcUnitInfo[:prcid]].nil?() || !@aRunning[hProcUnitInfo[:prcid]].nil?())
        gc_gcov_pause(cElement, get_proc_unit_info(@aActivate[hProcUnitInfo[:prcid]], @aRunning[hProcUnitInfo[:prcid]]))
      else
        # ̵ͤ¹Ծ֤νñ̤⤤ʤ硤Ʊθ˥ᥤץåǼ¹νñ̤Ԥ
        # оݤνñ̤󥿥Ʊʤ
        # resume/pauseνƱΤΥåݥԤȤƤ
        if (@cConf.enable_gcov?() && @hDo[TSR_PRM_GCOV] == true)
          cElement.set_wait_check_sync(get_proc_unit_info(@cActivate, @cRunning), hProcUnitInfo[:prcid])
          # Ʊpauseɬפ뤫ݻƤ
          @nGcovAfterSyncFlg = true
        end
      end

      return cElement  # [IMCodeElement]Doν
    end

    #=================================================================
    #   : Ʊgcov_pauseѥɤ֤
    #=================================================================
    def gc_gcov_pause_after_sync()
      cElement = IMCodeElement.new()

      # pause¹ԤƤʤ硤ƱθǼ¹νñ̤Ԥ
      if (@nGcovAfterSyncFlg == true)
        gc_gcov_pause(cElement, get_proc_unit_info(@cActivate, @cRunning))
      end

      return cElement  # [IMCodeElement]Ʊgcov_pauseѥ
    end

    #=================================================================
    #   : ǥѥåػ߾֤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_lastpost_ena_dsp_fmp()
      cElement      = IMCodeElement.new()
      @aPrcid.each{ |nPrcid|
        # checkͤƹԤ
        if (!@aCpuState[nPrcid].nil?() && !@aCpuState[nPrcid].hState[TSR_PRM_DISDSP].nil?() && (@aCpuState[nPrcid].hState[TSR_PRM_DISDSP] == true))
          hProcUnitInfo = get_proc_unit_info(@aRunning[nPrcid])
          cElement.set_syscall(hProcUnitInfo, "#{API_ENA_DSP}()")
        end
      }

      return cElement  # [IMCodeElement]ǥѥåػ߾֤
    end

    #=================================================================
    #   : ͥ٥ޥ
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_lastpost_set_ini_ipm_fmp()
      cElement      = IMCodeElement.new()
      @aPrcid.each{ |nPrcid|
        # checkͤƹԤ
        if (!@aCpuState[nPrcid].nil?() && !@aCpuState[nPrcid].hState[TSR_PRM_CHGIPM].nil?() && 
            (@aCpuState[nPrcid].hState[TSR_PRM_CHGIPM] != 0) && (@aCpuState[nPrcid].hState[TSR_PRM_CHGIPM] != KER_TIPM_ENAALL))
          hProcUnitInfo = get_proc_unit_info(@aRunning[nPrcid])
          cElement.set_syscall(hProcUnitInfo, "#{API_CHG_IPM}(#{KER_TIPM_ENAALL})")
        end
      }

      return cElement  # [IMCodeElement]ͥ٥ޥ
    end

    #=================================================================
    #   : ԥåν
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_lastpost_spin_unl_fmp()
      cElement = IMCodeElement.new()

      @hAllObject.each{|sObjectID, cObjectInfo|
        if ((cObjectInfo.sObjectType == TSR_OBJ_SPINLOCK) && (cObjectInfo.hState[TSR_PRM_SPNSTAT] == TSR_STT_TSPN_LOC))
          cObject = get_object_info(cObjectInfo.hState[TSR_PRM_PROCID])
          hProcUnitInfo = get_proc_unit_info(cObject)
          if (GRP_NON_CONTEXT.include?(cObject.sObjectType))
            cElement.set_syscall(hProcUnitInfo, "#{API_IUNL_SPN}(#{sObjectID})")
          else
            cElement.set_syscall(hProcUnitInfo, "#{API_UNL_SPN}(#{sObjectID})")
          end

          # CPUåʣƼ¹ԤʤᡤݻƤ
          @aSpinProcID.push(cObject.sObjectID)
        end
      }

      return cElement  # [IMCodeElement]ԥåν
    end

    #=================================================================
    #   : CPUå֤βν
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_lastpost_cpu_unl_fmp()
      cElement = IMCodeElement.new()
      @aPrcid.each{ |nPrcid|
        # checkͤƹԤ
        unless (@aCpuState[nPrcid].nil?() || @aCpuState[nPrcid].hState[TSR_PRM_LOCCPU].nil?() || (@aCpuState[nPrcid].hState[TSR_PRM_LOCCPU] != true))
          hProcUnitInfo = get_proc_unit_info(@aActivate[nPrcid], @aRunning[nPrcid])
          # ԥåˤCPUåϽ
          if (!@aSpinProcID.include?(hProcUnitInfo[:id]))
            if (!@aActivate[nPrcid].nil?())
              cElement.set_syscall(hProcUnitInfo, "#{API_IUNL_CPU}()")
            else
              cElement.set_syscall(hProcUnitInfo, "#{API_UNL_CPU}()")
            end
          end
        end
      }

      return cElement  # [IMCodeElement]CPUå֤βν
    end

    #=================================================================
    #   : ưλ륳ɤ
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_lastpost_all_task_ter_fmp()
      # ¾¸ߤ硤٤ter_tsk()
      cElement = IMCodeElement.new()

      hProcUnitInfo = get_proc_unit_info()
      nMainPrcid = @sMainPrcid

      # ᥤ󥿥ץꥨץȤ뤳Ȥɤ
      # ¹Բǽ֤ΥԤ֤ˤƤ
      @aTask.each{|nPrcid, sObjectID, cObjectInfo|
        if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_RDY)
          cElement.set_syscall(hProcUnitInfo, "#{API_SUS_TSK}(#{sObjectID})")
        end
      }
      # ¹Ծ֤ΥԤ֤ˤƤ
      @aTask.each{|nPrcid, sObjectID, cObjectInfo|
        if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_RUN)
          cElement.set_syscall(hProcUnitInfo, "#{API_SUS_TSK}(#{sObjectID})")
        end
      }

      # ԤˤޤԤ
      # ¹Ծ֤ͥ٤⤤θơ¹Բǽ֤ΥԤ
      cElement.set_checkpoint(get_proc_unit_info())
      @aTask.each{|nPrcid, sObjectID, cObjectInfo|
        if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_RDY || KER_TTS_RUN || KER_TTS_RUS)
          cElement.set_wait_finish_sync(get_proc_unit_info(cObjectInfo))
        end
      }

      @aTask.each{|nPrcid, sObjectID, cObjectInfo|
        # ᥤ󥿥оݥΥץåۤʤϥᥤ󥿥ư
        if (nMainPrcid != nPrcid)
          cElement.set_syscall(hProcUnitInfo, "#{API_MIG_TSK}(#{TTG_TSK_SELF}, #{nPrcid})")
          nMainPrcid = nPrcid
        end

        if (cObjectInfo.hState[TSR_PRM_STATE] != KER_TTS_DMT)
          cElement.set_syscall(hProcUnitInfo, "#{API_TER_TSK}(#{sObjectID})")
        end
      }
      # Ǹɬᥤץå
      if (nMainPrcid != @sMainPrcid)
        cElement.set_syscall(hProcUnitInfo, "#{API_MIG_TSK}(#{TTG_TSK_SELF}, #{@sMainPrcid})")
      end
      cElement.set_checkpoint(hProcUnitInfo)

      return cElement  # [IMCodeElement]ưλ륳
    end

    #=================================================================
    #   : Ǹrefλޤ¾ץåθߤƤ
    #         Ʊ
    #=================================================================
    def gc_last_running_sync()
      cElement = IMCodeElement.new()

      # ¹Ծ֤νñ̼
      aActivateRunningProc = get_actvate_running_fmp()
      bFlg = false

      # ¹Ծ֤νñ¦ref
      # ¾ץåνñ̤ΥåݥȤԤ
      aActivateRunningProc.each{|cObjectInfo|
        if (!cObjectInfo.nil?() && (cObjectInfo.hState[TSR_PRM_PRCID] != @sMainPrcid))
          cElement.set_checkpoint(get_proc_unit_info(cObjectInfo))
          cElement.set_wait_check_sync(get_proc_unit_info(@cActivate, @cRunning), cObjectInfo.hState[TSR_PRM_PRCID])
          bFlg = true
        end
      }

      # ¾ץåνñ̤ԤåݥȤ
      cElement.set_checkpoint(get_proc_unit_info(@cActivate, @cRunning))

      aActivateRunningProc.each{|cObjectInfo|
        if (!cObjectInfo.nil?() && (cObjectInfo.hState[TSR_PRM_PRCID] != @sMainPrcid))
          cElement.set_comment(get_proc_unit_info(cObjectInfo), "LastRunningSync")
          cElement.set_wait_check_sync(get_proc_unit_info(cObjectInfo), @sMainPrcid)
          bFlg = true
        end
      }

      if (bFlg == false)
        return nil       # [nil]ɲäɬפʤ
      else
        return cElement  # [IMCodeElement]LastRunningSync
      end
    end

    #=================================================================
    #   : տޤʤǥѥåɤᡤ¹Բǽ֤Υ
    #         Ԥܤ륳ɤ֤
    #=================================================================
    def gc_lastpost_ready_sleep_fmp()
      cElement = IMCodeElement.new()

      @aPrcid.each{|nPrcid|
        if ((@aActivate[nPrcid] != nil) || (!@aCpuState[nPrcid].nil?() &&
            ((@aCpuState[nPrcid].hState[TSR_PRM_LOCCPU] == true) || (@aCpuState[nPrcid].hState[TSR_PRM_DISDSP] == true) ||
            ((@aCpuState[nPrcid].hState[TSR_PRM_CHGIPM] != 0) && (@aCpuState[nPrcid].hState[TSR_PRM_CHGIPM] != KER_TIPM_ENAALL)))))
           @hTask.each{|sObjectID, cObjectInfo|
             if ((cObjectInfo.hState[TSR_PRM_PRCID] == nPrcid) && (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_RDY))
               hProcUnitInfo = get_proc_unit_info(cObjectInfo)
               cElement.set_syscall(hProcUnitInfo, "#{API_SLP_TSK}()")
             end
           }
        end
      }

      return cElement  # [IMCodeElement]Ԥܥ
    end

    #=================================================================
    #   : ԥåԤΤٱ륳ɤ֤
    #=================================================================
    def gc_delay_wait_spin_fmp(lPrevMainTaskState)
      check_class(Symbol, lPrevMainTaskState)   # ֤Υᥤ󥿥ξ

      cElement = IMCodeElement.new()

      # ᥤ󥿥ξ֤ϤΤޤޤȤ
      @lMainTaskState = lPrevMainTaskState

      # ԥåԤνñ̾
      # (ʣ¸ߤϤɤ줫ٱ䤵Ф褤)
      cWaitProcUnit = nil
      @aActivate.each{|cActivate|
        if (!cActivate.nil?() && (cActivate.hState[TSR_PRM_HDLSTAT] == TSR_STT_A_WAITSPN))
          cWaitProcUnit = cActivate
          break
        end
      }
      @aRunning.each{|cRunning|
        if (!cRunning.nil?() &&
          ((cRunning.hState[TSR_PRM_STATE] == TSR_STT_R_WAITSPN) || (cRunning.hState[TSR_PRM_HDLSTAT] == TSR_STT_A_WAITSPN)))
          cWaitProcUnit = cRunning
          break
        end
      }

      # ԥåԤоݤΥԥå
      cSpinlockInfo = get_object_info(cWaitProcUnit.hState[TSR_PRM_SPINID])

      # оݤΥԥåƤñ̾
      cSpinlockProcUnit = get_proc_unit_info(get_object_info(cSpinlockInfo.hState[TSR_PRM_PROCID]))

      # ԥåƤñ̤ˤٱ¹
      cElement.set_delay_loop(cSpinlockProcUnit)

      return cElement  # [IMCodeElement]ԥåԤΤٱ륳
    end

    #=================================================================
    #   : ػ߾֤γߤꤹ륳ɤ֤
    #=================================================================
    def gc_lastpost_interrupt_dis_fmp()
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      # dis_intɬפΤֹ
      aDisIntNoID = []
      @hAllObject.each{|sObjectID, cObjectInfo|
        if ((GRP_INTERRUPT.include?(cObjectInfo.sObjectType) == true) && (cObjectInfo.hState[TSR_PRM_STATE] == KER_TA_ENAINT))
          aDisIntNoID.push([cObjectInfo.hState[TSR_PRM_INTNO], cObjectInfo.hState[TSR_PRM_PRCID]])
        end
      }

      # ʣƤ٤dis_int¹Ԥ
      nMainPrcid = @sMainPrcid
      aDisIntNoID.uniq!()
      aDisIntNoID.each{|snIntNoID|
        # ᥤ󥿥оIntHdr/ISRΥץåۤʤϥᥤ󥿥ư
        if (nMainPrcid != snIntNoID[1])
          cElement.set_syscall(hMainTaskInfo, "#{API_MIG_TSK}(#{TTG_TSK_SELF}, #{snIntNoID[1]})")
          nMainPrcid = snIntNoID[1]
        end

        cElement.set_syscall(hMainTaskInfo, "#{API_DIS_INT}(#{snIntNoID[0]})")
      }

      # Ǹɬᥤץå
      if (nMainPrcid != @sMainPrcid)
        cElement.set_syscall(hMainTaskInfo, "#{API_MIG_TSK}(#{TTG_TSK_SELF}, #{@sMainPrcid})")
      end

      cElement.set_checkpoint(hMainTaskInfo)

      return cElement  # [IMCodeElement]ػ߾֤γߤꤹ륳
    end

    #=================================================================
    #   : ԥåԤ֤νñ̵̤ͭǧ֤
    #=================================================================
    def exist_wait_spinlock_fmp()
      @aActivate.each{|cActivate|
        if (!cActivate.nil?() && (cActivate.hState[TSR_PRM_HDLSTAT] == TSR_STT_A_WAITSPN))
          return true  # [Bool]ԥåԤ֤νñ̤
        end
      }

      @aRunning.each{|cRunning|
        if (!cRunning.nil?() &&
          ((cRunning.hState[TSR_PRM_STATE] == TSR_STT_R_WAITSPN) || (cRunning.hState[TSR_PRM_HDLSTAT] == TSR_STT_A_WAITSPN)))
          return true  # [Bool]ԥåԤ֤νñ̤
        end
      }

      return false  # [Bool]ԥåԤ֤νñ̤ʤ
    end
  end
end
