#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2012 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: IMCodeElement.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/CommonModule.rb"
require "common/bin/Config.rb"

module CommonModule

  #==================================================================
  # 饹̾: IMCodeElement
  #   : IntermediateCodeǤ֥ɤǤǼ
  #           륯饹
  #==================================================================
  class IMCodeElement
    include CommonModule

    #================================================================
    # : 󥹥ȥ饯
    #         ꤷפΥȤ
    #================================================================
    def initialize(lMode = :block)
      check_class(Symbol, lMode) # ɤBlock뤫뤫ʥǥե :block

      @aElement = []           # Ǥݻ
      @cConf    = Config.new() # ե

      # ⡼ɤ
      if (lMode == :block || :common)
        @lMode = lMode
      else
        abort(ERR_MSG % [__FILE__, __LINE__])
      end

    end
    attr_reader :aElement, :lMode


    #================================================================
    # : APIƤӽФͤΥåԤɤǤݻ
    #================================================================
    def set_syscall(hProcUnitInfo, sSyscall, snbReturn = "E_OK", sVarType = TYP_ER)
      check_class(Hash, hProcUnitInfo)                       # ɤɲäñ̾
      check_class(String, sSyscall)                          # ɲäAPI
      check_class([String, Integer, *Bool], snbReturn, true) # ꤵ͡ʥǥե E_OK
      check_class(String, sVarType)                          # ꤵͤηʥǥե TYP_ER

      # ѿ̾
      sVarName = GRP_VAR_TYPE[sVarType]

      # ͤΥåԤ
      if (!snbReturn.nil?())
        @aElement.push({:atr => :api, :proc_unit => hProcUnitInfo, :syscall => sSyscall, :var => sVarName})
        set_local_var(hProcUnitInfo[:id], sVarName, sVarType)

        # ͤηTYP_ERTYP_ER_UINTξcheck_ercd
        if (sVarType != TYP_BOOL_T)
          @aElement.push({:atr => :ercd, :proc_unit => hProcUnitInfo, :ret => snbReturn, :var => sVarName})
        # ͤηTYP_BOOL_Tξassert
        else
          set_assert(hProcUnitInfo, sVarName, snbReturn)
        end

      # ͤΥåԤʤ
      else
        # ƤӽФ¦Ǹ̤˥åƤȤ뤿
        set_local_var(hProcUnitInfo[:id], sVarName, sVarType)
        @aElement.push({:atr => :api, :proc_unit => hProcUnitInfo, :syscall => sSyscall, :var => sVarName})
      end
    end


    #================================================================
    # : assertåԤɤǤݻ
    #================================================================
    def set_assert(hProcUnitInfo, sVar, snbValue)
      check_class(Hash, hProcUnitInfo)                # ɤɲäñ̾
      check_class(String, sVar)                       # assertˤäƳǧѿ
      check_class([String, Integer, *Bool], snbValue) # assertˤäƳǧ

      @aElement.push({:atr => :assert, :proc_unit => hProcUnitInfo, :var => sVar, :value => snbValue})
    end


    #================================================================
    # : Ϳʸ򤽤Τޤ޽ϤǤݻ롥
    #         ؿƤӽФִϢȯCPU㳰ȯsyslog
    #         ʤɤΥɤɲäǤѤ
    #================================================================
    def set_code(hProcUnitInfo, sEvalCode, bExpression = true)
      check_class(Hash, hProcUnitInfo) # ɤɲäñ̾
      check_class(String, sEvalCode)   # Ϥ
      check_class(Bool, bExpression)   # ɤǤ뤫ɤʥǥեȡtrue

      if (bExpression == true)
        # ξϽʸ˥ߥͿ
        sEvalCodeSemicolon = sEvalCode + ";"
        @aElement.push({:atr => :expression, :proc_unit => hProcUnitInfo, :code => sEvalCodeSemicolon})
      else
        # ʸξϤΤޤ޳Ǽ
        @aElement.push({:atr => :statement,  :proc_unit => hProcUnitInfo, :code => sEvalCode})
      end
    end


    #================================================================
    # : åݥȤ륳ɤǤݻ
    #================================================================
    def set_checkpoint(hProcUnitInfo)
      check_class(Hash, hProcUnitInfo) # åݥȤɲäñ̾

      if (@cConf.is_asp?())
        @aElement.push({:atr => :check,    :proc_unit => hProcUnitInfo})
      elsif (@cConf.is_fmp?())
        @aElement.push({:atr => :check_mp, :proc_unit => hProcUnitInfo})
      else
        abort(ERR_MSG % [__FILE__, __LINE__])
      end
    end


    #================================================================
    # : åݥȤ륳ɤǤݻ
    #================================================================
    def set_checkpoint_zero(hProcUnitInfo)
      check_class(Hash, hProcUnitInfo) # åݥȤɲäñ̾

      if (@cConf.is_asp?())
        @aElement.push({:atr => :check_zero,    :proc_unit => hProcUnitInfo})
      else
        abort(ERR_MSG % [__FILE__, __LINE__])
      end
    end


    #================================================================
    # : åݥȤԤĥɤǤݻ
    #================================================================
    def wait_checkpoint(hProcUnitInfo)
      check_class(Hash, hProcUnitInfo) # åݥȤԤĽñ̾

      unless (@cConf.is_asp?())
        abort(ERR_MSG % [__FILE__, __LINE__])
      end

      @aElement.push({:atr => :wait, :proc_unit => hProcUnitInfo})
    end


    #================================================================
    # : ǽåݥȤ륳ɤǤݻ
    #================================================================
    def set_checkfinish(hProcUnitInfo)
      check_class(Hash, hProcUnitInfo) # åݥȤɲäñ̾

      if (@cConf.is_asp?())
        @aElement.push({:atr => :check_finish,    :proc_unit => hProcUnitInfo})
      elsif (@cConf.is_fmp?())
        @aElement.push({:atr => :check_finish_mp, :proc_unit => hProcUnitInfo})
      else
        abort(ERR_MSG % [__FILE__, __LINE__])
      end
    end


    #================================================================
    # : WaitCheckSyncԤɤǤݻ
    #================================================================
    def set_wait_check_sync(hProcUnitInfo, nPrcid)
      check_class(Hash, hProcUnitInfo) # waitCPɲäñ̾
      check_class(Integer, nPrcid)     # ԤоݤΥץåID

      unless (@cConf.is_fmp?())
        abort(ERR_MSG % [__FILE__, __LINE__])
      end

      @aElement.push({:atr => :waitcp, :proc_unit => hProcUnitInfo, :prcid => nPrcid})
    end


    #================================================================
    # : StateSyncԤɤǤݻ
    #================================================================
    def set_state_sync(hProcUnitInfo, sTargetTask, sTargetState)
      check_class(Hash, hProcUnitInfo)    # waitCPɲäñ̾
      check_class(String, sTargetTask)    # ԤоݥID
      check_class(String, sTargetState)   # Ԥоݾ

      unless (@cConf.is_fmp?())
        abort(ERR_MSG % [__FILE__, __LINE__])
      end

      set_code(hProcUnitInfo, "#{FNC_STATE_SYNC}(\"#{hProcUnitInfo[:id]}\", \"#{sTargetTask}\", #{sTargetTask}, \"#{sTargetState}\", #{sTargetState})")
    end


    #================================================================
    # : WaitFinishSyncԤɤǤݻ
    #================================================================
    def set_wait_finish_sync(hProcUnitInfo)
      check_class(Hash, hProcUnitInfo)  # WaitFinishSyncɲäñ̾

      unless (@cConf.is_fmp?())
        abort(ERR_MSG % [__FILE__, __LINE__])
      end

      set_code(hProcUnitInfo, "#{FNC_WAIT_FINISH_SYNC}(\"#{hProcUnitInfo[:id]}\")")
    end


    #================================================================
    # : ᥤ󥿥ͥ٤TTG_MAIN_PRIǤʤ
    #         chg_pri򤹤륳ɤcElementꤹ
    #================================================================
    def set_chg_pri_main_task(hProcUnitInfo)
      check_class(Hash, hProcUnitInfo)  # chg_pri_main_taskɲäñ̾

      @aElement.push({:atr => :chg_pri_main_task})
      set_code(hProcUnitInfo, "#{FNC_CHG_PRI_MAIN_TASK}()")
    end


    #================================================================
    # : BarrierSyncԤɤǤݻ
    #================================================================
    def set_barrier_sync(aProcUnitInfo)
      check_class(Array, aProcUnitInfo) # ХꥢƱɲäñ̾

      unless (@cConf.is_fmp?())
        abort(ERR_MSG % [__FILE__, __LINE__])
      end

      aProcUnitInfo.each{ |hProcUnitInfo|
        @aElement.push({:atr => :barrier, :proc_unit => hProcUnitInfo, :num => aProcUnitInfo.size})
      }
    end


    #================================================================
    # : dormantΥФޥ졼ȽԤɤ
    #         Ǥݻ
    #================================================================
    def set_migrate_task(hMainTaskInfo, sTargetTask, nTargetPrcid)
      check_class(Hash, hMainTaskInfo)    # ᥤ󥿥νñ̾
      check_class(String, sTargetTask)    # ԤоݥID
      check_class(Integer, nTargetPrcid)  # ޥ졼ȤץåID

      unless (@cConf.is_fmp?())
        abort(ERR_MSG % [__FILE__, __LINE__])
      end

      @aElement.push({:atr => :migrate_func})
      set_code(hMainTaskInfo, "#{FNC_MIGRATE_TASK}(#{sTargetTask}, #{nTargetPrcid})")
    end


    #================================================================
    # : ٱԤɤǤݻ
    #================================================================
    def set_delay_loop(hProcUnitInfo)
      check_class(Hash, hProcUnitInfo)  # ٱԤñ̾

      set_comment(hProcUnitInfo, CMT_WAIT_SPIN_LOOP)
      set_local_var(hProcUnitInfo[:id], "i", VAR_VOLATILE_ULONG_T)
      set_code(hProcUnitInfo, "for (i = 0; i < #{@cConf.get_wait_spin_loop()}; i++)")
    end


    #================================================================
    # : ñ̾ȺǽŪʵưݻ
    #================================================================
    def set_proc_unit(sProcUnitID, nFinalBootCnt = 0)
      check_class(String, sProcUnitID)    # ɲäñID
      check_class(Integer, nFinalBootCnt) # ǽŪʵư

      @aElement.push({:atr => :proc_unit, :proc_unit_id => sProcUnitID, :fbootcnt => nFinalBootCnt})
    end


    #================================================================
    # : ѿɤǤݻ
    #================================================================
    def set_local_var(sProcUnitID, sVarName, sVarType, snVarValue = nil)
      check_class(String, sProcUnitID)                 # ȤɲäñID
      check_class(String, sVarName)                    # ѿ̾
      check_class(String, sVarType)                    # ѿη
      check_class([String, Integer], snVarValue, true) # ѿν

      @aElement.push({:atr => :localvar, :proc_unit_id => sProcUnitID, :name => sVarName, :type => sVarType, :value => snVarValue})
    end


    #================================================================
    # : ХѿɤǤݻ
    #================================================================
    def set_global_var(sVarName, sVarType, snVarValue = nil)
      check_class(String, sVarName)                           # ѿ̾
      check_class(String, sVarType)                           # ѿη
      check_class([String, Integer, *Bool], snVarValue, true) # ѿν

      @aElement.push({:atr => :globalvar, :name => sVarName, :type => sVarType, :value => snVarValue})
    end


    #================================================================
    # : ץȥɤǤݻ
    #================================================================
    def set_header(sProcUnitID, sObjectType, aFuncArgs = nil)
      check_class(String, sProcUnitID)    # ץȥɲäñ
      check_class(String, sObjectType)    # ñ̤Υ֥ȥסʴؿξIMC_FUNC_TYPE
      check_class(Array, aFuncArgs, true) # ʴؿξΤߡ

      @aElement.push({:atr => :header, :proc_unit_id => sProcUnitID, :type => sObjectType, :args => aFuncArgs})
    end


    #================================================================
    # : ŪAPIǤݻ
    #================================================================
    def set_config(sCode, sClass = nil)
      check_class(String, sCode)        # ɲäŪAPI
      check_class(String, sClass, true) # ɲäоݥ饹(ǥե nil)

      @aElement.push({:atr => :config, :code => sCode, :class => sClass})
    end


    #================================================================
    # : ȥɤǤݻ
    #================================================================
    def set_comment(hProcUnitInfo, sComment, lAtr = :comment)
      check_class(Hash, hProcUnitInfo) # Ȥɲäñ̾
      check_class(String, sComment)    # ɲä륳
      check_class(Symbol, lAtr)        # Ϳ°ʥǥե :comment

      @aElement.push({:atr => lAtr, :proc_unit => hProcUnitInfo, :code => sComment})
    end


    #================================================================
    # : ֥åζ̿ݻ
    #================================================================
    def set_block_delimiter()
      if (lMode == :block)
        @aElement.push({:atr => :delimiter_cmd})
      end
    end


    #================================================================
    # : ʹߤνϥɤ򥤥ǥȤ̿ݻ
    #================================================================
    def set_indent(nTabs = 1)
      check_class(Integer, nTabs) # ǥȤοʥǥե 1

      @aElement.push({:atr => :indent_cmd, :num => nTabs})
    end


    #================================================================
    # : ǥ̿̿ݻ
    #================================================================
    def unset_indent()
      @aElement.push({:atr => :unindent_cmd})
    end


    #================================================================
    # : ؿľ˽Ϥץ쥳ɤǤݻ
    #================================================================
    def set_pre_code(sProcUnitID, sPreCode, bExpression = true)
      check_class(String, sProcUnitID)  # ɤɲäñID
      check_class(String, sPreCode)     # Ϥץ쥳
      check_class(Bool, bExpression)    # ɤǤ뤫ɤʥǥեȡtrue

      if (bExpression == true)
        # ξϽʸ˥ߥͿ
        sPreCodeSemicolon = sPreCode + ";"
        @aElement.push({:atr => :precode, :proc_unit => sProcUnitID, :code => sPreCodeSemicolon})
      else
        # ʸξϤΤޤ޳Ǽ
        @aElement.push({:atr => :precode, :proc_unit => sProcUnitID, :code => sPreCode})
      end
    end


    #================================================================
    # : ؿκǸ˽ϤݥȥɤǤݻ
    #================================================================
    def set_post_code(sProcUnitID, sPostCode, bExpression = true)
      check_class(String, sProcUnitID)  # ɤɲäñID
      check_class(String, sPostCode)    # Ϥݥȥ
      check_class(Bool, bExpression)    # ɤǤ뤫ɤʥǥեȡtrue

      if (bExpression == true)
        # ξϽʸ˥ߥͿ
        sPostCodeSemicolon = sPostCode + ";"
        @aElement.push({:atr => :postcode, :proc_unit => sProcUnitID, :code => sPostCodeSemicolon})
      else
        # ʸξϤΤޤ޳Ǽ
        @aElement.push({:atr => :postcode, :proc_unit => sProcUnitID, :code => sPostCode})
      end
    end


    #================================================================
    # : IMCodeElementpp긫䤹ƽϤ
    #================================================================
    def p_code(lOption = :all)
      # [atr]         [proc]   [other parameters]
      # api           proc,    syscall,          var
      # ercd          proc,    ret,              var
      # assert        proc,                      var,     value
      # code          proc,    code
      # check(mp)     proc
      # zero          proc
      # finish(mp)    proc
      # waitcp        proc,    prcid
      # barrier       proc,    num
      # proc_unit     proc_id, fbootcnt
      # localvar      proc_id, name,    type,             value
      # globalvar              name,    type,             value
      # header        proc_id,          type,    var
      # config                 code,    class
      # comment       proc,    code
      # delimiter_cmd
      # precode       proc_id, code
      # postcode      proc_id, code
      puts "[atr]".center(15) + "|" + "[proc_unit]".center(14) + "|" + "[other_parameters]"
      puts "-" * 15 + "+" + "-" * 14 + "+" + "-" * 20
      @aElement.each{ |hElement|
        if (hElement[:atr] == :delimiter_cmd)
          puts ""; next
        end
        print "#{hElement[:atr]}".ljust(15) + "|"

        print "#{hElement[:proc_unit][:id].sub(/.*_(\w+\z)/, "\\1")}".ljust(8) + "|" if (hElement[:proc_unit])
        print "#{hElement[:proc_unit_id].sub(/.*_(\w+\z)/, "\\1")}".ljust(8)   + "|" if (hElement[:proc_unit_id])
        print "".ljust(8) + "|" unless (hElement[:proc_unit] || hElement[:proc_unit_id])
        print "#{hElement[:proc_unit][:bootcnt]}".ljust(2) + "|" if (hElement[:proc_unit])
        print "#{hElement[:proc_unit][:prcid]}".ljust(2)   + "|" if (hElement[:proc_unit])
        print "".ljust(2) + "|" + "".ljust(2) + "|" unless (hElement[:proc_unit])
        print "#{hElement[:syscall]}, "   if (hElement[:syscall])
        print "#{hElement[:ret]}, "       if (hElement[:ret])
        print "#{hElement[:code]}, "      if (hElement[:code])
        print "#{hElement[:prcid]}, "     if (hElement[:prcid])
        print "#{hElement[:num]}, "       if (hElement[:num])
        print "#{hElement[:fbootcnt]}, "  if (hElement[:fbootcnt])
        print "#{hElement[:name]}, "      if (hElement[:name])
        print "#{hElement[:type]}, "      if (hElement[:type])
        print "#{hElement[:class]}, "     if (hElement[:class])
        print "#{hElement[:var]}, "       if (hElement[:var])
        print "#{hElement[:value]}, "     if (hElement[:value])
        print "#{hElement[:code]}, "      if (hElement[:precode])
        print "#{hElement[:code]}, "      if (hElement[:postcode])
        puts ""
      }
    end

  end
end
