#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: ProcessUnit.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/CommonModule.rb"
require "common/bin/Config.rb"
require "common/bin/process_unit/Variable.rb"
require "common/bin/IMCodeElement.rb"
require "ttc/bin/process_unit/ProcessUnit.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: ProcessUnit
  #     : ñ̥֥Ȥξ륯饹
  #===================================================================
  class ProcessUnit
    include CommonModule

    attr_accessor :hState, :sObjectID, :sObjectType

    #=================================================================
    #   : ñ̥֥Ȥν
    #=================================================================
    def initialize(sObjectID, hObjectInfo, sObjectType, aPath, bIsPre)
      check_class(String, sObjectID)    # ֥ID
      check_class(Hash, hObjectInfo)    # ֥Ⱦ
      check_class(String, sObjectType)  # ֥ȥ
      check_class(Array, aPath)         # 롼ȤΥѥ
      check_class(Bool, bIsPre)         # pre_condition⤫

      @cConf                  = Config.new()
      @hState                 = {}
      @aSpecifiedDoAttributes = []

      @sObjectID   = sObjectID
      @sObjectType = sObjectType
      @aPath       = aPath + [@sObjectID]

      @bConvertState = false  # state°ݻѤ֤ͤ(TESRYTTS_RUNʤɻꤵ줿˥顼ФǤʤ)

      # ñ̥饹ʬ
      @hState[TSR_PRM_STATE]   = nil  # [/顼ϥɥ/ϥɥ/㳰/ߥϥɥ/ߥӥ롼]
      @hState[TSR_PRM_LEFTTMO] = nil  # ֻ[/顼ϥɥ/ϥɥ]
      @hState[TSR_PRM_VAR]     = nil  # ѿ[ñ]
      @hState[TSR_PRM_EXINF]   = nil  # ĥ[/顼ϥɥ/ϥɥ/ߥӥ롼/롼/λ롼]
      @hState[TSR_PRM_HDLSTAT] = nil  # 顼ϥɥ[顼ϥɥ/ϥɥ/㳰/ߥϥɥ/ߥӥ롼/CPU㳰ϥɥ]
      @hState[TSR_PRM_ACTPRC]  = nil  # ưդץåID[/顼ϥɥ/ϥɥ]
      @hState[TSR_PRM_BOOTCNT] = nil  # ñ̤εư[/顼ϥɥ/ϥɥ/㳰/ߥϥɥ/ߥӥ롼/CPU㳰ϥɥ]
      @hState[TSR_PRM_PRCID]   = nil  # ץåID[/顼ϥɥ/ϥɥ]
      @hState[TSR_PRM_CLASS]   = nil  # 饹[ñ]
      @hState[TSR_PRM_INTNO]   = nil  # ֹ[ߥϥɥ/ߥӥ롼]
      @hState[TSR_PRM_INTPRI]  = nil  # ͥ[ߥϥɥ/ߥӥ롼]
      @hState[TSR_PRM_SPINID]  = nil  # ԥåID[/顼ϥɥ/ϥɥ/㳰/CPU㳰ϥɥ/ߥϥɥ/ߥӥ롼]
      @hState[TSR_PRM_ATR]     = nil  # °[ϥɥ/ߥϥɥ/ߥӥ롼]

      # TASK
      @hState[TSR_PRM_ITSKPRI] = nil  # ưͥ
      @hState[TSR_PRM_TSKPRI]  = nil  # ͥ
      @hState[TSR_PRM_TSKWAIT] = nil  # Ԥװ
      @hState[TSR_PRM_WOBJID]  = nil  # Ԥ֤ˤԤо
      @hState[TSR_PRM_ACTCNT]  = nil  # ư׵ᥭ塼󥰿
      @hState[TSR_PRM_WUPCNT]  = nil  # ׵ᥭ塼󥰿
      @hState[TSR_PRM_PORDER]  = nil  # ¹(ǽ)ֻΥǥ塼Ǥν

      # CYCLE
      @hState[TSR_PRM_CYCPHS]  = nil  # 
      @hState[TSR_PRM_CYCTIM]  = nil  # 

      # TASK_EXC
      @hState[TSR_PRM_PNDPTN]  = nil  # 㳰α㳰װѥ
      @hState[TSR_PRM_TEXPTN]  = nil  # 㳰㳰װѥ
      @hState[TSR_PRM_TASK]    = nil  # 㳰Ϣ

      # INTHDR
      @hState[TSR_PRM_INHNO]   = nil  # ߥϥɥֹ

      # ISR
      @hState[TSR_PRM_ISRPRI]  = nil  # ߥӥ롼ͥ

      # EXCEPTION
      @hState[TSR_PRM_EXCNO]   = nil  # CPU㳰ϥɥֹ

      # INIRTNTERRTN
      @hState[TSR_PRM_DO]      = nil  # /λ롼Ǽ¹Ԥ
      @hState[TSR_PRM_GLOBAL]  = nil  # Х/λ롼⤫ɤ

      pre_attribute_check(hObjectInfo, aPath + [@sObjectID], bIsPre)
      store_object_info(hObjectInfo)
    end

    #=================================================================
    #   : ƥȥʥꥪ̤ñ̥֥ȥǡ
    #         @hState
    #=================================================================
    def store_object_info(hObjectInfo)
      check_class(Hash, hObjectInfo)  # ֥Ⱦ

      # Ǽ
      set_specified_attribute(hObjectInfo)
      hObjectInfo.each{|atr, val|
        case atr
        when TSR_PRM_TYPE
          # ⤷ʤ

        when TSR_PRM_TSKSTAT, TSR_PRM_ALMSTAT, TSR_PRM_CYCSTAT, TSR_PRM_TEXSTAT, TSR_PRM_INTSTAT
          if (GRP_OBJECT_STATE.has_key?(val))
            @hState[TSR_PRM_STATE] = GRP_OBJECT_STATE[val]
            @bConvertState = true
          else
            @hState[TSR_PRM_STATE] = val
          end

        when TSR_PRM_LEFTTIM, TSR_PRM_LEFTTMO
          @hState[TSR_PRM_LEFTTMO] = val

        when TSR_PRM_VAR
          @hState[atr] = {}
          if (val.is_a?(Hash))
            val.each{|sVarName, var|
              @hState[atr][sVarName] = Variable.new(sVarName, var, @aPath + [TSR_PRM_VAR])
            }
          else
            @hState[atr] = val
          end

        when TSR_PRM_CYCATR, TSR_PRM_INTATR
          @hState[TSR_PRM_ATR] = val

        else
          @hState[atr] = val

        end
      }
    end

    #=================================================================
    #   : refcElementɲä
    #=================================================================
    def gc_obj_ref(cElement, hProcUnitInfo, bContext, bCpuLock)
      check_class(IMCodeElement, cElement) # 
      check_class(Hash, hProcUnitInfo)     # ñ̾
      check_class(Bool, bContext)          # ̤(SCObject¦ȤоΤ)
      check_class(Bool, bCpuLock)          # ̤(SCObject¦ȤоΤ)


      cElement.set_local_var(hProcUnitInfo[:id], @sRefStrVar, @sRefStrType)

      # 㳰ξ硤ꤹIDϴϢ륿IDȤ
      if (@sObjectType == TSR_OBJ_TASK_EXC)
        cElement.set_syscall(hProcUnitInfo, "#{@sRefAPI}(#{@hState[TSR_PRM_TASK]}, &#{@sRefStrVar})")
      else
        cElement.set_syscall(hProcUnitInfo, "#{@sRefAPI}(#{@sObjectID}, &#{@sRefStrVar})")
      end

      # °
      if (!@hState[TSR_PRM_ATR].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{@sRefAtr}", @hState[TSR_PRM_ATR])  # CYCLEΤ
      end

      # 
      if (!@hState[TSR_PRM_STATE].nil?())
        # ԥåԤξref뤳Ȥʤ
        if (@hState[TSR_PRM_STATE] == TSR_STT_R_WAITSPN)
          abort(ERR_MSG % [__FILE__, __LINE__])
        else
          cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{@sRefState}", @hState[TSR_PRM_STATE])
        end
      end

      # ͥ(ٻ߾֤ξϻȤʤ)
      if (!@hState[TSR_PRM_TSKPRI].nil?() && (@hState[TSR_PRM_STATE] != KER_TTS_DMT))
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_TSKPRI}", @hState[TSR_PRM_TSKPRI])
      end

      # ưͥ
      if (!@hState[TSR_PRM_ITSKPRI].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_ITSKPRI}", @hState[TSR_PRM_ITSKPRI])
      end

      # ֻ
      if (@sObjectType == TSR_OBJ_TASK)
        # ٻ߾֤ξϻȤʤ
        if (!@hState[TSR_PRM_LEFTTMO].nil?() && (@hState[TSR_PRM_STATE] != KER_TTS_DMT))
          cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_LEFTTMO}", "#{CST_TMO}#{@hState[TSR_PRM_LEFTTMO]}U")
        end
      else
        # 顼ϥɥ顤ϥɥ
        if (!@hState[TSR_PRM_LEFTTMO].nil?())
          cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_LEFTTIM}", @hState[TSR_PRM_LEFTTMO])
        end
      end

      # ǥ塼Ǥν(ٻ߾֤ξϻȤʤ)
      if (!@hState[TSR_PRM_PORDER].nil?() && (@hState[TSR_PRM_STATE] != KER_TTS_DMT))
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_PORDER}", @hState[TSR_PRM_PORDER])
      end

      # ư׵ᥭ塼󥰿
      if (!@hState[TSR_PRM_ACTCNT].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_ACTCNT}", @hState[TSR_PRM_ACTCNT])
      end

      # ׵ᥭ塼󥰿(ٻ߾֤ξϻȤʤ)
      if (!@hState[TSR_PRM_WUPCNT].nil?() && (@hState[TSR_PRM_STATE] != KER_TTS_DMT))
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_WUPCNT}", @hState[TSR_PRM_WUPCNT])
      end

      # ĥ(㳰ξϻȤǤʤ)
      if (!@hState[TSR_PRM_EXINF].nil?() && (@sObjectType != TSR_OBJ_TASK_EXC))
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{@sRefExInf}", @hState[TSR_PRM_EXINF])
      end

      # ץåID(㳰Ǥrefʤ)
      if (!@hState[TSR_PRM_PRCID].nil?() && (sObjectType != TSR_OBJ_TASK_EXC))
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{@sRefPrcID}", @hState[TSR_PRM_PRCID])
      end

      # ưդץåID
      if (!@hState[TSR_PRM_ACTPRC].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{@sRefActPrc}", @hState[TSR_PRM_ACTPRC])
      end

      # Ԥо(ٻ߾֤ξϻȤʤ)
      if (!@hState[TSR_PRM_WOBJID].nil?() && (@hState[TSR_PRM_STATE] != KER_TTS_DMT))
        if (@hState[TSR_PRM_WOBJID] == TSR_STT_SLEEP)
          cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_TSKWAIT}", KER_TTW_SLP)
        elsif (@hState[TSR_PRM_WOBJID] == TSR_STT_DELAY)
          cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_TSKWAIT}", KER_TTW_DLY)
        else
          cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_WOBJID}", @hState[TSR_PRM_WOBJID])
        end
      end

      # 
      if (!@hState[TSR_PRM_CYCPHS].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_CYCPHS}", @hState[TSR_PRM_CYCPHS])
      end

      # 
      if (!@hState[TSR_PRM_CYCTIM].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_CYCTIM}", @hState[TSR_PRM_CYCTIM])
      end

      # α㳰װѥ
      if (!@hState[TSR_PRM_PNDPTN].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_PNDPTN}", @hState[TSR_PRM_PNDPTN])
      end
    end

    #=================================================================
    #   : ñ̤ѿͤӤ륳ɤcElement˳Ǽ
    #         
    #=================================================================
    def gc_assert_value(cElement, hProcUnitInfo)
      check_class(IMCodeElement, cElement) # 
      check_class(Hash, hProcUnitInfo)     # ñ̾

      hState[TSR_PRM_VAR].each{|sValName, cVariable|
        cVariable.gc_assert_value(cElement, hProcUnitInfo)
      }
    end

    #=================================================================
    #   : ץåID֤
    #=================================================================
    def get_process_id()
      return @hState[TSR_PRM_PRCID] == nil ? 1 : @hState[TSR_PRM_PRCID] # [Integer]ץåID
    end

    #=================================================================
    #   : 롼Υɤ֤
    #=================================================================
    def gc_ini_rtn(bFirstFlg)
      check_class(Bool, bFirstFlg)  # ǽν롼󤫤ɤ

      cElement = IMCodeElement.new()

      # ñ(bootcnt0)
      cElement.set_proc_unit(@sObjectID, TTG_MAIN_BOOTCNT)

      # Ȥνñ̾
      hIniRtnInfo = {:id => @sObjectID, :prcid => @hState[TSR_PRM_PRCID], :bootcnt => TTG_MAIN_BOOTCNT}

      # ASPƬν롼ξ硤Ԥ
      if ((bFirstFlg == true) && @cConf.is_asp?())
        # ƥȥ饤֥ѿ
        cElement.set_code(hIniRtnInfo, FNC_INITIALIZE_TEST_LIB)
      end

      # ƥIDϤsyslog
      cElement.set_code(hIniRtnInfo, "syslog_0(LOG_NOTICE, \"#{@sObjectID}: Start\")")

      # 롼ɬפʤ٤ƤΥɺ
      gc_ini_ter_rtn_info(cElement, hIniRtnInfo, bFirstFlg)

      # 롼˥åݥȤ
      cElement.set_checkpoint(hIniRtnInfo)

      # ƥIDλsyslog
      cElement.set_code(hIniRtnInfo, "syslog_0(LOG_NOTICE, \"#{@sObjectID}: OK\")")

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : λ롼ΥåݥȰʳΥɤ֤
    #=================================================================
    def gc_ter_rtn_info()
      cElement = IMCodeElement.new()

      # ñ(bootcnt0)
      cElement.set_proc_unit(@sObjectID, TTG_MAIN_BOOTCNT)

      # Ȥνñ̾
      hTerRtnInfo = {:id => @sObjectID, :prcid => @hState[TSR_PRM_PRCID], :bootcnt => TTG_MAIN_BOOTCNT}

      # 顼ȯƤϽλ롼¹Ԥreturn
      cElement.set_local_var(hTerRtnInfo[:id], VAR_STATE, TYP_BOOL_T)
      cElement.set_code(hTerRtnInfo, "#{VAR_STATE} = #{FNC_GET_CP_STATE}()")
      cElement.set_code(hTerRtnInfo, "if (#{VAR_STATE} == false) {", false)
      cElement.set_indent(1)
      cElement.set_code(hTerRtnInfo, "return")
      cElement.unset_indent()
      cElement.set_code(hTerRtnInfo, "}")
      cElement.set_block_delimiter()

      # ƥIDϤsyslog
      cElement.set_code(hTerRtnInfo, "syslog_0(LOG_NOTICE, \"#{@sObjectID}: Start\")")

      # 롼ɬפʤ٤ƤΥɺ
      gc_ini_ter_rtn_info(cElement, hTerRtnInfo, false)

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : λ롼ΥåݥȤΥɤ֤
    #=================================================================
    def gc_ter_rtn_checkpoint()
      cElement = IMCodeElement.new()

      # Ȥνñ̾
      hTerRtnInfo = {:id => @sObjectID, :prcid => @hState[TSR_PRM_PRCID], :bootcnt => TTG_MAIN_BOOTCNT}

      cElement.set_checkpoint(hTerRtnInfo)

      # ƥIDλsyslog
      cElement.set_code(hTerRtnInfo, "syslog_0(LOG_NOTICE, \"#{@sObjectID}: OK\")")

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : ƥȽλåϤΥɤ֤
    #=================================================================
    def gc_finish_message()
      cElement = IMCodeElement.new()

      # Ȥνñ̾
      hTerRtnInfo = {:id => @sObjectID, :prcid => @hState[TSR_PRM_PRCID], :bootcnt => TTG_MAIN_BOOTCNT}

      cElement.set_local_var(hTerRtnInfo[:id], VAR_STATE, TYP_BOOL_T)
      cElement.set_code(hTerRtnInfo, "#{VAR_STATE} = #{FNC_GET_CP_STATE}()")
      cElement.set_code(hTerRtnInfo, "if (#{VAR_STATE} == true) {", false)
      cElement.set_indent(1)

      # GCOVν
      # FMPξGCOVѤΥХ뽪λ롼ǽϤ뤿ᡤASPΤ
      if (@cConf.enable_gcov?() && @cConf.is_asp?())
        cElement.set_code(hTerRtnInfo, FNC_GCOV_C_RESUME)
        cElement.set_code(hTerRtnInfo, FNC_GCOV_C_DUMP)
      end

      if (@cConf.is_asp?())
        cElement.set_code(hTerRtnInfo, "syslog_0(LOG_NOTICE, \"#{TTG_FINISH_MESSAGE}\")")
      else
        cElement.set_code(hTerRtnInfo, "syslog_0(LOG_NOTICE, \"PE #{hTerRtnInfo[:prcid]} : #{TTG_FINISH_MESSAGE}\")")
      end
      cElement.unset_indent()
      cElement.set_code(hTerRtnInfo, "}")

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : /λ롼ɬפʤ٤ƤΥɺ
    #=================================================================
    def gc_ini_ter_rtn_info(cElement, hRtnInfo, bFirstFlg)
      check_class(IMCodeElement, cElement) # 
      check_class(Hash, hRtnInfo)          # ñ̾
      check_class(Bool, bFirstFlg)         # Ǥʤ롼󤫤ɤ

      # إå
      cElement.set_header(@sObjectID, @sObjectType)

      # եե
      cElement.set_config("#{@sCfgAPI}({#{KER_TA_NULL}, #{@hState[TSR_PRM_EXINF]}, #{@sObjectID.downcase}});", @hState[TSR_PRM_CLASS])

      # ĥλ
      cElement.set_assert(hRtnInfo, VAR_EXINF, @hState[TSR_PRM_EXINF])

      # GCOVγ
      if (@cConf.enable_gcov?())
        # ASPǺǽν롼ξ硤ǽ
        if (bFirstFlg == true && @cConf.is_asp?())
          cElement.set_code(hRtnInfo, FNC_GCOV_TTG_C_PAUSE)
        end
        if (@hState[TSR_PRM_DO][TSR_PRM_GCOV] == true)
          cElement.set_code(hRtnInfo, FNC_GCOV_TTG_C_RESUME)
        end
      end

      # ¹Ԥ륳
      if (@hState[TSR_PRM_DO].has_key?(TSR_PRM_SYSCALL))
        if (@hState[TSR_PRM_DO].has_key?(TSR_PRM_ERCD))
          cElement.set_syscall(hRtnInfo, @hState[TSR_PRM_DO][TSR_PRM_SYSCALL], @hState[TSR_PRM_DO][TSR_PRM_ERCD])
        elsif (@hState[TSR_PRM_DO].has_key?(TSR_PRM_ERUINT))
          cElement.set_syscall(hRtnInfo, @hState[TSR_PRM_DO][TSR_PRM_SYSCALL], @hState[TSR_PRM_DO][TSR_PRM_ERUINT], TYP_ER_UINT)
        elsif (@hState[TSR_PRM_DO].has_key?(TSR_PRM_BOOL))
          cElement.set_syscall(hRtnInfo, @hState[TSR_PRM_DO][TSR_PRM_SYSCALL], @hState[TSR_PRM_DO][TSR_PRM_BOOL], TYP_BOOL_T)
        else
          cElement.set_syscall(hRtnInfo, @hState[TSR_PRM_DO][TSR_PRM_SYSCALL], nil)
        end
      else
        cElement.set_code(hRtnInfo, @hState[TSR_PRM_DO][TSR_PRM_CODE])
      end

      # GCOV
      if (@cConf.enable_gcov?() && @hState[TSR_PRM_DO][TSR_PRM_GCOV] == true)
        cElement.set_code(hRtnInfo, FNC_GCOV_TTG_C_PAUSE)
      end

    end

  end
end
