#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: SCObject.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/CommonModule.rb"
require "common/bin/Config.rb"
require "common/bin/IMCodeElement.rb"
require "ttc/bin/sc_object/SCObject.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: SCObject
  #     : Ʊ֥̿Ȥξ륯饹
  #===================================================================
  class SCObject
    include CommonModule

    attr_accessor :hState, :sObjectType, :sObjectID

    #=================================================================
    #   : Ʊ֥̿Ȥν
    #=================================================================
    def initialize(sObjectID, hObjectInfo, sObjectType, aPath, bIsPre)
      check_class(String, sObjectID)    # ֥ID
      check_class(Hash, hObjectInfo)    # ֥Ⱦ
      check_class(String, sObjectType)  # ֥ȥ
      check_class(Array, aPath)         # 롼ȤΥѥ
      check_class(Bool, bIsPre)         # pre_condition⤫

      @cConf   = Config.new()
      @hState = {}

      @sObjectID   = sObjectID
      @sObjectType = sObjectType  # ֥ȤΥ
      @aPath       = aPath + [@sObjectID]

      # Ʊ֥̿ȶʬ
      @hState[TSR_PRM_DATACNT]  = nil  # ǼǤǡ[ǡ塼/ͥ٥ǡ塼]
      @hState[TSR_PRM_STSKLIST] = nil  # ԤΥꥹ[ǡ塼/ͥ٥ǡ塼]
      @hState[TSR_PRM_RTSKLIST] = nil  # ԤΥꥹ[ǡ塼/ͥ٥ǡ塼]
      @hState[TSR_PRM_DATALIST] = nil  # ΰΥǡΥꥹ[ǡ塼/ͥ٥ǡ塼]
      @hState[TSR_PRM_WTSKLIST] = nil  # ԤΥꥹ[ޥե/٥ȥե饰/᡼ܥå/Ĺס]
      @hState[TSR_PRM_ATR]      = nil  # °[ޥե/٥ȥե饰/ǡ塼/ͥ٥ǡ塼/᡼ܥå/Ĺס]
      @hState[TSR_PRM_CLASS]    = nil  # 饹

      # SEMAPHORE
      @hState[TSR_PRM_MAXSEM]   = nil  # 񸻿
      @hState[TSR_PRM_ISEMCNT]  = nil  # 񸻿
      @hState[TSR_PRM_SEMCNT]   = nil  # ߻񸻿

      # EVENTFLAG
      @hState[TSR_PRM_IFLGPTN]  = nil  # ӥåȥѥ
      @hState[TSR_PRM_FLGPTN]   = nil  # ߥӥåȥѥ

      # P_DATAQUEUE
      @hState[TSR_PRM_MAXDPRI]  = nil  # ǡͥ٤κ

      # MAILBOX
      @hState[TSR_PRM_MAXMPRI]  = nil  # åͥ٤κ
      @hState[TSR_PRM_MSGLIST]  = nil  # ԤåΥꥹ

      # MEMORYPOOL
      @hState[TSR_PRM_BLKCNT]   = nil  # Ǥ֥åν
      @hState[TSR_PRM_FBLKCNT]  = nil  # Ǥ֥åθ߿
      @hState[TSR_PRM_BLKSZ]    = nil  # ֥åΥ
      @hState[TSR_PRM_MPF]      = nil  # סƬϻѿ

      # SPINLOCK
      @hState[TSR_PRM_SPNSTAT]  = nil  # ԥåξ
      @hState[TSR_PRM_PROCID]   = nil  # ԥåƤñID

      pre_attribute_check(hObjectInfo, aPath + [@sObjectID], bIsPre)
      store_object_info(hObjectInfo)
    end

    #=================================================================
    #   : ƥȥʥꥪ̤Ʊ֥̿ȥǡ
    #         @hState
    #=================================================================
    def store_object_info(hObjectInfo)
      check_class(Hash, hObjectInfo)  # ֥Ⱦ

      # Ǽ
      set_specified_attribute(hObjectInfo)
      hObjectInfo.each{|atr, val|
        case atr
        when TSR_PRM_TYPE
          # ⤷ʤ

        when TSR_PRM_DTQCNT, TSR_PRM_PDQCNT
          @hState[TSR_PRM_DATACNT] = val

        when TSR_PRM_SEMATR, TSR_PRM_FLGATR, TSR_PRM_DTQATR, TSR_PRM_PDQATR, TSR_PRM_MBXATR, TSR_PRM_MPFATR
          @hState[TSR_PRM_ATR] = val

        else
          @hState[atr] = val
        end
      }

      # ꥹȷϥѥ᡼TESRY°ҤƤ硤
      # 򥻥åȤ
      [TSR_PRM_WTSKLIST, TSR_PRM_STSKLIST, TSR_PRM_RTSKLIST, TSR_PRM_DATALIST, TSR_PRM_MSGLIST].each{|sAtr|
        if (hObjectInfo[sAtr].nil?() && hObjectInfo.has_key?(sAtr))
          @hState[sAtr] = []
        end
      }
    end

    #=================================================================
    #   : Ʊ֥̿Ȥpre_conditioncElement˳
    #         Ǽ
    #=================================================================
    def gc_obj_ref(cElement, hProcUnitInfo, bContext, bCouLock)
      check_class(IMCodeElement, cElement) # 
      check_class(Hash, hProcUnitInfo)     # ñ̾
      check_class(Bool, bContext)          # ƥȤ
      check_class(Bool, bCouLock)          # CPUå


      # CPU_LOCK
      if (check_cpu_lock() && (bCouLock != true))
        cElement.set_syscall(hProcUnitInfo, get_cpu_lock(bContext))
      end

      cElement.set_local_var(hProcUnitInfo[:id], @sRefStrVar, @sRefStrType)
      cElement.set_syscall(hProcUnitInfo, "#{@sRefAPI}(#{@sObjectID}, &#{@sRefStrVar})")

      # °
      if (!@hState[TSR_PRM_ATR].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{@sRefAtr}", @hState[TSR_PRM_ATR])
      end

      # ʬ
      # ԤΥꥹ[SEMAPHORE, EVENTFLAG, MAILBOX, MEMORYPOOL]
      if (!@hState[TSR_PRM_WTSKLIST].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{@sRefWaitCnt}", @hState[TSR_PRM_WTSKLIST].size())

        if (!@hState[TSR_PRM_WTSKLIST].empty?())
          cElement.set_local_var(hProcUnitInfo[:id], VAR_TSKID, TYP_ID)

          @hState[TSR_PRM_WTSKLIST].each_with_index{|hTaskInfo, nIndex|
            case @sObjectType
            when TSR_OBJ_SEMAPHORE, TSR_OBJ_MAILBOX, TSR_OBJ_MEMORYPOOL
              cElement.set_syscall(hProcUnitInfo, "#{@sRefRWaitAPI}(#{@sObjectID}, #{nIndex + 1}, &#{VAR_TSKID})")
              cElement.set_assert(hProcUnitInfo, VAR_TSKID, hTaskInfo.keys[0])

            when TSR_OBJ_EVENTFLAG
              cElement.set_local_var(hProcUnitInfo[:id], VAR_WAIPTN, TYP_FLGPTN)
              cElement.set_local_var(hProcUnitInfo[:id], VAR_WFMODE, TYP_MODE)
              cElement.set_syscall(hProcUnitInfo, "#{@sRefRWaitAPI}(#{@sObjectID}, #{nIndex + 1}, &#{VAR_TSKID}, &#{VAR_WAIPTN}, &#{VAR_WFMODE})")
              cElement.set_assert(hProcUnitInfo, "#{VAR_TSKID}", hTaskInfo.keys[0])
              cElement.set_assert(hProcUnitInfo, VAR_WAIPTN, hTaskInfo[hTaskInfo.keys[0]][TSR_VAR_WAIPTN])
              cElement.set_assert(hProcUnitInfo, VAR_WFMODE, hTaskInfo[hTaskInfo.keys[0]][TSR_VAR_WFMODE])

            else
              abort(ERR_MSG % [__FILE__, __LINE__])
            end
          }
        end
      end

      # DATAQUEUEP_DATAQUEUE
      # ǡΰꥹ
      if (!@hState[TSR_PRM_DATACNT].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{@sRefDataCnt}", @hState[TSR_PRM_DATACNT])

        if (!@hState[TSR_PRM_DATALIST].nil?())
          cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{@sRefDataList}", @hState[TSR_PRM_DATALIST].size())

          if (!@hState[TSR_PRM_DATALIST].empty?())
            case @sObjectType
            when TSR_OBJ_DATAQUEUE
              cElement.set_local_var(hProcUnitInfo[:id], VAR_DATA, TYP_INTPTR_T)
              @hState[TSR_PRM_DATALIST].each_with_index{|hData, nIndex|
                cElement.set_syscall(hProcUnitInfo, "#{FNC_REF_DATA}(#{sObjectID}, #{nIndex + 1}, &#{VAR_DATA})")
                cElement.set_assert(hProcUnitInfo, VAR_DATA, hData[TSR_VAR_DATA])
              }

            when TSR_OBJ_P_DATAQUEUE
              cElement.set_local_var(hProcUnitInfo[:id], VAR_DATA, TYP_INTPTR_T)
              cElement.set_local_var(hProcUnitInfo[:id], VAR_DATAPRI, TYP_PRI)

              @hState[TSR_PRM_DATALIST].each_with_index{|hData, nIndex|
                cElement.set_syscall(hProcUnitInfo, "#{FNC_REF_PRI_DATA}(#{sObjectID}, #{nIndex + 1}, &#{VAR_DATA}, &#{VAR_DATAPRI})")
                cElement.set_assert(hProcUnitInfo, VAR_DATA, hData[TSR_VAR_DATA])
                cElement.set_assert(hProcUnitInfo, VAR_DATAPRI, hData[TSR_VAR_DATAPRI])
              }

            else
              abort(ERR_MSG % [__FILE__, __LINE__])
            end
          end
        end
      end

      # Ԥꥹ
      if (!@hState[TSR_PRM_STSKLIST].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{@sRefSWaitList}", @hState[TSR_PRM_STSKLIST].size())

        if (!@hState[TSR_PRM_STSKLIST].empty?())
          cElement.set_local_var(hProcUnitInfo[:id], VAR_TSKID, TYP_ID)
          cElement.set_local_var(hProcUnitInfo[:id], VAR_DATA, TYP_INTPTR_T)

          case @sObjectType
          when TSR_OBJ_DATAQUEUE
            @hState[TSR_PRM_STSKLIST].each_with_index{|hTaskInfo, nIndex|
              cElement.set_syscall(hProcUnitInfo, "#{FNC_REF_SWAIT_DTQ}(#{@sObjectID}, #{nIndex + 1}, &#{VAR_TSKID}, &#{VAR_DATA})")
              cElement.set_assert(hProcUnitInfo, VAR_TSKID, hTaskInfo.keys[0])
              cElement.set_assert(hProcUnitInfo, VAR_DATA, hTaskInfo[hTaskInfo.keys[0]][TSR_VAR_DATA])
            }

          when TSR_OBJ_P_DATAQUEUE
            cElement.set_local_var(hProcUnitInfo[:id], VAR_DATAPRI, TYP_PRI)
            @hState[TSR_PRM_STSKLIST].each_with_index{|hTaskInfo, nIndex|
              cElement.set_syscall(hProcUnitInfo, "#{FNC_REF_SWAIT_PDQ}(#{@sObjectID}, #{nIndex + 1}, &#{VAR_TSKID}, &#{VAR_DATA}, &#{VAR_DATAPRI})")
              cElement.set_assert(hProcUnitInfo, VAR_TSKID, hTaskInfo.keys[0])
              cElement.set_assert(hProcUnitInfo, VAR_DATA, hTaskInfo[hTaskInfo.keys[0]][TSR_VAR_DATA])
              cElement.set_assert(hProcUnitInfo, VAR_DATAPRI, hTaskInfo[hTaskInfo.keys[0]][TSR_VAR_DATAPRI])
            }

          else
            abort(ERR_MSG % [__FILE__, __LINE__])
          end
        end
      end

      # Ԥꥹ
      if (!@hState[TSR_PRM_RTSKLIST].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{@sRefRWaitList}", @hState[TSR_PRM_RTSKLIST].size())

        if (!@hState[TSR_PRM_RTSKLIST].empty?())
          cElement.set_local_var(hProcUnitInfo[:id], VAR_TSKID, TYP_ID)

          @hState[TSR_PRM_RTSKLIST].each_with_index{|hTaskInfo, nIndex|
            cElement.set_syscall(hProcUnitInfo, "#{@sRefRWaitAPI}(#{@sObjectID}, #{nIndex + 1}, &#{VAR_TSKID})")
            cElement.set_assert(hProcUnitInfo, VAR_TSKID, hTaskInfo.keys[0])
          }
        end
      end

      # MAILBOX
      # åꥹ
      if (!@hState[TSR_PRM_MSGLIST].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{@sRefMsgCnt}", @hState[TSR_PRM_MSGLIST].size())

        if (!@hState[TSR_PRM_MSGLIST].empty?())
          @hState[TSR_PRM_MSGLIST].each_with_index{|hData, nIndex|
            if (hData.has_key?(TSR_VAR_MSGPRI))
              cElement.set_local_var(hProcUnitInfo[:id], VAR_P_MSG_PRI, TYP_T_P_MSG_PRI)
              cElement.set_syscall(hProcUnitInfo, "#{FNC_REF_MSG}(#{@sObjectID}, #{nIndex + 1}, #{CST_MSG2}&#{VAR_P_MSG_PRI})")
              cElement.set_assert(hProcUnitInfo, VAR_P_MSG_PRI, "&#{hData[TSR_VAR_MSG]}")
              cElement.set_assert(hProcUnitInfo, "#{VAR_P_MSG_PRI}->#{STR_MSGPRI}", hData[TSR_VAR_MSGPRI])
            else
              cElement.set_local_var(hProcUnitInfo[:id], VAR_P_MSG, TYP_T_P_MSG)
              cElement.set_syscall(hProcUnitInfo, "#{FNC_REF_MSG}(#{@sObjectID}, #{nIndex + 1}, #{CST_MSG2}&#{VAR_P_MSG})")
              cElement.set_assert(hProcUnitInfo, VAR_P_MSG, "&#{hData[TSR_VAR_MSG]}")
            end
          }
        end
      end

      # SEMAPHORE
      if (!@hState[TSR_PRM_SEMCNT].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_SEMCNT}", @hState[TSR_PRM_SEMCNT])
      end

      if (!@hState[TSR_PRM_ISEMCNT].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_ISEMCNT}", @hState[TSR_PRM_ISEMCNT])
      end

      if (!@hState[TSR_PRM_MAXSEM].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_MAXSEM}", @hState[TSR_PRM_MAXSEM])
      end

      # EVENTFLAG
      if (!@hState[TSR_PRM_FLGPTN].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_FLGPTN}", @hState[TSR_PRM_FLGPTN])
      end

      if (!@hState[TSR_PRM_IFLGPTN].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_IFLGPTN}", @hState[TSR_PRM_IFLGPTN])
      end

      # MAILBOX
      if (!@hState[TSR_PRM_MAXMPRI].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_MAXMPRI}", @hState[TSR_PRM_MAXMPRI])
      end

      # P_DATAQUEUE
      if (!@hState[TSR_PRM_MAXDPRI].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_MAXDPRI}", @hState[TSR_PRM_MAXDPRI])
      end

      # MEMORYPOOL
      if (!@hState[TSR_PRM_BLKCNT].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_BLKCNT}", @hState[TSR_PRM_BLKCNT])
      end

      if (!@hState[TSR_PRM_FBLKCNT].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_FBLKCNT}", @hState[TSR_PRM_FBLKCNT])
      end

      if (!@hState[TSR_PRM_BLKSZ].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_BLKSZ}", @hState[TSR_PRM_BLKSZ])
      end

      if (!@hState[TSR_PRM_MPF].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_MPF}", @hState[TSR_PRM_MPF])
      end

      # SPINLOCK
      if (!@hState[TSR_PRM_SPNSTAT].nil?())
        cElement.set_assert(hProcUnitInfo, "#{@sRefStrVar}.#{STR_SPNSTAT}", @hState[TSR_PRM_SPNSTAT])
      end

      # CPU_UNLOCK
      if (check_cpu_lock() && (bCouLock != true))
        cElement.set_syscall(hProcUnitInfo, get_cpu_unlock(bContext))
      end
    end

    #=================================================================
    #   : cpu_lockɬפɤȽǤɬפǤtrue
    #         ɬפǤʤfalse֤
    #=================================================================
    def check_cpu_lock()
      if !(@hState[TSR_PRM_STSKLIST].nil?() || @hState[TSR_PRM_STSKLIST].empty?()) ||
         !(@hState[TSR_PRM_RTSKLIST].nil?() || @hState[TSR_PRM_RTSKLIST].empty?()) ||
         !(@hState[TSR_PRM_DATALIST].nil?() || @hState[TSR_PRM_DATALIST].empty?()) ||
         !(@hState[TSR_PRM_WTSKLIST].nil?() || @hState[TSR_PRM_WTSKLIST].empty?()) ||
         !(@hState[TSR_PRM_MSGLIST].nil?() || @hState[TSR_PRM_MSGLIST].empty?())
        return true # [Bool]CPUåɬ
      end

      return false # [Bool]CPUå
    end

    #=================================================================
    #   : ƥȤξcpu_lock
    #         󥿥ƥȤξicpu_lock֤
    #=================================================================
    def get_cpu_lock(bCpuLock)
      check_class(Bool, bCpuLock)

      if (bCpuLock == true)
        sCpuLock = "#{API_LOC_CPU}()"
      else
        sCpuLock = "#{API_ILOC_CPU}()"
      end

      return sCpuLock # [String]cpu_lockicpu_lock
    end

    #=================================================================
    #   : ƥȤξunl_lock
    #         󥿥ƥȤξiunl_lock֤
    #=================================================================
    def get_cpu_unlock(bCpuLock)
      check_class(Bool, bCpuLock)

      if (bCpuLock == true)
        sCpuUnlock = "#{API_UNL_CPU}()"
      else
        sCpuUnlock = "#{API_IUNL_CPU}()"
      end

      return sCpuUnlock # [String]unl_lockiunl_cpu
    end
  end
end
