#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: PreCondition.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/test_scenario/Condition.rb"
require "ttc/bin/test_scenario/PreCondition.rb"
require "ttj/bin/test_scenario/PreCondition.rb"
require "bin/builder/fmp_builder/test_scenario/PreCondition.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: PreCondition
  #     : pre_conditionξ륯饹
  #===================================================================
  class PreCondition < Condition
    include CommonModule

    attr_reader :hObjectType

    #=================================================================
    #   : pre_conditionν
    #=================================================================
    def initialize(sTestID, hScenarioPre)
      check_class(String, sTestID)           # ƥID
      check_class(Hash, hScenarioPre, true)  # pre_condition

      super(sTestID)
      @hObjectType = {}  # ֥IDȥפбդ

      # ¤å
      basic_check(hScenarioPre)

      # ֥IDȥ֥ȥפбɽ
      hScenarioPre.each{|sObjectID, hObjectInfo|
        @hObjectType[sObjectID] = hObjectInfo[TSR_PRM_TYPE]
      }
      # ֥ȾǼ
      store_condition_info(hScenarioPre, @hObjectType)

      # åֹγǼ
      if (@cConf.is_stack_share_mode?())
        nStackNum = 1
        hObjects = get_objects_by_type(TSR_OBJ_TASK)
        hObjects.each{ |sObjectID, cObjectInfo|
          cObjectInfo.nStackNum = nStackNum
          nStackNum += 1
        }
      end
    end

    #=================================================================
    #   : pre_conditionǿʤ֤
    #=================================================================
    def set_pre_gain_tick()
      @nPreGainTick = 0

      # pre_conditionACTIVATEʥ।٥ȥϥɥʤ뤿ɬפʻ֤
      @hAllObject.each{|sObjectID, cObjectInfo|
        if ((GRP_TIME_EVENT_HDL.include?(cObjectInfo.sObjectType) == true) && (cObjectInfo.hState[TSR_PRM_HDLSTAT] == TSR_STT_ACTIVATE))
          if (cObjectInfo.sObjectType == TSR_OBJ_ALARM)
            if (@nPreGainTick == 0)
              @nPreGainTick = 1
            end
          elsif (cObjectInfo.sObjectType == TSR_OBJ_CYCLE)
            if ((cObjectInfo.hState[STR_CYCPHS].to_i + 1) > @nPreGainTick)
              @nPreGainTick = cObjectInfo.hState[STR_CYCPHS].to_i + 1
            end
          end
        end
      }
    end

    #=================================================================
    #   : оݥươᥤ󥿥ͥ٤򲼤
    #         cElement˳Ǽ
    #=================================================================
    def set_act_task(cElement, cObjectInfo)
      check_class(IMCodeElement, cElement)  # 
      check_class(ProcessUnit, cObjectInfo) # оݥ饹

      hMainTaskInfo = get_proc_unit_info()

      # оݥư
      cElement.set_syscall(hMainTaskInfo, "#{API_ACT_TSK}(#{cObjectInfo.sObjectID})")

      # ᥤ󥿥ͥ٤򲼤ƥǥѥå
      cElement.set_syscall(hMainTaskInfo, "#{API_CHG_PRI}(#{TTG_TSK_SELF}, #{TTG_WAIT_PRI})")

      # оݥͥ٤TTG_WAIT_PRIƱä硤rot_rdqȯԤƥǥѥå
      if (cObjectInfo.hState[TSR_PRM_TSKPRI] == TTG_WAIT_PRI)
        cElement.set_syscall(hMainTaskInfo, "#{API_ROT_RDQ}(#{TTG_WAIT_PRI})")
      end
    end
    private :set_act_task

    #=================================================================
    #   : ᥤ󥿥ͥ٤夲
    #         cElement˳Ǽ
    #=================================================================
    def set_chg_pri(cElement)
      check_class(IMCodeElement, cElement) # 
      hMainTaskInfo = get_proc_unit_info()

      # ᥤ󥿥򸵤ͥ٤᤹
      cElement.set_syscall(hMainTaskInfo, "#{API_CHG_PRI}(#{TTG_TSK_SELF}, #{TTG_MAIN_PRI})")
    end
    private :set_chg_pri

    #=================================================================
    #   : 㳰ľ֥true
    #         Ǥʤfalse֤
    #=================================================================
    def exist_pre_task_tex_ena()
      @hTask.each{|sObjectID, cObjectInfo|
        if (!cObjectInfo.cTex.nil?() && cObjectInfo.cTex.hState[TSR_PRM_STATE] == TSR_STT_TTEX_ENA)
          return true # [Bool]㳰ľ֥
        end
      }

      return false # [Bool]㳰ľ֥ʤ
    end

    #=================================================================
    #   : ACTIVATEǤ륿㳰ϥɥ餬true
    #         Ǥʤfalse֤
    #=================================================================
    def exist_pre_task_texhdr_activate()
      @hTask.each{|sObjectID, cObjectInfo|
        if (!cObjectInfo.cTex.nil?() && cObjectInfo.cTex.hState[TSR_PRM_HDLSTAT] == TSR_STT_ACTIVATE)
          return true # [Bool]ACTIVATEǤ륿㳰ϥɥ餬
        end
      }

      return false # [Bool]ACTIVATEǤ륿㳰ϥɥ餬ʤ
    end

    #=================================================================
    #   : ֤ɬפƱ֥̿Ȥ
    #         Ƥtrue򡤤ʤfalse֤
    #=================================================================
    def exist_pre_scobj_data()
      @hWaitObject.each{|sObjectID, cObjectInfo|
        if (cObjectInfo.hState[TSR_PRM_ISEMCNT] != cObjectInfo.hState[TSR_PRM_SEMCNT]) ||
           (cObjectInfo.hState[TSR_PRM_IFLGPTN] != cObjectInfo.hState[TSR_PRM_FLGPTN]) ||
           !(cObjectInfo.hState[TSR_PRM_DATALIST].nil?() || cObjectInfo.hState[TSR_PRM_DATALIST].empty?()) ||
           !(cObjectInfo.hState[TSR_PRM_MSGLIST].nil?() || cObjectInfo.hState[TSR_PRM_MSGLIST].empty?()) ||
           (cObjectInfo.hState[TSR_PRM_BLKCNT] != cObjectInfo.hState[TSR_PRM_FBLKCNT])
          return true # [Bool]Ƥ
        end
      }

      return false # [Bool]Ƥʤ
    end

    #=================================================================
    #   : Ʊ֥̿ȤˤԤ֤Υ
    #         true򡤤ʤfalse֤
    #=================================================================
    def exist_pre_task_scobj_waiting()
      @hTask.each{|sObjectID, cObjectInfo|
        if (!cObjectInfo.hState[TSR_PRM_WOBJID].nil?() && !GRP_WAIT_NON_OBJECT.include?(cObjectInfo.hState[TSR_PRM_WOBJID]))
          return true # [Bool]Ʊ֥̿ȤˤԤ֤Υ
        end
      }

      return false # [Bool]Ʊ֥̿ȤˤԤ֤Υʤ
    end

    #=================================================================
    #   : Ԥ(꡼סǥ쥤)Υ򸡺Ƥ
    #         true򡤤ʤfalse֤
    #=================================================================
    def exist_pre_task_waiting()
      @hTask.each{|sObjectID, cObjectInfo|
        if (!cObjectInfo.hState[TSR_PRM_WOBJID].nil?() && GRP_WAIT_NON_OBJECT.include?(cObjectInfo.hState[TSR_PRM_WOBJID]))
          return true # [Bool]Ƥ
        end
      }

      return false # [Bool]Ƥʤ
    end

    #=================================================================
    #   : Ԥ֤Υ򸡺Ƥtrue
    #         ʤfalse֤
    #=================================================================
    def exist_pre_task_suspended()
      @hTask.each{|sObjectID, cObjectInfo|
        if (GRP_SUSPENDED.include?(cObjectInfo.hState[TSR_PRM_STATE]))
          return true # [Bool]Ƥ
        end
      }

      return false # [Bool]Ƥʤ
    end

    #=================================================================
    #   : ǥ֤Υ򸡺Ƥtrue
    #         ʤfalse֤
    #=================================================================
    def exist_pre_task_ready()
      @hTask.each{|sObjectID, cObjectInfo|
        if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_RDY)
          return true # [Bool]Ƥ
        end
      }

      return false # [Bool]Ƥʤ
    end

    #=================================================================
    #   : ͥ٤Ƚͥ٤ۤʤ륿򸡺Ƥ
    #         true򡤤ʤfalse֤
    #=================================================================
    def exist_pre_task_pri_chg()
      @hTask.each{|sObjectID, cObjectInfo|
        if ((cObjectInfo.hState[TSR_PRM_STATE] != KER_TTS_RUN) &&
            (cObjectInfo.hState[TSR_PRM_STATE] != KER_TTS_DMT) &&
            (cObjectInfo.hState[TSR_PRM_TSKPRI] != cObjectInfo.hState[TSR_PRM_ITSKPRI]) &&
            !(!cObjectInfo.hState[TSR_PRM_WOBJID].nil?() && !GRP_WAIT_NON_OBJECT.include?(cObjectInfo.hState[TSR_PRM_WOBJID])))
          return true # [Bool]Ƥ
        end
      }

      return false # [Bool]Ƥʤ
    end

    #=================================================================
    #   : α㳰װ򤷤Ƥtrue
    #         Ǥʤfalse֤
    #=================================================================
    def exist_pre_task_tex_pndptn()
      @hTask.each{|sObjectID, cObjectInfo|
        if (!cObjectInfo.cTex.nil?() && !cObjectInfo.cTex.hState[TSR_PRM_PNDPTN].nil?() && cObjectInfo.cTex.hState[TSR_PRM_PNDPTN] != 0)
          return true # [Bool]α㳰װ򤷤Ƥ
        end
      }

      return false # [Bool]α㳰װ򤷤Ƥʤ
    end

    #=================================================================
    #   : Х/ѿ뤿Υɤ
    #         cElement˳Ǽ
    #=================================================================
    def gc_global_local_var(cElement)
      # ѿ¸ߤ硤
      @hAllObject.each{|sObjectID, cObjectInfo|
        if (!cObjectInfo.hState[TSR_PRM_VAR].nil?())
          cObjectInfo.hState[TSR_PRM_VAR].each{|sValName, cVariable|
            cVariable.gc_global_local_var(cElement, sObjectID)
          }
        end
      }
    end

    #=================================================================
    #   : إåե˽Ϥ륳ɺ
    #=================================================================
    def gc_header(cElement)
      @hAllObject.each{|sObjectID, cObjectInfo|
        if (GRP_PROCESS_UNIT.include?(cObjectInfo.sObjectType))
          cElement.set_header(sObjectID, cObjectInfo.sObjectType)
        end
      }
    end

    #=================================================================
    #   : եե˽Ϥ륳ɺ
    #=================================================================
    def gc_config(cElement)
      @hAllObject.each{|sObjectID, cObjectInfo|
        # CPU֤ɬפʤ
        # 㳰ϥȤν¸뤿ᡤǥɤ
        # 롼󡤽λ롼¾ΥɤȤޤȤ
        # ߥϥɥ顤CPU㳰϶ͭؿΤ
        if ((cObjectInfo.sObjectType != TSR_OBJ_CPU_STATE) &&
            (cObjectInfo.sObjectType != TSR_OBJ_TASK_EXC) &&
            (cObjectInfo.sObjectType != TSR_OBJ_INIRTN) &&
            (cObjectInfo.sObjectType != TSR_OBJ_TERRTN) &&
            (cObjectInfo.sObjectType != TSR_OBJ_INTHDR) &&
            (cObjectInfo.sObjectType != TSR_OBJ_EXCEPTION))
          cObjectInfo.gc_config(cElement)
        end
      }
    end

    #=================================================================
    #   : 㳰ľ֤ˤ륳ɤ֤
    #=================================================================
    def gc_pre_task_tex_ena()
      cElement = IMCodeElement.new()

      @hTask.each{|sObjectID, cObjectInfo|
        if (!cObjectInfo.cTex.nil?() && cObjectInfo.cTex.hState[TSR_PRM_STATE] == TSR_STT_TTEX_ENA)
          cElement.set_syscall(get_proc_unit_info(get_object_info(sObjectID)), "#{API_ENA_TEX}()")
        end
      }

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : 㳰򵯤ɤ֤
    #=================================================================
    def gc_pre_task_texhdr_activate()
      cElement     = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()
      hRunningTask  = get_proc_unit_info(get_object_info(@cRunning.hState[TSR_PRM_TASK]))
      hActivateTex  = get_proc_unit_info(@cRunning)

      # ¹Ծ֤Υư
      cElement.set_syscall(hMainTaskInfo, "#{API_ACT_TSK}(#{@cRunning.hState[TSR_PRM_TASK]})")

      # ¹Ծ֤Υ㳰ư
      cElement.set_syscall(hRunningTask, "#{API_RAS_TEX}(#{TTG_TSK_SELF}, #{@cRunning.hState[TSR_PRM_TEXPTN]})")

      # 㳰ľ֤TTEX_DISξ硤ena_texACTIVATEˤ
      if (@cRunning.hState[TSR_PRM_STATE] == TSR_STT_TTEX_DIS)
        cElement.set_syscall(hRunningTask, "#{API_ENA_TEX}()")
      # 㳰ľ֤TTEX_ENAξ硤ena_texƤ뤬㳰ư˺ena_tex
      else
        cElement.set_syscall(hActivateTex, "#{API_ENA_TEX}()")
      end

      # α㳰װѥ0Ǥʤ硤ʬras_tex
      if (@cRunning.hState[TSR_PRM_PNDPTN] != 0)
        cElement.set_syscall(hActivateTex, "#{API_RAS_TEX}(#{TTG_TSK_SELF}, #{@cRunning.hState[TSR_PRM_PNDPTN]})")
      end

      cElement.set_checkpoint(hMainTaskInfo)

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : Ʊ֥̿Ȥν֤
    #         IMCodeElement饹ˤޤȤ֤(ᥤؿνʬ)
    #=================================================================
    def gc_pre_scobj_data()
      # ᥤ󥿥Ŭڤʽˤꡤ
      # Ԥ֥Ȥν֤ꤹ
      cElement      = IMCodeElement.new()
      hProcUnitInfo = get_proc_unit_info()

      @hWaitObject.each{|sObjectID, cObjectInfo|
        # SEMAPHORE
        if (cObjectInfo.hState[TSR_PRM_ISEMCNT] != cObjectInfo.hState[TSR_PRM_SEMCNT])
          nTimes = cObjectInfo.hState[TSR_PRM_ISEMCNT] - cObjectInfo.hState[TSR_PRM_SEMCNT]

          if (nTimes > 0)
            nTimes.downto(1){
              cElement.set_syscall(hProcUnitInfo, "#{API_WAI_SEM}(#{cObjectInfo.sObjectID})")
            }
          else
            nTimes.upto(-1){
              cElement.set_syscall(hProcUnitInfo, "#{API_SIG_SEM}(#{cObjectInfo.sObjectID})")
            }
          end
        end

        # EVENTFLAG
        if (cObjectInfo.hState[TSR_PRM_IFLGPTN] != cObjectInfo.hState[TSR_PRM_FLGPTN])
          # ӥåȥѥ0ǤʤơӥåȥѥΥե饰򥯥ꥢƤ
          cElement.set_syscall(hProcUnitInfo, "#{API_CLR_FLG}(#{cObjectInfo.sObjectID}, ~#{cObjectInfo.hState[TSR_PRM_IFLGPTN]})")
          cElement.set_syscall(hProcUnitInfo, "#{API_SET_FLG}(#{cObjectInfo.sObjectID}, #{cObjectInfo.hState[TSR_PRM_FLGPTN]})")
        end

        # DATAQUEUEP_DATAQUEUE
        if !(cObjectInfo.hState[TSR_PRM_DATALIST].nil?() || cObjectInfo.hState[TSR_PRM_DATALIST].empty?())
          cObjectInfo.hState[TSR_PRM_DATALIST].each{|hData|
            case cObjectInfo.sObjectType
            when TSR_OBJ_DATAQUEUE
              cElement.set_syscall(hProcUnitInfo, "#{API_SND_DTQ}(#{cObjectInfo.sObjectID}, #{hData[TSR_VAR_DATA]})")

            when TSR_OBJ_P_DATAQUEUE
              cElement.set_syscall(hProcUnitInfo, "#{API_SND_PDQ}(#{cObjectInfo.sObjectID}, #{hData[TSR_VAR_DATA]}, #{hData[TSR_VAR_DATAPRI]})")

            end
          }
        end

        # MAILBOX
        if !(cObjectInfo.hState[TSR_PRM_MSGLIST].nil?() || cObjectInfo.hState[TSR_PRM_MSGLIST].empty?())
          cObjectInfo.hState[TSR_PRM_MSGLIST].each{|hData|
            if (hData.has_key?(TSR_VAR_MSGPRI))
              cElement.set_global_var(hData[TSR_VAR_MSG], TYP_T_MSG_PRI)
              cElement.set_code(hProcUnitInfo, "#{hData[TSR_VAR_MSG]}.#{STR_MSGPRI} = #{hData[TSR_VAR_MSGPRI]}")
              cElement.set_syscall(hProcUnitInfo, "#{API_SND_MBX}(#{cObjectInfo.sObjectID}, #{CST_MSG1}&#{hData[TSR_VAR_MSG]})")
            else
              cElement.set_global_var(hData[TSR_VAR_MSG], TYP_T_MSG)
              cElement.set_syscall(hProcUnitInfo, "#{API_SND_MBX}(#{cObjectInfo.sObjectID}, &#{hData[TSR_VAR_MSG]})")
            end
          }
        end

        # MEMORYPOOL
        if (cObjectInfo.hState[TSR_PRM_BLKCNT] != cObjectInfo.hState[TSR_PRM_FBLKCNT])
          nTimes = cObjectInfo.hState[TSR_PRM_BLKCNT] - cObjectInfo.hState[TSR_PRM_FBLKCNT]

          (1..nTimes).each{|nCnt|
            cElement.set_local_var(hProcUnitInfo[:id], "#{VAR_BLK}_#{nCnt}", TYP_VOID_P)
            cElement.set_syscall(hProcUnitInfo, "#{API_GET_MPF}(#{cObjectInfo.sObjectID}, &#{VAR_BLK}_#{nCnt})")
          }
        end
      }

      cElement.set_checkpoint(hProcUnitInfo)

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : Ʊ֥̿ȤˤԤ֥ν֤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_scobj_waiting()
      # 򥪥֥Ԥˤ륳ɥ֥å֤
      # ASP_dataqueue_rcv_dtq_f_2_1_1
      #   ᥤ󥿥TASK2򵯤㳰ϥɥ餬¸ߤ
      #   򤷡TASK2ʬsnd_dtq
      #   Ԥˤ(ԤˤʤäƤ륿ο)
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      @hWaitObject.each{|sObjectID, cObjectInfo|
        # ԤΥꥹ
        if (!cObjectInfo.hState[TSR_PRM_WTSKLIST].nil?() && !cObjectInfo.hState[TSR_PRM_WTSKLIST].empty?())
          cObjectInfo.hState[TSR_PRM_WTSKLIST].each{|aWtskList|
            aWtskList.each_key{|sTaskID|
              cTaskInfo = @hTask[sTaskID]

              # оݥإǥѥå뤿Υ
              set_act_task(cElement, cTaskInfo)

              # оݥξåݥ
              hProcUnitInfo = get_proc_unit_info(cTaskInfo)
              cElement.set_checkpoint(hProcUnitInfo)

              case cObjectInfo.sObjectType
              when TSR_OBJ_SEMAPHORE
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  cElement.set_syscall(hProcUnitInfo, "#{API_WAI_SEM}(#{sObjectID})", nil)
                else
                  cElement.set_syscall(hProcUnitInfo, "#{API_TWAI_SEM}(#{sObjectID}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                end

              when TSR_OBJ_EVENTFLAG
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  # ѿꤵƤлѤ
                  if (aWtskList[sTaskID][TSR_PRM_VAR] != nil)
                    cElement.set_syscall(hProcUnitInfo, "#{API_WAI_FLG}(#{sObjectID}, #{aWtskList[sTaskID][TSR_VAR_WAIPTN]}, #{aWtskList[sTaskID][TSR_VAR_WFMODE]}, &#{aWtskList[sTaskID][TSR_PRM_VAR]})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_FLGPTN, TYP_FLGPTN)
                    cElement.set_syscall(hProcUnitInfo, "#{API_WAI_FLG}(#{sObjectID}, #{aWtskList[sTaskID][TSR_VAR_WAIPTN]}, #{aWtskList[sTaskID][TSR_VAR_WFMODE]}, &#{VAR_FLGPTN})", nil)
                  end
                else
                  # ѿꤵƤлѤ
                  if (aWtskList[sTaskID][TSR_PRM_VAR] != nil)
                    cElement.set_syscall(hProcUnitInfo, "#{API_TWAI_FLG}(#{sObjectID}, #{aWtskList[sTaskID][TSR_VAR_WAIPTN]}, #{aWtskList[sTaskID][TSR_VAR_WFMODE]}, &#{aWtskList[sTaskID][TSR_PRM_VAR]}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_FLGPTN, TYP_FLGPTN)
                    cElement.set_syscall(hProcUnitInfo, "#{API_TWAI_FLG}(#{sObjectID}, #{aWtskList[sTaskID][TSR_VAR_WAIPTN]}, #{aWtskList[sTaskID][TSR_VAR_WFMODE]}, &#{VAR_FLGPTN}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  end
                end

              when TSR_OBJ_MAILBOX
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  # ѿꤵƤлѤ
                  if (!aWtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_RCV_MBX}(#{sObjectID}, &#{aWtskList[sTaskID][TSR_PRM_VAR]})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_P_MSG, TYP_T_P_MSG)
                    cElement.set_syscall(hProcUnitInfo, "#{API_RCV_MBX}(#{sObjectID}, &#{VAR_P_MSG})", nil)
                  end
                else
                  # ѿꤵƤлѤ
                  if (!aWtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_TRCV_MBX}(#{sObjectID}, &#{aWtskList[sTaskID][TSR_PRM_VAR]}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_P_MSG, TYP_T_P_MSG)
                    cElement.set_syscall(hProcUnitInfo, "#{API_TRCV_MBX}(#{sObjectID}, &#{VAR_P_MSG}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  end
                end

              when TSR_OBJ_MEMORYPOOL
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  # ѿꤵƤлѤ
                  if (!aWtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_GET_MPF}(#{sObjectID}, &#{aWtskList[sTaskID][TSR_PRM_VAR]})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_BLK, TYP_VOID_P)
                    cElement.set_syscall(hProcUnitInfo, "#{API_GET_MPF}(#{sObjectID}, &#{VAR_BLK})", nil)
                  end
                else
                  # ѿꤵƤлѤ
                  if (!aWtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_TGET_MPF}(#{sObjectID}, &#{aWtskList[sTaskID][TSR_PRM_VAR]}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_BLK, TYP_VOID_P)
                    cElement.set_syscall(hProcUnitInfo, "#{API_TGET_MPF}(#{sObjectID}, &#{VAR_BLK}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  end
                end

              end

              # ᥤ󥿥ͥ٤᤹Υ
              set_chg_pri(cElement)

              # оݥθͥ٤Ƚͥ٤ۤʤ礳chg_pri
              # (Ʊ֥̿Ȥ°ͥٽäˡԤǤʤȽѤǽ)
              if (cTaskInfo.hState[TSR_PRM_TSKPRI] != cTaskInfo.hState[TSR_PRM_ITSKPRI])
                cElement.set_syscall(hMainTaskInfo, "#{API_CHG_PRI}(#{cTaskInfo.sObjectID}, #{cTaskInfo.hState[TSR_PRM_TSKPRI]})")
              end
            }
          }
        end

        # ԤΥꥹ
        if (!cObjectInfo.hState[TSR_PRM_STSKLIST].nil?() && !cObjectInfo.hState[TSR_PRM_STSKLIST].empty?())
          cObjectInfo.hState[TSR_PRM_STSKLIST].each{|aStskList|
            aStskList.each{|sTaskID, hData|
              cTaskInfo = @hTask[sTaskID]

              # оݥإǥѥå뤿Υ
              set_act_task(cElement, cTaskInfo)

              # оݥξåݥ
              hProcUnitInfo = get_proc_unit_info(cTaskInfo)
              cElement.set_checkpoint(hProcUnitInfo)

              case cObjectInfo.sObjectType
              when TSR_OBJ_DATAQUEUE
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  cElement.set_syscall(hProcUnitInfo, "#{API_SND_DTQ}(#{sObjectID}, #{hData[hData.keys[0]]})", nil)
                else
                  cElement.set_syscall(hProcUnitInfo, "#{API_TSND_DTQ}(#{sObjectID}, #{hData[hData.keys[0]]}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                end

              when TSR_OBJ_P_DATAQUEUE
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  cElement.set_syscall(hProcUnitInfo, "#{API_SND_PDQ}(#{sObjectID}, #{hData[TSR_VAR_DATA]}, #{hData[TSR_VAR_DATAPRI]})", nil)
                else
                  cElement.set_syscall(hProcUnitInfo, "#{API_TSND_PDQ}(#{sObjectID}, #{hData[TSR_VAR_DATA]}, #{hData[TSR_VAR_DATAPRI]}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                end

              end

              # ᥤ󥿥ͥ٤᤹Υ
              set_chg_pri(cElement)

              # оݥθͥ٤Ƚͥ٤ۤʤ礳chg_pri
              # (Ʊ֥̿Ȥ°ͥٽäˡԤǤʤȽѤǽ)
              if (cTaskInfo.hState[TSR_PRM_TSKPRI] != cTaskInfo.hState[TSR_PRM_ITSKPRI])
                cElement.set_syscall(hMainTaskInfo, "#{API_CHG_PRI}(#{cTaskInfo.sObjectID}, #{cTaskInfo.hState[TSR_PRM_TSKPRI]})")
              end
            }
          }
        end

        # ԤΥꥹ
        if (!cObjectInfo.hState[TSR_PRM_RTSKLIST].nil?() && !cObjectInfo.hState[TSR_PRM_RTSKLIST].empty?())
          cObjectInfo.hState[TSR_PRM_RTSKLIST].each{|aRtskList|
            aRtskList.each_key{|sTaskID|
              cTaskInfo = @hTask[sTaskID]

              # оݥإǥѥå뤿Υ
              set_act_task(cElement, cTaskInfo)

              # оݥξåݥ
              hProcUnitInfo = get_proc_unit_info(cTaskInfo)
              cElement.set_checkpoint(hProcUnitInfo)

              case cObjectInfo.sObjectType
              when TSR_OBJ_DATAQUEUE
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  # ѿꤵƤлѤ
                  if (!aRtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_RCV_DTQ}(#{sObjectID}, &#{aRtskList[sTaskID][TSR_PRM_VAR]})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_DATA, TYP_INTPTR_T)
                    cElement.set_syscall(hProcUnitInfo, "#{API_RCV_DTQ}(#{sObjectID}, &#{VAR_DATA})", nil)
                  end
                else
                  if (!aRtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_TRCV_DTQ}(#{sObjectID}, &#{aRtskList[sTaskID][TSR_PRM_VAR]}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  else
                    # ѿꤵƤлѤ
                    cElement.set_local_var(sTaskID, VAR_DATA, TYP_INTPTR_T)
                    cElement.set_syscall(hProcUnitInfo, "#{API_TRCV_DTQ}(#{sObjectID}, &#{VAR_DATA}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  end
                end

              when TSR_OBJ_P_DATAQUEUE
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  # ѿꤵƤлѤ
                  if (!aRtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_RCV_PDQ}(#{sObjectID}, &#{aRtskList[sTaskID][TSR_VAR_VARDATA]}, &#{aRtskList[sTaskID][TSR_VAR_VARPRI]})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_DATA, TYP_INTPTR_T)
                    cElement.set_local_var(sTaskID, VAR_DATAPRI, TYP_PRI)
                    cElement.set_syscall(hProcUnitInfo, "#{API_RCV_PDQ}(#{sObjectID}, &#{VAR_DATA}, &#{VAR_DATAPRI})", nil)
                  end
                else
                  # ѿꤵƤлѤ
                  if (!aRtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_TRCV_PDQ}(#{sObjectID}, &#{aRtskList[sTaskID][TSR_VAR_VARDATA]}, &#{aRtskList[sTaskID][TSR_VAR_VARPRI]}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_DATA, TYP_INTPTR_T)
                    cElement.set_local_var(sTaskID, VAR_DATAPRI, TYP_PRI)
                    cElement.set_syscall(hProcUnitInfo, "#{API_TRCV_PDQ}(#{sObjectID}, &#{VAR_DATA}, &#{VAR_DATAPRI}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  end
                end

              end

              # ᥤ󥿥ͥ٤᤹Υ
              set_chg_pri(cElement)

              # оݥθͥ٤Ƚͥ٤ۤʤ礳chg_pri
              # (Ʊ֥̿Ȥ°ͥٽäˡԤǤʤȽѤǽ)
              if (cTaskInfo.hState[TSR_PRM_TSKPRI] != cTaskInfo.hState[TSR_PRM_ITSKPRI])
                cElement.set_syscall(hMainTaskInfo, "#{API_CHG_PRI}(#{cTaskInfo.sObjectID}, #{cTaskInfo.hState[TSR_PRM_TSKPRI]})")
              end
            }
          }
        end
      }

      # Ԥֺ塤ᥤ󥿥äǥåݥ
      cElement.set_checkpoint(get_proc_unit_info())

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : Ԥ֤Ǥ륿ν֤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_waiting()
      cElement = IMCodeElement.new()

      @hTask.each{|sObjectID, cObjectInfo|
        if (GRP_WAIT_NON_OBJECT.include?(cObjectInfo.hState[TSR_PRM_WOBJID]))
          # оݥإǥѥå뤿Υ
          set_act_task(cElement, cObjectInfo)

          # оݥξåݥ
          hProcUnitInfo = get_proc_unit_info(cObjectInfo)
          cElement.set_checkpoint(hProcUnitInfo)

          if (cObjectInfo.hState[TSR_PRM_WOBJID] == TSR_STT_SLEEP)
            if (cObjectInfo.hState[TSR_PRM_LEFTTMO].nil?())
              cElement.set_syscall(hProcUnitInfo, "#{API_SLP_TSK}()", nil)
            else
              cElement.set_syscall(hProcUnitInfo, "#{API_TSLP_TSK}(#{cObjectInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
            end
          elsif (cObjectInfo.hState[TSR_PRM_WOBJID] == TSR_STT_DELAY)
            cElement.set_syscall(hProcUnitInfo, "#{API_DLY_TSK}(#{cObjectInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
          end

          # ᥤ󥿥ͥ٤᤹Υ
          set_chg_pri(cElement)
        end
      }

      # Ԥֺ塤ᥤ󥿥äǥåݥ
      cElement.set_checkpoint(get_proc_unit_info())

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : ֤Ǥ륿ν֤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_suspended()
      # ᥤ󥿥sus_tsk(оݥ)
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      @hTask.each{|sObjectID, cObjectInfo|
        if (GRP_SUSPENDED.include?(cObjectInfo.hState[TSR_PRM_STATE]))  # TTS_SUSTTS_WAS
          if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_SUS)
            # оݥإǥѥå뤿Υ
            set_act_task(cElement, cObjectInfo)

            # оݥξåݥ
            hProcUnitInfo = get_proc_unit_info(cObjectInfo)
            cElement.set_checkpoint(hProcUnitInfo)

            cElement.set_syscall(hProcUnitInfo, "#{API_SLP_TSK}()")

            # ᥤ󥿥ͥ٤᤹Υ
            set_chg_pri(cElement)
          end

          cElement.set_syscall(hMainTaskInfo, "#{API_SUS_TSK}(#{sObjectID})")

          # Ԥξ硤ƴ
          if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_SUS)
            cElement.set_syscall(hMainTaskInfo, "#{API_WUP_TSK}(#{sObjectID})")
          end
        end
      }

      cElement.set_checkpoint(hMainTaskInfo)

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : ǥ֤Ǥ륿ν֤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_ready()
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      # ᥤ󥿥鵯ơslp_tskƤ
      @hTask.each{|sObjectID, cObjectInfo|
        if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_RDY)
          # оݥإǥѥå뤿Υ
          set_act_task(cElement, cObjectInfo)

          # оݥξåݥ
          hProcUnitInfo = get_proc_unit_info(cObjectInfo)
          cElement.set_checkpoint(hProcUnitInfo)

          cElement.set_syscall(hProcUnitInfo, "#{API_SLP_TSK}()")

          # ᥤ󥿥ͥ٤᤹Υ
          set_chg_pri(cElement)
        end
      }

      cElement.set_checkpoint(hMainTaskInfo)

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : α㳰װꤹ륳ɤ֤
    #=================================================================
    def gc_pre_task_tex_pndptn()
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      @hTask.each{|sObjectID, cObjectInfo|
        # ¹⤷ϥ㳰ϥɥ餬ACTIVATEξϡʬȤras_tex
        if (!GRP_ACTIVATE.include?(cObjectInfo.hState[TSR_PRM_STATE]) && (!cObjectInfo.cTex.nil?()) &&
            !cObjectInfo.cTex.hState[TSR_PRM_PNDPTN].nil?() && (cObjectInfo.cTex.hState[TSR_PRM_PNDPTN] != 0))
          cElement.set_syscall(hMainTaskInfo, "#{API_RAS_TEX}(#{sObjectID}, #{cObjectInfo.cTex.hState[TSR_PRM_PNDPTN]})")
        end
      }

      cElement.set_checkpoint(hMainTaskInfo)

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : ư(Txxx_STA)Υ।٥ȥϥɥꤹ
    #         ɤ֤
    #=================================================================
    def gc_pre_time_event_sta()
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      @hAllObject.each{|sObjectID, cObjectInfo|
        if ((GRP_TIME_EVENT_HDL.include?(cObjectInfo.sObjectType) == true) &&
            (GRP_TIME_EVENT_STA.include?(cObjectInfo.hState[TSR_PRM_STATE]) == true) &&
             (cObjectInfo.hState[TSR_PRM_HDLSTAT] != TSR_STT_ACTIVATE))
          if (cObjectInfo.sObjectType == TSR_OBJ_ALARM)
            cElement.set_syscall(hMainTaskInfo, "#{API_STA_ALM}(#{sObjectID}, #{cObjectInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})")
          elsif (cObjectInfo.sObjectType == TSR_OBJ_CYCLE)
            cElement.set_syscall(hMainTaskInfo, "#{API_STA_CYC}(#{sObjectID})")
          end
        end
      }

      cElement.set_checkpoint(hMainTaskInfo)

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : ľ֤γߤꤹ륳ɤ֤
    #=================================================================
    def gc_pre_interrupt_ena()
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      # ena_intɬפΤֹ
      aEnaIntNo = []
      @hAllObject.each{|sObjectID, cObjectInfo|
        if ((GRP_INTERRUPT.include?(cObjectInfo.sObjectType) == true) &&
            (cObjectInfo.hState[TSR_PRM_STATE] == KER_TA_ENAINT))
          aEnaIntNo.push(cObjectInfo.hState[TSR_PRM_INTNO])
        end
      }

      # ʣƤ٤ena_int¹Ԥ
      aEnaIntNo.uniq!()
      aEnaIntNo.each{|snIntNo|
        cElement.set_syscall(hMainTaskInfo, "#{API_ENA_INT}(#{snIntNo})")
      }

      cElement.set_checkpoint(hMainTaskInfo)

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : ͥ٤Ƚͥ٤ۤʤ륿
    #         IMCodeElement饹ˤޤȤ֤
    #         (running,dormant,running-suspend,֥ԤʳΥ)
    #=================================================================
    def gc_pre_task_pri_chg()
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      @hTask.each{|sObjectID, cObjectInfo|
        if ((cObjectInfo.hState[TSR_PRM_STATE] != KER_TTS_RUN) &&
            (cObjectInfo.hState[TSR_PRM_STATE] != KER_TTS_RUS) &&
            (cObjectInfo.hState[TSR_PRM_STATE] != KER_TTS_DMT) &&
            (cObjectInfo.hState[TSR_PRM_TSKPRI] != cObjectInfo.hState[TSR_PRM_ITSKPRI]) &&
            !(!cObjectInfo.hState[TSR_PRM_WOBJID].nil?() && !GRP_WAIT_NON_OBJECT.include?(cObjectInfo.hState[TSR_PRM_WOBJID])))
          cElement.set_syscall(hMainTaskInfo, "#{API_CHG_PRI}(#{sObjectID}, #{cObjectInfo.hState[TSR_PRM_TSKPRI]})")
        end
      }

      cElement.set_checkpoint(hMainTaskInfo)

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : ¹Ծ֤Ǥ륿ν֤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_running()
      # ¹Ծ֤ˤʤ٤Υᥤ󥿥鵯
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      cElement.set_syscall(hMainTaskInfo, "#{API_ACT_TSK}(#{@cRunning.sObjectID})")

      # α㳰װꤹ
      if (!@cRunning.cTex.nil?() && 
          !@cRunning.cTex.hState[TSR_PRM_PNDPTN].nil?() && 
          @cRunning.cTex.hState[TSR_PRM_PNDPTN] != 0 &&
          @cRunning.cTex.hState[TSR_PRM_HDLSTAT] != TSR_STT_ACTIVATE)
        cElement.set_syscall(hMainTaskInfo, "#{API_RAS_TEX}(#{@cRunning.sObjectID}, #{@cRunning.cTex.hState[TSR_PRM_PNDPTN]})")
      end

      # ͥ٤Ƚͥ٤ۤʤꤹ
      if (@cRunning.hState[TSR_PRM_TSKPRI] != @cRunning.hState[TSR_PRM_ITSKPRI])
        cElement.set_syscall(hMainTaskInfo, "#{API_CHG_PRI}(#{@cRunning.sObjectID}, #{@cRunning.hState[TSR_PRM_TSKPRI]})")
      end

      cElement.set_checkpoint(hMainTaskInfo)

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : ǥѥåػߤˤ
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_dis_dsp()
      cElement      = IMCodeElement.new()
      hProcUnitInfo = get_proc_unit_info(@cRunning)

      cElement.set_syscall(hProcUnitInfo, "#{API_DIS_DSP}()")

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : ͥ٥ޥ0ʳˤ
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_set_ipm()
      cElement      = IMCodeElement.new()
      hProcUnitInfo = get_proc_unit_info(@cRunning)

      cElement.set_syscall(hProcUnitInfo, "#{API_CHG_IPM}(#{@cCpuState.hState[TSR_PRM_CHGIPM]})")

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : ư󥿥
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_nontask_activate()
      cElement      = IMCodeElement.new()
      hProcUnitInfo = get_proc_unit_info(@cRunning)

      case @cActivate.sObjectType
      # 顼ϥɥ
      when TSR_OBJ_ALARM
        # 0äꤷ1ߥÿʤƵư
        cElement.set_syscall(hProcUnitInfo, "#{API_STA_ALM}(#{@cActivate.sObjectID}, 0)")
        # STA°мȤista_alm¹Ԥ
        if (@cActivate.hState[TSR_PRM_STATE] == TSR_STT_TALM_STA)
          cElement.set_syscall(get_proc_unit_info(@cActivate), "#{API_ISTA_ALM}(#{@cActivate.sObjectID}, #{@cActivate.hState[TSR_PRM_LEFTTMO]})")
        end
        gc_tick_gain(cElement)

      # ϥɥ
      when TSR_OBJ_CYCLE
        cElement.set_syscall(hProcUnitInfo, "#{API_STA_CYC}(#{@cActivate.sObjectID})")
        # ʬ֤ʤƵư
        (@cActivate.hState[TSR_PRM_CYCPHS].to_i + 1).times{
          gc_tick_gain(cElement)
        }

      # ߥϥɥ顤ߥӥ롼
      when TSR_OBJ_INTHDR, TSR_OBJ_ISR
        # ȯؿ¹ԤƵư
        cElement.set_code(hProcUnitInfo, "#{FNC_INT_RAISE}(#{@cActivate.hState[TSR_PRM_INTNO]})")

      # CPU㳰ϥɥ
      when TSR_OBJ_EXCEPTION
        # CPU㳰ȯؿ¹ԤƵư
        cElement.set_code(hProcUnitInfo, "#{FNC_CPUEXC_RAISE}(#{@cActivate.hState[TSR_PRM_EXCNO]})")

      else
        abort(ERR_MSG % [__FILE__, __LINE__])
      end

      # ƥﹹ//CPU㳰ȯٱ䤷
      # 󥿥¦ǥåݥȤȯԤȯԸǥåݥȤԤ
      cElement.set_checkpoint(get_proc_unit_info(@cActivate))
      cElement.wait_checkpoint(hProcUnitInfo)

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : ŪSLEEPޤDELAY¹Խ֤˵
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_ready_porder()
      # ꡼פƤporderǧ
      # ¹Բǽ֤ˤ

      cElement  = IMCodeElement.new()  # element饹Ѱդ

      aPriorityTemp = []  # ̤ͥΤʤݻ뤿
      aPriOrderTemp = []  # ̤ͥΤ륿ͥݻ뤿

      @hTask.each{|sObjectID, cObjectInfo|
        if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_RDY)
          nPOrder = cObjectInfo.hState[TSR_PRM_PORDER]

          if (nPOrder.nil?())
            aPriorityTemp.push(sObjectID)
          else
            aPriOrderTemp[nPOrder] = sObjectID  # ̤ͥν
          end
        end
      }

      aPriOrderTemp.delete(nil)  # ɬפǤϤʤnilϺ
      aPriOrderTemp = aPriOrderTemp.concat(aPriorityTemp)
      hProcUnitInfo = get_proc_unit_info(@cActivate, @cRunning)

      aPriOrderTemp.each{|sObjectID|
        # ¹Ծ֤󥿥
        if (!@cActivate.nil?())
          cElement.set_syscall(hProcUnitInfo, "#{API_IWUP_TSK}(#{sObjectID})")
        # ¹Ծ֤Υ
        elsif (!@cRunning.nil?())
          cElement.set_syscall(hProcUnitInfo, "#{API_WUP_TSK}(#{sObjectID})")
        else
          abort(ERR_MSG % [__FILE__, __LINE__])
        end
      }

      cElement.set_checkpoint(hProcUnitInfo)

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : ư׵ᥭ塼󥰤򤹤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_queueing()
      cElement      = IMCodeElement.new()  # element饹Ѱդ
      hProcUnitInfo = get_proc_unit_info(@cActivate, @cRunning)

      @hTask.each{|sObjectID, cObjectInfo|
        if (!cObjectInfo.hState[TSR_PRM_ACTCNT].nil?() && cObjectInfo.hState[TSR_PRM_ACTCNT] >= 1)
          cObjectInfo.hState[TSR_PRM_ACTCNT].times{
            if (!@cActivate.nil?())
              cElement.set_syscall(hProcUnitInfo, "#{API_IACT_TSK}(#{sObjectID})")
            elsif (!@cRunning.nil?())
              cElement.set_syscall(hProcUnitInfo, "#{API_ACT_TSK}(#{sObjectID})")
            else
              abort(ERR_MSG % [__FILE__, __LINE__])
            end
          }
        end

        if(!cObjectInfo.hState[TSR_PRM_WUPCNT].nil?() && cObjectInfo.hState[TSR_PRM_WUPCNT] >= 1)
          cObjectInfo.hState[TSR_PRM_WUPCNT].times{
            if (!@cActivate.nil?())
              cElement.set_syscall(hProcUnitInfo, "#{API_IWUP_TSK}(#{sObjectID})")
            elsif (!@cRunning.nil?())
              cElement.set_syscall(hProcUnitInfo, "#{API_WUP_TSK}(#{sObjectID})")
            else
              abort(ERR_MSG % [__FILE__, __LINE__])
            end
          }
        end
      }

      cElement.set_checkpoint(hProcUnitInfo)

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : CPUå֤(¹νñ̤)
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_cpu_loc()
      # ư֤󥿥硤顼ࡦϥɥξ
      # ϥ顼ˤ
      # ޤư֤󥿥ʤļ¹Ծ֤Υ
      # ϡˤ

      cElement      = IMCodeElement.new()
      hProcUnitInfo = get_proc_unit_info(@cActivate, @cRunning)

      if (!@cActivate.nil?())
        cElement.set_syscall(hProcUnitInfo, "#{API_ILOC_CPU}()")
      else
        cElement.set_syscall(hProcUnitInfo, "#{API_LOC_CPU}()")
      end

      cElement.set_checkpoint(hProcUnitInfo)

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : ξ֤˹Ԥ٤Υᥤ
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_maintask_set(cNextActivate, cNextRunning, bNextCpuLock, bNextRunSus)
      check_class(ProcessUnit, cNextActivate, true) # Υǥǵưνñ
      check_class(ProcessUnit, cNextRunning, true)  # ΥǥǼ¹Υ
      check_class(Bool, bNextCpuLock)               # ΥǥCPUå
      check_class(Bool, bNextRunSus)                # ΥǥǲϾ֤ɤ

      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      # Υǥ˼¹Ծ֤νñ̤¸ߤ
      # pre_condition󥿥ACTIVATEäϡ
      # ᥤ󥿥slp_tskơ󥿥iwup_tskǵ
      # (󥿥ư˥ᥤ󥿥νʤΤ򤱤)
      if (!@cActivate.nil?() && @cRunning.nil?() && cNextActivate.nil?() && cNextRunning.nil?())
        cElement.set_syscall(hMainTaskInfo, "#{API_SLP_TSK}()")
        cElement.set_syscall(get_proc_unit_info(@cActivate), "#{API_IWUP_TSK}(#{TTG_MAIN_TASK})")
        @lMainTaskState = :running

      # ξ򤹤٤硤Υǥ
      # ᥤ󥿥򵯾Ǥ뤿ᡤslp_tsk
      # 1)Υǥ˼¹Ծ֤νñ̤¸ߤ
      # 2)Υǥμ¹Ծ֤ΥϾ֤Ǥʤ
      #   (ǲϾ֤ǶԤȤʤꡤᥤ󥿥򵯾Ǥʤ)
      # 3)ΥǥCPUåǤʤ
      #   (ʣdo/post³chg_pri/wup_tskȯԤǤʤǽ)
      elsif ((!cNextActivate.nil?() || !cNextRunning.nil?()) && (bNextRunSus == false) && (bNextCpuLock == false))
        cElement.set_syscall(hMainTaskInfo, "#{API_SLP_TSK}()")
        @lMainTaskState = :sleep

      # 嵭ʳǤϥᥤץå򵯾Ǥʤǽ뤿ᡤ
      # ¹Υ¸ߤ硤ᥤ󥿥ͥ٤򲼤Ƥ
      elsif (!@cRunning.nil?())
        cElement.set_syscall(hMainTaskInfo, "#{API_CHG_PRI}(#{TTG_TSK_SELF}, #{TTG_WAIT_PRI})")
        # pre_conditionrunningΥͥ٤TTG_WAIT_PRIä
        if (check_running_pri(TTG_WAIT_PRI) == true)
          cElement.set_syscall(hMainTaskInfo, "#{API_ROT_RDQ}(#{TTG_WAIT_PRI})")
        end
        # ᥤ󥿥TTG_MAIN_PRIξchg_priȯԤʤ
        cElement.set_chg_pri_main_task(hMainTaskInfo)

        @lMainTaskState = :ready

      # 嵭ʳϲ⤷ʤ
      else
        @lMainTaskState = :running

      end

      return cElement # [IMCodeElement] 
    end

    #=================================================================
    #   : ͥ٥ޥɬtrue
    #         ʤfalse֤
    #=================================================================
    def check_pre_need_chg_ipm()
      # ͥ٥ޥꤵƤʤfalse֤
      if (check_chg_ipm() == false)
        return false # [Bool] ͥ٥ޥɬ̵ͭ
      end

      # ʲΤ줫Τ߳ͥ٥ޥѹ
      # 1)ACTIVATE󥿥¸ߤʤ
      # 2)ACTIVATE󥿥CPU㳰ϥɥǤ
      if (@cActivate.nil?() || (@cActivate.sObjectType == TSR_OBJ_EXCEPTION))
        return true # [Bool] ͥ٥ޥɬ̵ͭ
      else
        return false # [Bool] ͥ٥ޥɬ̵ͭ
      end
    end

    #=================================================================
    #   : /λ롼󥯥饹ID֤
    #=================================================================
    def get_ini_ter_object_info_sort_by_id(sObjectType)
      check_class(String, sObjectType)  # оݤȤ륪֥ȥ[orλ롼]

      aIniTerInfo = []
      @hAllObject.sort.each{|aObjectInfo|
        if (aObjectInfo[1].sObjectType == sObjectType)
          aIniTerInfo.push(aObjectInfo[1])
        end
      }

      return aIniTerInfo  # [Array]/λ롼󥯥饹
    end

    #=================================================================
    #   : TA_STA°μϥɥ̵֤ͭ
    #=================================================================
    def exist_cyclic_sta()
      @hAllObject.each{|sObjID, cObjectInfo|
        if ((cObjectInfo.sObjectType == TSR_OBJ_CYCLE) && (cObjectInfo.hState[TSR_PRM_ATR] == KER_TA_STA))
          return true    # [Bool]TA_STA°μϥɥ餬¸ߤ
        end
      }

      return false  # [Bool]TA_STA°μϥɥ餬¸ߤʤ
    end

    #=================================================================
    #   : TA_ENAINT°γߥӥ롼̵֤ͭ
    #=================================================================
    def exist_isr_enaint()
      @hAllObject.each{|sObjID, cObjectInfo|
        if ((cObjectInfo.sObjectType == TSR_OBJ_ISR) && (cObjectInfo.hState[TSR_PRM_ATR] == KER_TA_ENAINT))
          return true    # [Bool]TA_ENAINT°γߥӥ롼¸ߤ
        end
      }

      return false  # [Bool]TA_ENAINT°γߥӥ롼¸ߤʤ
    end
  end
end
