#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: ObjectCommon.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/CommonModule.rb"
require "ttc/bin/class/TTCCommon.rb"

#=====================================================================
# TTCModule
#=====================================================================
module TTCModule
  #===================================================================
  # : ֥ȥ饹̥᥽å
  #===================================================================
  module ObjectCommon
    include CommonModule
    attr_accessor :aNilAttributes, :aSpecifiedAttributes

    #=================================================================
    # : ֥Υޥִ
    #=================================================================
    def convert_macro()
      hMacro = @cConf.get_macro()
      @hState.each{|sAtr, val|
        @hState[sAtr] = calc_all_expr(@hState[sAtr], hMacro)
      }
    end

    #=================================================================
    #   : ХбΤѥ᡼Ѵ¹Ԥ
    #=================================================================
    def convert_global(hTable, hClassTable)
      check_class(Hash, hTable)       # Ѵɽ
      check_class(Hash, hClassTable)  # 饹ִбɽ

      # prcidclass
      if (@hState[TSR_PRM_PRCID].is_a?(String))
        sMacro = @hState[TSR_PRM_PRCID]
        # prcid
        @hState[TSR_PRM_PRCID] = convert_global_prcid(sMacro, hTable)
        # class
        if (!@hState[TSR_PRM_CLASS].nil?() && sMacro != @hState[TSR_PRM_PRCID])
          sClass = @hState[TSR_PRM_CLASS]
          @hState[TSR_PRM_CLASS] = hClassTable[sMacro][sClass][@hState[TSR_PRM_PRCID]]
        end
      end

      # actprc
      if (@hState[TSR_PRM_ACTPRC].is_a?(String))
        @hState[TSR_PRM_ACTPRC] = convert_global_prcid(@hState[TSR_PRM_ACTPRC], hTable)
      end

      # intno
      if (@hState[TSR_PRM_INTNO].is_a?(String))
        @hState[TSR_PRM_INTNO] = convert_global_intno(@hState[TSR_PRM_INTNO], hTable)
      end

      # inhno
      if (@hState[TSR_PRM_INHNO].is_a?(String))
        @hState[TSR_PRM_INHNO] = convert_global_inhno(@hState[TSR_PRM_INHNO], hTable)
      end

      # excno
      if (@hState[TSR_PRM_EXCNO].is_a?(String))
        @hState[TSR_PRM_EXCNO] = convert_global_excno(@hState[TSR_PRM_EXCNO], hTable)
      end
    end

    #=================================================================
    # : Хִо°ƥޥƤ뤫
    #=================================================================
    def is_global_attribute_all_macro?()
      # å°ȡޥɽ
      hCheckAtr = {
        TSR_PRM_PRCID  => CFG_MCR_REX_PRCID,
        TSR_PRM_CLASS  => CFG_MCR_REX_CLASS,
        TSR_PRM_INTNO  => CFG_MCR_REX_INTNO,
        TSR_PRM_INHNO  => CFG_MCR_REX_INHNO,
        TSR_PRM_EXCNO  => CFG_MCR_REX_EXCNO
      }

      return hCheckAtr.all?(){|sAtr, cReg|
        (@hState[sAtr].nil?() || @hState[sAtr] =~ cReg)
      }  # [Bool]Хִо°ƥޥƤ뤫
    end

    #=================================================================
    #   : YAMLؤΥѥꤹ
    #=================================================================
    def set_path(aPath)
      check_class(Array, aPath)  # 롼ȤΥѥ

      @aPath = aPath
    end

    #=================================================================
    #   : ͤ䴰
    #=================================================================
    def complement_init_object_info()
      # ̾ϲ⤷ʤ
      # ɬפʥ֥ȤϥС饤
    end

    #=================================================================
    # : 䴰¹Ԥ
    #=================================================================
    def complement(cPrevObj)
      # åϳƥ֥ȤΥѡ饹Ǽ»ܤ뤳
      check_class(Object, cPrevObj)  # ľξ֤Υ֥

      # ꤵƤʤ䴰
      cPrevObj.hState.each{|sAtr, val|
        sRealAtr = get_real_attribute_name(sAtr)
        unless (is_specified?(sRealAtr))
          @hState[sAtr] = safe_dup(val)
        end
      }
    end

    #=================================================================
    # : 䴰λ˼¹Ԥ
    #=================================================================
    def complement_after()
      # ̾ϲ⤷ʤ
      # ɬפʥ֥ȤϥС饤
    end

    #=================================================================
    # : ꥢ¹Ԥ
    #=================================================================
    def alias(hAlias)
      check_class(Hash, hAlias)   # ꥢѴơ֥

      # ֥ID
      @sObjectID = hAlias[@sObjectID]

      # °
      @hState.each{|sAtr, val|
        if (val.is_a?(String))
          @hState[sAtr] = alias_replace(val, hAlias)
        end
      }
    end

    #=================================================================
    # : ֥ȤΥꥢѴơ֥֤
    #=================================================================
    def get_alias(sTestID, nNum = nil)
      abort(ERR_MSG % [__FILE__, __LINE__])
    end

    #=================================================================
    #   : ֥¸ߤѿ֤̾
    #=================================================================
    def get_variable_names()
      return []  # [Array]֥¸ߤѿ̾
    end

    #=================================================================
    #   : ݻ°̾TESRY°̾
    #=================================================================
    def get_real_attribute_name(sAtr)
      check_class(String, sAtr)  # ݻ°̾

      return sAtr  # [String]TESRY°̾
    end

    #=================================================================
    #   : Yaml˵ҤƤѥ᡼ꥹȤϿ
    #=================================================================
    def set_specified_attribute(hObjectInfo)
      check_class(Hash, hObjectInfo, true)  # ֥Ⱦ

      if (hObjectInfo.nil?())
        @aSpecifiedAttributes = []
      else
        @aSpecifiedAttributes = hObjectInfo.keys()
        @aSpecifiedAttributes.delete(TSR_PRM_TYPE)
      end
    end

    #=================================================================
    #   : NilΥѥ᡼ꥹȤϿ
    #=================================================================
    def set_nil_attribute()
      @aNilAttributes = []
      @hState.each{|sAtr, val|
        if (val.nil?())
          @aNilAttributes.push(sAtr)
        end
      }
    end

    #=================================================================
    # : °å(°ꤷå)
    #=================================================================
    def pre_attribute_check(hObjectInfo, aPath, bIsPre)
      check_class(Hash, hObjectInfo)  # ֥Ⱦ
      check_class(Array, aPath)       # 롼ȤΥѥ
      check_class(Bool, bIsPre)       # pre_condition⤫

      aErrors = []
      # ֥ȥפб°
      hAtrDefList = get_attribute_list()

      ### ǽ°
      aAtrs = hObjectInfo.keys()
      begin
        aAtrs.delete(TSR_PRM_TYPE)
        check_defined_attribute(aAtrs, hAtrDefList.keys(), aPath)
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      ### T1_023: pre_conditionǻɬܤ°ꤵƤʤ
      if (bIsPre == true)
        hAtrDefList.each{|sAtr, aDef|
          if (aDef[0] == true)
            unless (hObjectInfo.has_key?(sAtr))
              sErr = sprintf("T1_023: " + ERR_REQUIRED_KEY, sAtr)
              aErrors.push(YamlError.new(sErr, aPath))
            end
          end
        }
      ### T1_024: pre_conditionΤߤǻǽ°ꤵƤ
      else
        hAtrDefList.each{|sAtr, aDef|
          if (aDef[1] == true)
            if (hObjectInfo.has_key?(sAtr))
              sErr = sprintf("T1_024: " + ERR_ONLY_PRE_ATR, sAtr)
              aErrors.push(YamlError.new(sErr, aPath))
            end
          end
        }
      end

      check_error(aErrors)
    end

    #=================================================================
    #   : ֥Ȥ°
    #=================================================================
    def get_attribute_list()
      # ץեб°
      cConf    = Config.new()
      hAtrList = {}
      if (cConf.is_asp?())
        hAtrList = GRP_DEF_OBJECT_ASP
      elsif (cConf.is_fmp?())
        hAtrList = GRP_DEF_OBJECT_FMP
      end

      # ֥ȥפб°
      if (hAtrList.has_key?(@sObjectType))
        return hAtrList[@sObjectType]  # [Hash]֥Ȥ°
      else
        abort(ERR_MSG % [__FILE__, __LINE__])
      end
    end

    #=================================================================
    #   : ֥ȤƤYAML֥ȤѴ֤
    #=================================================================
    def to_yaml(bIsPre = false)
      check_class(Bool, bIsPre)  # pre_condition

      hYaml = {}
      # preξtype°Ϳ
      if (bIsPre == true)
        hYaml[TSR_PRM_TYPE] = @sObjectType
      end
      # ݻƤ
      @hState.each{|sAtr, val|
        sRealAtr = get_real_attribute_name(sAtr)
        if (!val.nil?() || is_specified?(sRealAtr))
          hYaml[sRealAtr] = safe_dup(val)
        end
      }

      return hYaml  # [Hash]YAML֥
    end

    #=================================================================
    #   : ꤵ줿°YAMLǵҤƤ뤫֤
    #=================================================================
    def is_specified?(sAtr)
      check_class(String, sAtr, true)  # °̾

      return @aSpecifiedAttributes.include?(sAtr)  # [Bool]ꤵ줿°YAMLǵҤƤ뤫
    end

    #=================================================================
    # : °å
    #=================================================================
    def attribute_check()
      abort(ERR_MSG % [__FILE__, __LINE__])
    end

    #=================================================================
    #   : ֥ȥå
    #=================================================================
    def object_check(aPath, bIsPre = false)
      abort(ERR_MSG % [__FILE__, __LINE__])
    end
  end
end
