#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: TTCError.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/CommonModule.rb"

#=====================================================================
# TTCModule
#=====================================================================
module TTCModule
  include CommonModule

  #===================================================================
  # 饹̾: TTCError
  #   : TTC¹Իȯ㳰
  #===================================================================
  class TTCError < Exception
  end

  #===================================================================
  # 饹̾: TTCMultiError
  #   : ʣȯ㳰
  #===================================================================
  class TTCMultiError < Exception
  end

  #===================================================================
  # 饹̾: TTCExcludeError
  #   : Хꥨ㳰
  #===================================================================
  class TTCExcludeError < Exception
    include CommonModule
    attr_reader :lErrCode

    #=================================================================
    # : 󥹥ȥ饯
    #=================================================================
    def initialize(sErr, lErrCode = nil)
      check_class(String, sErr)            # 顼å
      check_class(Symbol, lErrCode, true)  # ѥ

      super(sErr)
      @lErrCode = lErrCode
    end
  end

  #===================================================================
  # 饹̾: TTCMultiExcludeError
  #   : ʣȯХꥨ㳰
  #===================================================================
  class TTCMultiExcludeError < Exception
  end

  #===================================================================
  # 饹̾: YamlError
  #   : YamlҤΥ顼
  #===================================================================
  class YamlError < TTCError
    include CommonModule

    #=================================================================
    # : 󥹥ȥ饯
    #=================================================================
    def initialize(sErr, aPath = [])
      check_class(String, sErr)  # 顼å
      check_class(Array, aPath)  # ѥ

      super(sErr)
      @aPath = aPath
    end

    #=================================================================
    # : ѥ֤
    #=================================================================
    def path()
      sPath = "/"
      sPath.concat(@aPath.join("/"))

      return sPath  # [String]Ѥߥѥ
    end
  end
end
