#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: TaskExcept.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "ttc/bin/process_unit/ProcessUnit.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: TaskExcept
  #     : 㳰ξ륯饹
  #===================================================================
  class TaskExcept < ProcessUnit
    #=================================================================
    #   : ֥ȥå
    #=================================================================
    def object_check(bIsPre)
      check_class(Bool, bIsPre)  # pre_condition

      aErrors = []
      begin
        super(bIsPre)
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      # hdlstatACTIVATE
      if (@hState[TSR_PRM_HDLSTAT] == TSR_STT_ACTIVATE)
        ### T3_TEX001: hdlstatACTIVATEλtexptnꤵƤʤ
        if (@hState[TSR_PRM_TEXPTN].nil?())
          aErrors.push(YamlError.new("T3_TEX001: " + ERR_NO_TEXPTN_ON_ACTIVATE, @aPath))
        ### T3_TEX002: hdlstatACTIVATEλtexptn0
        elsif (@hState[TSR_PRM_TEXPTN] == 0)
          aErrors.push(YamlError.new("T3_TEX002: " + ERR_TEXPTN_0_ON_ACTIVATE, @aPath))
        end
        ### T3_TEX003: hdlstatACTIVATEΤȤpndptn0Ǥʤ  texstatTTEX_ENA
        if (@hState[TSR_PRM_PNDPTN] != 0 && @hState[TSR_PRM_STATE] == TSR_STT_TTEX_ENA)
          aErrors.push(YamlError.new("T3_TEX003: " + ERR_SET_PNDPTN_ON_ENABLE, @aPath))
        end
      ### T3_TEX004: hdlstatACTIVATE-waitspinλspinidꤵƤʤ
      elsif (@hState[TSR_PRM_HDLSTAT] == TSR_STT_A_WAITSPN && @hState[TSR_PRM_SPINID].nil?())
        aErrors.push(YamlError.new("T3_TEX004: " + ERR_NO_SPINID_WAITING, @aPath))
      end

      check_error(aErrors)
    end

    #=================================================================
    #   : ͤ䴰
    #=================================================================
    def complement_init_object_info()
      hMacro  = @cConf.get_macro()

      # bootcnt
      unless (is_specified?(TSR_PRM_BOOTCNT))
        @hState[TSR_PRM_BOOTCNT] = 0
      end
    end
  end
end
