#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: CPUState.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "ttc/bin/class/TTCCommon.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: CPUState
  #     : CPU֤ξ륯饹
  #===================================================================
  class CPUState
    include TTCModule
    include TTCModule::ObjectCommon

    #=================================================================
    #   : °å
    #=================================================================
    def attribute_check()
      aErrors = []
      @hState.each{|sAtr, val|
        begin
          if (is_specified?(sAtr))
            case sAtr
            # 0ʲʸ
            when TSR_PRM_CHGIPM
              unless (val.is_a?(String))
                check_attribute_le(sAtr, val, 0, @aPath)
              end

            # 
            when TSR_PRM_LOCCPU, TSR_PRM_DISDSP
              check_attribute_type(sAtr, val, Bool, false, @aPath)

            # 0礭
            when TSR_PRM_PRCID
              check_attribute_gt(sAtr, val, 0, @aPath)

            else
              abort(ERR_MSG % [__FILE__, __LINE__])
            end
          end
        rescue TTCError
          aErrors.push($!)
        end
      }

      check_error(aErrors)
    end

    #=================================================================
    #   : ֥ȥå
    # : ʤ
    #=================================================================
    def object_check(bIsPre = false)
      check_class(Bool, bIsPre)  # pre_condition

=begin
      aErrors = []
      ### T3_CPU001: loc_idꤵƤCPUå֤Ǥʤ
      if (!@hState[TSR_PRM_LOC_ID].nil?() && @hState[TSR_PRM_LOCCPU] == false)
        aErrors.push(YamlError.new("T3_CPU001: " + ERR_SET_LOC_ID_NOT_CPU_LOCK, @aPath))
      end

      check_error(aErrors)
=end
    end

    #=================================================================
    #   : ͤ䴰
    #=================================================================
    def complement_init_object_info()
      # loccpu
      unless (is_specified?(TSR_PRM_LOCCPU))
        @hState[TSR_PRM_LOCCPU] = false
      end
      # disdsp
      unless (is_specified?(TSR_PRM_DISDSP))
        @hState[TSR_PRM_DISDSP] = false
      end
      # chgipm
      unless (is_specified?(TSR_PRM_CHGIPM))
        @hState[TSR_PRM_CHGIPM] = KER_TIPM_ENAALL
      end

      # fmp
      if (@cConf.is_fmp?())
        # prcid
        unless (is_specified?(TSR_PRM_PRCID))
          @hState[TSR_PRM_PRCID] = CFG_MCR_PRC_SELF
        end
      end
    end

    #=================================================================
    # : 䴰¹Ԥ
    #=================================================================
    def complement(cPrevObj)
      check_class(CPUState, cPrevObj)  # ľξ֤Υ֥

      super(cPrevObj)
    end

    #=================================================================
    # : ֥ȤΥꥢѴơ֥֤
    #=================================================================
    def get_alias(sTestID, nNum = nil)
      check_class(String, sTestID)      # ƥID
      check_class(Integer, nNum, true)  # ֹ

      hResult = {}
      hResult[@sObjectID] = alias_str(@sObjectID, sTestID)

      return hResult  # [Hash]ꥢѴơ֥
    end

    #=================================================================
    # : ֥Ȥʣ֤
    #=================================================================
    def dup()
      cObjectInfo = super()

      # ֥IDʣ
      cObjectInfo.sObjectID = safe_dup(@sObjectID)
      # ֥ȥʣ
      cObjectInfo.sObjectType = safe_dup(@sObjectType)
      # ѥ᡼ʣ
      cObjectInfo.hState = safe_dup(@hState)

      return cObjectInfo  # [Object]ʣ֥
    end

    #=================================================================
    #   : CPUå椫֤
    #=================================================================
    def is_cpu_lock?()
      return (@hState[TSR_PRM_LOCCPU] == true)  # [Bool]CPUå椫
    end

    #=================================================================
    #   : ǥѥåػ߾֤֤
    #=================================================================
    def is_disable_dispatch?()
      return (@hState[TSR_PRM_DISDSP] == true)  # [Bool]ǥѥåػ߾֤
    end

    #=================================================================
    #   : ͥ٥ޥ֤֤
    #=================================================================
    def is_enable_interrupt?()
      return (@hState[TSR_PRM_CHGIPM] == KER_TIPM_ENAALL || @hState[TSR_PRM_CHGIPM] == 0)  # [Bool]ͥ٥ޥ֤
    end

    #=================================================================
    #   : ѲꤵƤ뤫֤
    #=================================================================
    def is_state_changed?()
      return (is_cpu_lock?() || is_disable_dispatch?() || !is_enable_interrupt?())  # [Bool]ѲꤵƤ뤫
    end
  end
end
