#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Digital Craft Inc.
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: TTJModule.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
$KCODE = "euc"

require "common/bin/CommonModule.rb"
require "common/bin/Config.rb"
require "ttj/bin/dictionary.rb"

module TTJModule
  include TTCModule
  include CommonModule

  $aTestScenarios = []  # ƥȥʥꥪݻ뤿ΥХѿ
  $sAttrErr       = ""  # 顼å

  #===================================================================
  #   : TestScenarioξܸ첽֤
  #===================================================================
  def japanize_test_scenario_info()
    cConf     = Config.new()  # ץ쥹С
    @aTTJInfo = []            # ܸ첽ݻѿ

    # ϥå幽¤°ߤ
    $hTTJAttribute = {}

    GRP_TTJ_ATTRIBUTE.each{|hAttribute|
      hAttribute.each{|key, val|
        $hTTJAttribute.store(key, val)
      }
    }

    # ץ쥹Сν
    nCnt   = 0
    nTotal = $aTestScenarios.size()

    # ƥƥȥʥꥪν
    $aTestScenarios.each{|cTestScenario|
      nCnt += 1

      if (cConf.is_no_progress_bar_mode?() == true)
        $stderr.puts "[TTJ][#{"%5.1f" % (100 * nCnt.to_f / nTotal.to_f)}\% (#{"%4d" % nCnt}/#{"%4d" % nTotal})] #{cTestScenario.sTestID}"
      else
        print_progress("TTJ", cTestScenario.sTestID, nCnt, nTotal)
      end

      cTSDup = Marshal.load(Marshal.dump(cTestScenario))  # ԡ(cTestScenarioƤݸΤ)
      @aTTJInfo.push(cTSDup.japanize_tesry_info())        # ܸ첽
    }

    # ץ쥹СɽΥꥻå
    if (cConf.is_no_progress_bar_mode?() != true)
      finish_progress("TTJ", nTotal)
    end
  end

  #===================================================================
  #   : TTCTESRYɤɹTestScenario
  #===================================================================
  def japanize_TTC_info(aArgs)
    check_class(Array, aArgs)  # ޥɤΰ

    cTTC = TTC.new()
    $aTestScenarios = cTTC.pre_process(aArgs)
    japanize_test_scenario_info()

    # Хꥨǽ줿եɽ
    cTTC.print_exclude()
  end

  #===================================================================
  #   : ̽
  #===================================================================
  def puts_monitor()
    @aTTJInfo.each{|hTTJInfo|
      hTTJInfo.each{|sObjectID, sObjectInfo|
        $stderr.puts("-" * 70)
        $stderr.puts(sObjectID)
        $stderr.puts("-" * 70)
        $stderr.puts("#{TTJ_NEW_LINE}#{sObjectInfo}#{TTJ_NEW_LINE}")
      }
    }

    if ($sAttrErr.empty?() == false)
      $stderr.puts("== ꤵƤʤ° ==#{TTJ_NEW_LINE}")
      $stderr.puts($sAttrErr)
    end
  end

  #===================================================================
  #   : ե
  #===================================================================
  def create_file()
    # ե
    File.open(TTJ_PRINT_FILE, "w"){|cIO|
      if ($sAttrErr.empty?() == false)
        cIO.puts("== ꤵƤʤ° ==#{TTJ_NEW_LINE}")
        cIO.puts($sAttrErr)
      end

      @aTTJInfo.each{|hTTJInfo|
        hTTJInfo.each{|sTestID, sTTJInfo|
          cIO.puts("-" * 70)
          cIO.puts(sTestID)
          cIO.puts("-" * 70)
          cIO.puts("#{TTJ_NEW_LINE}#{sTTJInfo}#{TTJ_NEW_LINE}")
        }
      }
    }
  end

end
