#
#  TTSP
#      TOPPERS Test Suite Package
# 
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2009-2011 by Digital Craft Inc.
#  Copyright (C) 2009-2011 by NEC Communication Systems, Ltd.
#  Copyright (C) 2009-2011 by FUJISOFT INCORPORATED
# 
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
# 
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
# 
#  $Id: sil_test.sh 2 2012-05-09 02:23:52Z nces-shigihara $
# 

# SILƥȥ˥塼
sil_test_main()
{
	if [ $USE_KERNEL_LIB = "true" ]
	then
		check_file_name=$KERNEL_LIB/libkernel.a
		check_file
		if [ $? -eq 1 ]
		then
			return
		fi
	fi
	while true
	do
		cat<<EOS

$DOUBLE_LINE
 $SIL_TEST_MENU
$DOUBLE_LINE
 1: $SIL_ALL_BUILD
 2: $SIL_MAKE_DIR
 3: $SIL_MAKE_DEPEND
 4: $SIL_MAKE_BUILD
 5: $SIL_MAKE_CLEAN
 6: $SIL_MAKE_REALCLEAN
 e: $RUN_EXEC_MODULE
 r: $BACK_TO_MAIN_MENU
 q: $EXIT_TOOL
$SINGLE_LINE
EOS
echo -n " $INPUT_NO "
		# ɤ߹
		read key
		# ɤ߹ˤäʬ
		case ${key} in
			1)
			 header_double "$SIL_ALL_BUILD"
			 dir_name=$SIL_TEST_ROOT
			 continuous_execute_for_sil_test
			 ;;
			2)
			 header_double "$SIL_MAKE_DIR"
			 dir_name=$SIL_TEST_ROOT
			 make_directory_for_sil_test
			 ;;
			3)
			 header_double "$SIL_MAKE_DEPEND"
			 rule=$RULE_DEPEND
			 dir_name=$SIL_TEST_ROOT
			 make_for_sil_test
			 ;;
			4)
			 header_double "$SIL_MAKE_BUILD"
			 rule=$RULE_BUILD
			 dir_name=$SIL_TEST_ROOT
			 make_for_sil_test
			 ;;
			5)
			 header_double "$SIL_MAKE_CLEAN"
			 rule=$RULE_CLEAN
			 dir_name=$SIL_TEST_ROOT
			 make_for_sil_test
			 ;;
			6)
			 header_double "$SIL_MAKE_REALCLEAN"
			 rule=$RULE_REALCLEAM
			 dir_name=$SIL_TEST_ROOT
			 make_for_sil_test
			 ;;
			e)
			 header_double "RUN_EXEC_MODULE"
			 kind="$SIL_TEST_MENU"
			 execute_module
			 ;;
			r)
			 go_main_flg=1
			 ;;
			q)
			 exit 0
			 ;;
			*)
			 echo " $key $ERR_INVALID_NO"
			 ;;
		esac
		if [ $go_main_flg -eq 1 ]
		then
			go_main_flg=0
			break
		fi
		
	done
}

# ե
make_directory_for_sil_test()
{
	rm -rf $OBJECT_DIR/$dir_name
	echo "$PRE_MAKE_DIRECTORY $dir_name $POST_MAKE_DIRECTORY"
	mkdir -p $OBJECT_DIR/$dir_name
	cd $OBJECT_DIR/$dir_name
	perl ../../../configure $CONFIG_TEST_PROGRAM "$INCLUDE_DIR" &> /dev/null
	cp -p $TTSP_DIR/$SIL_TEST_DIR/* .
	rename_scratch_program
	cd $TTSP_DIR
}

# MakefileѤμ¹
make_for_sil_test()
{
	check_dir_name=$OBJECT_DIR/$dir_name/
	check_dir
	if [ $? -eq 0 ]
	then
		cd $OBJECT_DIR/$dir_name/
		case $rule in
			$RULE_DEPEND)
			 check_file_name="$APPLI_NAME.c \
			                  $APPLI_NAME.h \
			                  $APPLI_NAME.cfg \
			                  $MAKE_FILE_NAME"
			 ;;
			$RULE_BUILD)
			 check_file_name="$APPLI_NAME.c \
			                  $APPLI_NAME.h \
			                  $APPLI_NAME.cfg \
			                  $MAKE_FILE_NAME"
			 ;;
			$RULE_CLEAN)
			 check_file_name="$MAKE_FILE_NAME"
			 ;;
			$RULE_REALCLEAM)
			 check_file_name="$MAKE_FILE_NAME"
			 ;;
		esac
		check_file
		make_for_common
	fi
	cd $TTSP_DIR

}

# եmake dependmake¹
continuous_execute_for_sil_test()
{
	rm -rf $OBJECT_DIR/$dir_name
	echo "$PRE_MAKE_DIRECTORY $dir_name $POST_MAKE_DIRECTORY"
	mkdir -p $OBJECT_DIR/$dir_name
	cd $OBJECT_DIR/$dir_name
	perl ../../../configure $CONFIG_TEST_PROGRAM "$INCLUDE_DIR" &> /dev/null
	cp -p $TTSP_DIR/$SIL_TEST_DIR/* .
	rename_scratch_program

	# make depend¹
	rule=$RULE_DEPEND
	check_file_name="$APPLI_NAME.c \
                     $APPLI_NAME.h \
                     $APPLI_NAME.cfg \
                     $MAKE_FILE_NAME"
	check_file
	if [ $? -ne 1 ]
	then
		make_for_common

		# make¹
		if [ $? -eq 0 ]
		then
			rule=$RULE_BUILD
			make_for_common
		else
			echo "$ERR_DEPEND_FAIL "$dir_name
		fi
	fi
	cd $TTSP_DIR
}

# 
sil_test_main
