#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Condition.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: Condition
  #     : pre_condition, post_conditionξ륯饹
  #===================================================================
  class Condition

    #=================================================================
    #   : ¹Ծ֤Υtrue
    #         ʤfalse֤
    #=================================================================
    def exist_task_running_fmp()
      @aRunning.each{ |aRunning|
        if (!aRunning.nil?())
          return true  # [Bool]¹Ծ֤Υ
        end
      }

      return false  # [Bool]¹Ծ֤Υʤ
    end

    #=================================================================
    #   : ư󥿥true
    #         ʤfalse֤
    #=================================================================
    def exist_nontask_activate_fmp()
      @aActivate.each{ |cActivate|
        if (!cActivate.nil?())
          return true  # [Bool]ư󥿥
        end
      }

      return false  # [Bool]ư󥿥ʤ
    end

    #=================================================================
    #   : ¹Υ֤
    #         (ACTIVATEʥ㳰ϢդƤϥ㳰֤)
    #=================================================================
    def get_running_fmp()
      aRunning = []
      @aTask.each{|nPrcid, sObjectID, cObjectInfo|
        if ((cObjectInfo.sObjectType == TSR_OBJ_TASK) && GRP_ACTIVATE.include?(cObjectInfo.hState[TSR_PRM_STATE]))
          if (!cObjectInfo.cTex.nil?() && GRP_ACTIVATE.include?(cObjectInfo.cTex.hState[TSR_PRM_HDLSTAT]))
            aRunning[nPrcid] = cObjectInfo.cTex
          else
            aRunning[nPrcid] = cObjectInfo
          end
        end
      }

      return aRunning  # [Array]¹Υ
    end

    #=================================================================
    #   : ¹󥿥֤
    #=================================================================
    def get_activate_fmp()
      aActivate = []

      @hAllObject.each{|sObjectID, cObjectInfo|
        if (GRP_NON_CONTEXT.include?(cObjectInfo.sObjectType) && GRP_ACTIVATE.include?(cObjectInfo.hState[TSR_PRM_HDLSTAT]))
          aActivate[cObjectInfo.hState[TSR_PRM_PRCID]] = cObjectInfo
        end
      }

      return aActivate  # [Array]¹󥿥
    end

    #=================================================================
    #   : CPU֤֤
    #=================================================================
    def get_cpu_state_fmp()
      aCpuState = []
      @hAllObject.each{|sObjectID, cObjectInfo|
        if (cObjectInfo.sObjectType[TSR_OBJ_CPU_STATE])
           aCpuState[cObjectInfo.hState[TSR_PRM_PRCID]] = cObjectInfo
        end
      }
      return aCpuState  # [Array]CPU
    end

    #=================================================================
    #   : ¹νñ̤֤
    #=================================================================
    def get_actvate_running_fmp()
      aProcUnitInfo = []

      @aPrcid.each{ |nPrcid|
        if (!@aActivate[nPrcid].nil?())
          aProcUnitInfo.push(@aActivate[nPrcid])
        elsif (!@aRunning[nPrcid].nil?())
          aProcUnitInfo.push(@aRunning[nPrcid])
        end
      }

      return aProcUnitInfo  # [Array]¹νñ
    end

    #=================================================================
    #   : ֥Ȥref
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_obj_ref_fmp()
      cElement      = IMCodeElement.new()

      # refCPU֡ѿʳϤ٤ƥᥤץåԤ
      hProcUnitInfo = get_proc_unit_info(@cActivate, @cRunning)

      # Ƚ
      sComment = String.new()
      if (@nSeqNum.nil?() && @nTimeTick.nil?())
        sComment = "#{TSR_LBL_PRE}"
      else
        sComment = "#{TSR_UNS_POST}#{@nSeqNum}_#{@nTimeTick}"
      end
      cElement.set_comment(hProcUnitInfo, sComment)

      @aPrcid.each{|nPrcid|
        # 㳰ACTIAVTEä硤texptn/exinfȰפƤ뤳Ȥǧ륳ɤ
        if (@aActivate[nPrcid].nil?() && !@aRunning[nPrcid].nil?() && @aRunning[nPrcid].sObjectType == TSR_OBJ_TASK_EXC)
          @aRunning[nPrcid].gc_assert_texptn_exinf(cElement, get_proc_unit_info(@aRunning[nPrcid]))
        end

        # ߥӥ롼ACTIAVTEä硤exinfȰפƤ뤳Ȥǧ륳ɤ
        if (!@aActivate[nPrcid].nil?() && @aActivate[nPrcid].sObjectType == TSR_OBJ_ISR)
          @aActivate[nPrcid].gc_assert_exinf(cElement, get_proc_unit_info(@aActivate[nPrcid]))
        end

        # ¹νñ̤ͤꤵ줿ѿСפƤ뤳Ȥǧ륳ɤ
        if (!@aActivate[nPrcid].nil?() && !@aActivate[nPrcid].hState[TSR_PRM_VAR].nil?())
          @aActivate[nPrcid].gc_assert_value(cElement, get_proc_unit_info(@aActivate[nPrcid]))
        elsif (!@aRunning[nPrcid].nil?() && !@aRunning[nPrcid].hState[TSR_PRM_VAR].nil?())
          @aRunning[nPrcid].gc_assert_value(cElement, get_proc_unit_info(@aRunning[nPrcid]))
        end
      }

      # ᥤץåCPU_STATEcpu_lockäƤ뤫򻲾
      bCpuLock = false
      if (!@cCpuState.nil?() && (@cCpuState.hState[TSR_PRM_LOCCPU] == true))
        bCpuLock = true
      end

      # ֥Ȥref_codeޤȤ
      @hAllObject.each{|sObjectID, cObjectInfo|
        case cObjectInfo.sObjectType
        when TSR_OBJ_CPU_STATE
          # ¾ץåCPU֤¾ץåμ¹Ծ֤νñ̤黲Ȥ
          nPrcid = cObjectInfo.hState[TSR_PRM_PRCID]

          if (!@aActivate[nPrcid].nil?())
            hTempInfo = get_proc_unit_info(@aActivate[nPrcid])
            cElement.set_comment(hTempInfo, "#{sComment} (CPU state)")
            cObjectInfo.gc_obj_ref(cElement, hTempInfo)
          # ᥤץåξϡ¹ΥʤƤᥤ󥿥Ȥ
          elsif (!@aRunning[nPrcid].nil?() || (nPrcid == @sMainPrcid))
            hTempInfo = get_proc_unit_info(@aRunning[nPrcid])
            cElement.set_comment(hTempInfo, "#{sComment} (CPU state)")
            cObjectInfo.gc_obj_ref(cElement, hTempInfo)
          end

        when TSR_OBJ_TASK_EXC
          # 㳰ϴϢդ줿ٻ߾֤ξ硤ȤǤʤ
          cTask = get_object_info(cObjectInfo.hState[TSR_PRM_TASK])
          if (cTask.hState[TSR_PRM_STATE] != KER_TTS_DMT)
            cObjectInfo.gc_obj_ref(cElement, hProcUnitInfo, check_activate_context(), bCpuLock)
          end

        # ֤򻲾ȤǤʤñ̤ξ硤⤷ʤ
        when TSR_OBJ_INTHDR, TSR_OBJ_ISR, TSR_OBJ_EXCEPTION, TSR_OBJ_INIRTN, TSR_OBJ_TERRTN

        else
          cObjectInfo.gc_obj_ref(cElement, hProcUnitInfo, check_activate_context(), bCpuLock)

        end
      }

      # ᥤץåΥåݥ
      cElement.set_checkpoint(hProcUnitInfo)

      return cElement  # [IMCodeElement]֥Ȥref
    end


    #=================================================================
    #   : BarrierSyncԤɤ֤
    #=================================================================
    def gc_barrier_sync()
      cElement      = IMCodeElement.new()
      aProcUnitInfo = [] 

      @aPrcid.each{ |nPrcid|
        if (nPrcid == @sMainPrcid)
          aProcUnitInfo.push(get_proc_unit_info(@cActivate, @cRunning))
        elsif (!@aActivate[nPrcid].nil?())
          aProcUnitInfo.push(get_proc_unit_info(@aActivate[nPrcid]))
        elsif (!@aRunning[nPrcid].nil?())
          aProcUnitInfo.push(get_proc_unit_info(@aRunning[nPrcid]))
        end
      }

      if (aProcUnitInfo.size > 1)
        cElement.set_barrier_sync(aProcUnitInfo)
      end

      return cElement  # [IMCodeElement]BarrierSyncԤ
    end

    #=================================================================
    #   : DoStartSyncԤɤ֤
    #=================================================================
    def gc_do_start_sync(cPrevCondition)
      check_class(Condition, cPrevCondition)  # Υǥ

      cElement = IMCodeElement.new()

      # doAPIȯԤץåʳˤơΥǥǤϼ¹Ծ֤ǡ
      # post_conditonǼ¹Ծ֤ǤϤʤʤ륿硤
      # doAPIȯԤޤǼ¹Ծ֤ΤޤޤȤ
      cPrevCondition.aRunning.each{|cObjectInfo|
        if (!cObjectInfo.nil?() && !@hDo.empty?())
          # doAPIȯԤ륪֥Ȥ֤ˤ
          cPreDoObjectInfo = cPrevCondition.get_object_info(@hDo[TSR_PRM_ID])

          # doAPIȯԤ륿ξϲ⤷ʤ
          if (cObjectInfo.hState[TSR_PRM_PRCID] == cPreDoObjectInfo.hState[TSR_PRM_PRCID])
            next
          end

          # ߤΥ֥Ⱦ
          cNowObjectInfo = get_object_info(cObjectInfo.sObjectID)

          # APIȯԸ˥åݥȤꤷ¹Ծ֤ΥϤΥåݥȤԵ
          if (!GRP_ACTIVATE.include?(cNowObjectInfo.hState[TSR_PRM_STATE]))
            # doAPIȯԤ륪֥Ȥθ֤ˤ
            cPostDoObjectInfo = get_object_info(@hDo[TSR_PRM_ID])

            # ֤APIȯԤñ̤¹Ծ֤Ǥʤʤϡ
            # ᥤץåμ¹Ծ֤νñ̤˥åݥȤ
            if (!GRP_ACTIVATE.include?(cPostDoObjectInfo.hState[TSR_PRM_STATE]))
              cElement.set_checkpoint(get_proc_unit_info(@cActivate, @cRunning))
            else
              cElement.set_checkpoint(get_proc_unit_info(cPostDoObjectInfo))
            end
            cElement.set_wait_check_sync(get_proc_unit_info(cObjectInfo), cPostDoObjectInfo.hState[TSR_PRM_PRCID])
          end
        end
      }

      # doAPIȯԤץåʳˤơΥǥǤϼ¹Ծ֤ǡ
      # post_conditonǼ¹Ծ֤ǤϤʤʤ󥿥硤
      # doAPIȯԤޤǼ¹Ծ֤ΤޤޤȤ
      cPrevCondition.aActivate.each{|cObjectInfo|
        if (!cObjectInfo.nil?() && !@hDo.empty?())
          # doAPIȯԤ륪֥Ȥ֤ˤ
          cPreDoObjectInfo = cPrevCondition.get_object_info(@hDo[TSR_PRM_ID])

          # doAPIȯԤ󥿥ξϲ⤷ʤ
          if (cObjectInfo.hState[TSR_PRM_PRCID] == cPreDoObjectInfo.hState[TSR_PRM_PRCID])
            next
          end

          # ߤΥ֥Ⱦ
          cNowObjectInfo = get_object_info(cObjectInfo.sObjectID)

          # APIȯԸ˥åݥȤꤷ¹Ծ֤󥿥ϤΥåݥȤԵ
          if (!GRP_ACTIVATE.include?(cNowObjectInfo.hState[TSR_PRM_HDLSTAT]))
            # doAPIȯԤ륪֥Ȥθ֤ˤ
            cPostDoObjectInfo = get_object_info(@hDo[TSR_PRM_ID])

            cElement.set_checkpoint(get_proc_unit_info(cPostDoObjectInfo))
            cElement.set_wait_check_sync(get_proc_unit_info(cObjectInfo), cPostDoObjectInfo.hState[TSR_PRM_PRCID])
          end
        end
      }

      return cElement  # [IMCodeElement]DoStartSyncԤ
    end

    #=================================================================
    #   : DoFinishSyncԤɤ֤
    #=================================================================
    def gc_do_finish_sync(cPrevCondition)
      check_class(Condition, cPrevCondition)  # Υǥ

      cElement = IMCodeElement.new()

      # ¾ץåˤơΥǥǤϼ¹Ծ֤ä
      # ǥѥåˤ¹Ծ֤ǤϤʤʤä硤
      # Υߤξ֤ˤʤޤԵ(refΤɤ)
      cPrevCondition.aRunning.each_with_index{|cObjectInfo, nPrcid|
        if (!cObjectInfo.nil?() && (nPrcid != @sMainPrcid))
          # ߤΥ֥Ⱦ
          cNowObjectInfo = get_object_info(cObjectInfo.sObjectID)

          # 㳰ξϡϢξФ
          if (cNowObjectInfo.sObjectType == TSR_OBJ_TASK_EXC)
            cNowObjectInfo = get_object_info(cNowObjectInfo.hState[TSR_PRM_TASK])
          end

          # оݥߤξ֤ˤʤޤStateSync
          if (!GRP_ACTIVATE.include?(cNowObjectInfo.hState[TSR_PRM_STATE]))
             cElement.set_state_sync(get_proc_unit_info(@cActivate, @cRunning), cNowObjectInfo.sObjectID, cNowObjectInfo.hState[TSR_PRM_STATE])
          end
        end
      }

      return cElement  # [IMCodeElement]DoFinishSyncԤ
    end

    #=================================================================
    #   : ֤ʤcElement˳Ǽ
    #=================================================================
    def gc_tick_gain_fmp(cElement, aNextActivate, cNextRunning, nGainTick)
      check_class(IMCodeElement, cElement)         # ɤɲä륨
      check_class(Array, aNextActivate)            # ΥǥACTIVATEǤ󥿥
      check_class(ProcessUnit, cNextRunning, true) # ΥǥRunningǤ륿
      check_class(Integer, nGainTick)              # ʤ

      hNowProcUnitInfo = get_proc_unit_info(@cRunning)
      hNextProcUnitInfo = get_proc_unit_info(cNextRunning)

      # ¾ץå˼ΥǥǵưACTIVATE󥿥¸ߤ硤
      # ᥤץåǵưԤ
      aPrcidProcUnitInfo = []
      aWaitPrcid = []
      @aPrcid.each{|nPrcid|
        if (!aNextActivate[nPrcid].nil?() && (nPrcid != @sMainPrcid))
          cNowObjectInfo = get_object_info(aNextActivate[nPrcid].sObjectID)
          # ưǧѥåݥ
          if (cNowObjectInfo.hState[TSR_PRM_HDLSTAT] == TSR_STT_STP)
            cElement.set_checkpoint(get_proc_unit_info(cNowObjectInfo))
            aPrcidProcUnitInfo.push([hNowProcUnitInfo, nPrcid])
            aWaitPrcid.push(nPrcid)
          else
            cElement.set_checkpoint(get_proc_unit_info(aNextActivate[nPrcid]))
            aPrcidProcUnitInfo.push([hNextProcUnitInfo, nPrcid])
            aWaitPrcid.push(nPrcid)
          end
        end
      }

      # 륿ξ硤¾ץåλ֤ʤǤᥤץåʤ
      if (@cConf.is_timer_local?())
        if (!aPrcidProcUnitInfo.empty?())
          (1..nGainTick).each{|nCnt|
            if (nCnt == nGainTick)
              # ¾ץåλ֤ʤƵư
              gc_tick_gain_local_other_fmp(cElement, aWaitPrcid)
              # ᥤץåǼ¹ΥǵưȤԤ
              aPrcidProcUnitInfo.each{|aPrcidProcUnitInfo|
                cElement.set_wait_check_sync(aPrcidProcUnitInfo[0], aPrcidProcUnitInfo[1])
              }
              # ᥤץåλ֤ʤƵư
              gc_tick_gain_local_main_fmp(cElement)
            else
              # λ֤ϡ礷ƿʤ
              gc_tick_gain_local_all_fmp(cElement)
            end
          }
        else
          # ᥤ󥿥Τߤξϡ礷ƻ֤ʤ
          nGainTick.times{
            gc_tick_gain_local_all_fmp(cElement)
          }
        end
      # Х륿ϻִץåΥƥåζΤ߹Ԥ
      else
        nGainTick.times{
          gc_tick_gain_global_fmp(cElement, aWaitPrcid)
        }

        # ¾ץåACTIVATE󥿥ᥤץåǼ¹ΥǵưȤԤ
        if (!aPrcidProcUnitInfo.empty?())
          aPrcidProcUnitInfo.each{|aPrcidProcUnitInfo|
            cElement.set_wait_check_sync(aPrcidProcUnitInfo[0], aPrcidProcUnitInfo[1])
          }
        end
      end
    end

    #=================================================================
    #   : ¹Խ뤿Ʊѥɤ֤
    #=================================================================
    def gc_exec_sequence_sync(cPrevCondition = nil)
      check_class(Condition, cPrevCondition, true)  # Υǥ

      cElement = IMCodeElement.new()

      @aPrcid.each{|nPrcid|
        # ACTIVATEʥ㳰ACTIVATE󥿥¸ߤ
        if (!@aActivate[nPrcid].nil?() && !@aRunning[nPrcid].nil?() && (@aRunning[nPrcid].sObjectType == TSR_OBJ_TASK_EXC))
          cElement.set_checkpoint(get_proc_unit_info(@aActivate[nPrcid]))
          cElement.set_wait_check_sync(get_proc_unit_info(@aRunning[nPrcid]), nPrcid)
          hRunningTask  = get_proc_unit_info(get_object_info(@aRunning[nPrcid].hState[TSR_PRM_TASK]))
          cElement.set_wait_check_sync(hRunningTask, nPrcid)

          # ACTIVATE󥿥Ѥäϡ󥿥鼡󥿥εưԤ
          if (!cPrevCondition.nil?() && !cPrevCondition.aActivate[nPrcid].nil?() &&
              (cPrevCondition.aActivate[nPrcid].sObjectID != @aActivate[nPrcid].sObjectID))
            cElement.set_wait_check_sync(get_proc_unit_info(cPrevCondition.aActivate[nPrcid]), nPrcid)
          end

        # ACTIVATE󥿥¸ߤ  Υץå˼¹Υ硤
        # ˽ʤޤʤ褦󥿥εưԤ
        elsif (!@aActivate[nPrcid].nil?() && !@aRunning[nPrcid].nil?())
          cElement.set_checkpoint(get_proc_unit_info(@aActivate[nPrcid]))
          cElement.set_wait_check_sync(get_proc_unit_info(@aRunning[nPrcid]), nPrcid)

          # ACTIVATE󥿥Ѥäϡ󥿥鼡󥿥εưԤ
          if (!cPrevCondition.nil?() && !cPrevCondition.aActivate[nPrcid].nil?() &&
              (cPrevCondition.aActivate[nPrcid].sObjectID != @aActivate[nPrcid].sObjectID))
            cElement.set_wait_check_sync(get_proc_unit_info(cPrevCondition.aActivate[nPrcid]), nPrcid)
          end

        # ACTIVATEʥ㳰¸ߤ硤¦ν˿ʤޤʤ褦㳰εưԤ
        elsif (!@aRunning[nPrcid].nil?() && (@aRunning[nPrcid].sObjectType == TSR_OBJ_TASK_EXC))
          cElement.set_checkpoint(get_proc_unit_info(@aRunning[nPrcid]))
          hRunningTask  = get_proc_unit_info(get_object_info(@aRunning[nPrcid].hState[TSR_PRM_TASK]))
          cElement.set_wait_check_sync(hRunningTask, nPrcid)
        end
      }

      return cElement  # [IMCodeElement]¹Խ뤿Ʊѥ
    end

    #=================================================================
    #   : ᥤץåλ֤ʤcElement˳Ǽ
    #         (륿)
    #=================================================================
    def gc_tick_gain_local_main_fmp(cElement)
      check_class(IMCodeElement, cElement)   # ɤɲä륨

      hProcUnitInfo = get_proc_unit_info(@cRunning)

      # ᥤץåϥ޳ߥϥɥνλԤ
      cElement.set_code(hProcUnitInfo, "#{FNC_GAIN_TICK_PE}(#{@sMainPrcid}, true)")
    end

    #=================================================================
    #   : ᥤץåʳλ֤ʤcElement˳Ǽ
    #         (륿)
    #=================================================================
    def gc_tick_gain_local_other_fmp(cElement, aWaitPrcid)
      check_class(IMCodeElement, cElement)  # ɤɲä륨
      check_class(Array, aWaitPrcid)        # 󥿥εưԤĥץåID

      hProcUnitInfo = get_proc_unit_info(@cRunning)

      # ֤ʤ˥åݥ
      cElement.set_checkpoint(hProcUnitInfo)

      # λֹλȤǧ
      cElement.set_code(hProcUnitInfo, "#{FNC_CHECK_TIMER_HANDLER}()")

      @aPrcid.each{ |nPrcid|
        if (nPrcid != @sMainPrcid)
          # 󥿥ưϥ޳ߥϥɥνλԤʤ
          if (aWaitPrcid.include?(nPrcid))
            cElement.set_code(hProcUnitInfo, "#{FNC_GAIN_TICK_PE}(#{nPrcid}, false)")
          else
            cElement.set_code(hProcUnitInfo, "#{FNC_GAIN_TICK_PE}(#{nPrcid}, true)")
          end
        end
      }
    end

    #=================================================================
    #   : ץåλ֤ʤcElement˳Ǽ
    #         (Х륿)
    #=================================================================
    def gc_tick_gain_local_all_fmp(cElement)
      check_class(IMCodeElement, cElement)  # ɤɲä륨

      hProcUnitInfo = get_proc_unit_info(@cRunning)

      cElement.set_code(hProcUnitInfo, "#{FNC_GAIN_TICK}()")
    end

    #=================================================================
    #   : ᥤץåλ֤ʤcElement˳Ǽ
    #         (Х륿)
    #=================================================================
    def gc_tick_gain_global_fmp(cElement, aWaitPrcid)
      check_class(IMCodeElement, cElement)  # ɤɲä륨
      check_class(Array, aWaitPrcid)        # 󥿥εưԤĥץåID

      hProcUnitInfo = get_proc_unit_info(@cRunning)

      nTimePrcid = @cConf.get_time_manage_prcid()

      # ִץå󥿥ưϥ޳ߥϥɥνλԤʤ
      if (aWaitPrcid.include?(nTimePrcid))
        cElement.set_code(hProcUnitInfo, "#{FNC_GAIN_TICK_PE}(#{nTimePrcid}, false)")
      else
        cElement.set_code(hProcUnitInfo, "#{FNC_GAIN_TICK_PE}(#{nTimePrcid}, true)")
      end
    end
  end
end
