#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: PreCondition.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: PreCondition
  #     : pre_conditionξ륯饹
  #===================================================================
  class PreCondition < Condition

    #=================================================================
    #   : ͥ٤Ƚͥ٤ۤʤ륿򸡺Ƥ
    #         true򡤤ʤfalse֤
    #=================================================================
    def exist_pre_task_pri_chg_fmp()
      @hTask.each{|sObjectID, cObjectInfo|
        if ((cObjectInfo.hState[TSR_PRM_STATE] != KER_TTS_RUN) &&
            (cObjectInfo.hState[TSR_PRM_STATE] != KER_TTS_DMT) &&
            (cObjectInfo.hState[TSR_PRM_STATE] != KER_TTS_RUS) &&
            (cObjectInfo.hState[TSR_PRM_TSKPRI] != cObjectInfo.hState[TSR_PRM_ITSKPRI]) &&
            !(!cObjectInfo.hState[TSR_PRM_WOBJID].nil?() && !GRP_WAIT_NON_OBJECT.include?(cObjectInfo.hState[TSR_PRM_WOBJID])))
          return true # [Bool]ͥ٤Ƚͥ٤ۤʤ륿
        end
      }

      return false # [Bool]ͥ٤Ƚͥ٤ۤʤ륿ʤ
    end

    #=================================================================
    #   : Ͼ֤Υ򸡺Ƥtrue
    #         ʤfalse֤
    #=================================================================
    def exist_pre_task_running_suspended_fmp()
      @hTask.each{|sObjectID, cObjectInfo|
        if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_RUS)
          return true # [Bool]Ͼ֤Υ
        end
      }

      return false # [Bool]Ͼ֤Υʤ
    end

    #=================================================================
    #   : оݥươᥤ󥿥ͥ٤򲼤
    #         cElement˳Ǽ
    #=================================================================
    def set_act_task_fmp(cElement, cObjectInfo)
      check_class(ProcessUnit, cObjectInfo) # оݥ饹

      hMainTaskInfo = get_proc_unit_info()

      # оݥư
      cElement.set_syscall(hMainTaskInfo, "#{API_MACT_TSK}(#{cObjectInfo.sObjectID}, #{cObjectInfo.hState[TSR_PRM_PRCID]})")

      # ᥤץåʤХᥤ󥿥ͥ٤򲼤ƥǥѥå
      if (cObjectInfo.hState[TSR_PRM_PRCID] == @sMainPrcid)
        cElement.set_syscall(hMainTaskInfo, "#{API_CHG_PRI}(#{TTG_TSK_SELF}, #{TTG_WAIT_PRI})")

        # оݥͥ٤TTG_WAIT_PRIƱä硤rot_rdqȯԤƥǥѥå
        if (cObjectInfo.hState[TSR_PRM_TSKPRI] == TTG_WAIT_PRI)
          cElement.set_syscall(hMainTaskInfo, "#{API_ROT_RDQ}(#{TTG_WAIT_PRI})")
        end
      end

    end
    private :set_act_task_fmp


    #=================================================================
    #   : Ʊ֥̿ȤˤԤ֥ν֤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_scobj_waiting_fmp()
      # 򥪥֥Ԥˤ륳ɥ֥å֤
      # ASP_dataqueue_rcv_dtq_f_2_1_1
      #   ᥤ󥿥TASK2򵯤㳰ϥɥ餬¸ߤ
      #   򤷡TASK2ʬsnd_dtq
      #   Ԥˤ(ԤˤʤäƤ륿ο)
      #   ʢץåνݤƤʤ
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      @hWaitObject.each{|sObjectID, cObjectInfo|
        # ԤΥꥹ
        if (!cObjectInfo.hState[TSR_PRM_WTSKLIST].nil?() && !cObjectInfo.hState[TSR_PRM_WTSKLIST].empty?())
          cObjectInfo.hState[TSR_PRM_WTSKLIST].each{|aWtskList|
            aWtskList.each_key{|sTaskID|
              cTaskInfo = @hTask[sTaskID]

              # оݥإǥѥå뤿Υ
              set_act_task_fmp(cElement, cTaskInfo)

              # оݥξåݥ
              hProcUnitInfo = get_proc_unit_info(cTaskInfo)
              cElement.set_checkpoint(hProcUnitInfo)

              case cObjectInfo.sObjectType
              when TSR_OBJ_SEMAPHORE
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  cElement.set_syscall(hProcUnitInfo, "#{API_WAI_SEM}(#{sObjectID})", nil)
                else
                  cElement.set_syscall(hProcUnitInfo, "#{API_TWAI_SEM}(#{sObjectID}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                end

              when TSR_OBJ_EVENTFLAG
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  # ѿꤵƤлѤ
                  if (aWtskList[sTaskID][TSR_PRM_VAR] != nil)
                    cElement.set_syscall(hProcUnitInfo, "#{API_WAI_FLG}(#{sObjectID}, #{aWtskList[sTaskID][TSR_VAR_WAIPTN]}, #{aWtskList[sTaskID][TSR_VAR_WFMODE]}, &#{aWtskList[sTaskID][TSR_PRM_VAR]})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_FLGPTN, TYP_FLGPTN)
                    cElement.set_syscall(hProcUnitInfo, "#{API_WAI_FLG}(#{sObjectID}, #{aWtskList[sTaskID][TSR_VAR_WAIPTN]}, #{aWtskList[sTaskID][TSR_VAR_WFMODE]}, &#{VAR_FLGPTN})", nil)
                  end
                else
                  # ѿꤵƤлѤ
                  if (aWtskList[sTaskID][TSR_PRM_VAR] != nil)
                    cElement.set_syscall(hProcUnitInfo, "#{API_TWAI_FLG}(#{sObjectID}, #{aWtskList[sTaskID][TSR_VAR_WAIPTN]}, #{aWtskList[sTaskID][TSR_VAR_WFMODE]}, &#{aWtskList[sTaskID][TSR_PRM_VAR]}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_FLGPTN, TYP_FLGPTN)
                    cElement.set_syscall(hProcUnitInfo, "#{API_TWAI_FLG}(#{sObjectID}, #{aWtskList[sTaskID][TSR_VAR_WAIPTN]}, #{aWtskList[sTaskID][TSR_VAR_WFMODE]}, &#{VAR_FLGPTN}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  end
                end

              when TSR_OBJ_MAILBOX
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  # ѿꤵƤлѤ
                  if (!aWtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_RCV_MBX}(#{sObjectID}, &#{aWtskList[sTaskID][TSR_PRM_VAR]})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_P_MSG, TYP_T_P_MSG)
                    cElement.set_syscall(hProcUnitInfo, "#{API_RCV_MBX}(#{sObjectID}, &#{VAR_P_MSG})", nil)
                  end
                else
                  # ѿꤵƤлѤ
                  if (!aWtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_TRCV_MBX}(#{sObjectID}, &#{aWtskList[sTaskID][TSR_PRM_VAR]}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_P_MSG, TYP_T_P_MSG)
                    cElement.set_syscall(hProcUnitInfo, "#{API_TRCV_MBX}(#{sObjectID}, &#{VAR_P_MSG}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  end
                end

              when TSR_OBJ_MEMORYPOOL
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  # ѿꤵƤлѤ
                  if (!aWtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_GET_MPF}(#{sObjectID}, &#{aWtskList[sTaskID][TSR_PRM_VAR]})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_BLK, TYP_VOID_P)
                    cElement.set_syscall(hProcUnitInfo, "#{API_GET_MPF}(#{sObjectID}, &#{VAR_BLK})", nil)
                  end
                else
                  # ѿꤵƤлѤ
                  if (!aWtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_TGET_MPF}(#{sObjectID}, &#{aWtskList[sTaskID][TSR_PRM_VAR]}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_BLK, TYP_VOID_P)
                    cElement.set_syscall(hProcUnitInfo, "#{API_TGET_MPF}(#{sObjectID}, &#{VAR_BLK}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  end
                end

              end

              if (cTaskInfo.hState[TSR_PRM_PRCID] == @sMainPrcid)
                # ᥤ󥿥ͥ٤᤹Υ
                set_chg_pri(cElement)
              else
                cElement.set_state_sync(get_proc_unit_info(), hProcUnitInfo[:id], KER_TTS_WAI)
              end

              # оݥθͥ٤Ƚͥ٤ۤʤ礳chg_pri
              # (Ʊ֥̿Ȥ°ͥٽäˡԤǤʤȽѤǽ)
              if (cTaskInfo.hState[TSR_PRM_TSKPRI] != cTaskInfo.hState[TSR_PRM_ITSKPRI])
                cElement.set_syscall(hMainTaskInfo, "#{API_CHG_PRI}(#{cTaskInfo.sObjectID}, #{cTaskInfo.hState[TSR_PRM_TSKPRI]})")
              end

              cElement.set_block_delimiter()
            }
          }
        end

        # ԤΥꥹ
        if (!cObjectInfo.hState[TSR_PRM_STSKLIST].nil?() && !cObjectInfo.hState[TSR_PRM_STSKLIST].empty?())
          cObjectInfo.hState[TSR_PRM_STSKLIST].each{|aStskList|
            aStskList.each{|sTaskID, hData|
              cTaskInfo = @hTask[sTaskID]

              # оݥإǥѥå뤿Υ
              set_act_task_fmp(cElement, cTaskInfo)

              # оݥξåݥ
              hProcUnitInfo = get_proc_unit_info(cTaskInfo)
              cElement.set_checkpoint(hProcUnitInfo)

              case cObjectInfo.sObjectType
              when TSR_OBJ_DATAQUEUE
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  cElement.set_syscall(hProcUnitInfo, "#{API_SND_DTQ}(#{sObjectID}, #{hData[hData.keys[0]]})", nil)
                else
                  cElement.set_syscall(hProcUnitInfo, "#{API_TSND_DTQ}(#{sObjectID}, #{hData[hData.keys[0]]}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                end

              when TSR_OBJ_P_DATAQUEUE
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  cElement.set_syscall(hProcUnitInfo, "#{API_SND_PDQ}(#{sObjectID}, #{hData[TSR_VAR_DATA]}, #{hData[TSR_VAR_DATAPRI]})", nil)
                else
                  cElement.set_syscall(hProcUnitInfo, "#{API_TSND_PDQ}(#{sObjectID}, #{hData[TSR_VAR_DATA]}, #{hData[TSR_VAR_DATAPRI]}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                end

              end

              if (cTaskInfo.hState[TSR_PRM_PRCID] == @sMainPrcid)
                # ᥤ󥿥ͥ٤᤹Υ
                set_chg_pri(cElement)
              else
                cElement.set_state_sync(get_proc_unit_info(), hProcUnitInfo[:id], KER_TTS_WAI)
              end

              # оݥθͥ٤Ƚͥ٤ۤʤ礳chg_pri
              # (Ʊ֥̿Ȥ°ͥٽäˡԤǤʤȽѤǽ)
              if (cTaskInfo.hState[TSR_PRM_TSKPRI] != cTaskInfo.hState[TSR_PRM_ITSKPRI])
                cElement.set_syscall(hMainTaskInfo, "#{API_CHG_PRI}(#{cTaskInfo.sObjectID}, #{cTaskInfo.hState[TSR_PRM_TSKPRI]})")
              end

              cElement.set_block_delimiter()
            }
          }
        end

        # ԤΥꥹ
        if (!cObjectInfo.hState[TSR_PRM_RTSKLIST].nil?() && !cObjectInfo.hState[TSR_PRM_RTSKLIST].empty?())
          cObjectInfo.hState[TSR_PRM_RTSKLIST].each{|aRtskList|
            aRtskList.each_key{|sTaskID|
              cTaskInfo = @hTask[sTaskID]

              # оݥإǥѥå뤿Υ
              set_act_task_fmp(cElement, cTaskInfo)

              # оݥξåݥ
              hProcUnitInfo = get_proc_unit_info(cTaskInfo)
              cElement.set_checkpoint(hProcUnitInfo)

              case cObjectInfo.sObjectType
              when TSR_OBJ_DATAQUEUE
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  # ѿꤵƤлѤ
                  if (!aRtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_RCV_DTQ}(#{sObjectID}, &#{aRtskList[sTaskID][TSR_PRM_VAR]})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_DATA, TYP_INTPTR_T)
                    cElement.set_syscall(hProcUnitInfo, "#{API_RCV_DTQ}(#{sObjectID}, &#{VAR_DATA})", nil)
                  end
                else
                  if (!aRtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_TRCV_DTQ}(#{sObjectID}, &#{aRtskList[sTaskID][TSR_PRM_VAR]}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  else
                    # ѿꤵƤлѤ
                    cElement.set_local_var(sTaskID, VAR_DATA, TYP_INTPTR_T)
                    cElement.set_syscall(hProcUnitInfo, "#{API_TRCV_DTQ}(#{sObjectID}, &#{VAR_DATA}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  end
                end

              when TSR_OBJ_P_DATAQUEUE
                # ֻ꤬ХॢդAPIѤ
                if (cTaskInfo.hState[TSR_PRM_LEFTTMO].nil?())
                  # ѿꤵƤлѤ
                  if (!aRtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_RCV_PDQ}(#{sObjectID}, &#{aRtskList[sTaskID][TSR_VAR_VARDATA]}, &#{aRtskList[sTaskID][TSR_VAR_VARPRI]})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_DATA, TYP_INTPTR_T)
                    cElement.set_local_var(sTaskID, VAR_DATAPRI, TYP_PRI)
                    cElement.set_syscall(hProcUnitInfo, "#{API_RCV_PDQ}(#{sObjectID}, &#{VAR_DATA}, &#{VAR_DATAPRI})", nil)
                  end
                else
                  # ѿꤵƤлѤ
                  if (!aRtskList[sTaskID].nil?())
                    cElement.set_syscall(hProcUnitInfo, "#{API_TRCV_PDQ}(#{sObjectID}, &#{aRtskList[sTaskID][TSR_VAR_VARDATA]}, &#{aRtskList[sTaskID][TSR_VAR_VARPRI]}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  else
                    cElement.set_local_var(sTaskID, VAR_DATA, TYP_INTPTR_T)
                    cElement.set_local_var(sTaskID, VAR_DATAPRI, TYP_PRI)
                    cElement.set_syscall(hProcUnitInfo, "#{API_TRCV_PDQ}(#{sObjectID}, &#{VAR_DATA}, &#{VAR_DATAPRI}, #{cTaskInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
                  end
                end

              end

              if (cTaskInfo.hState[TSR_PRM_PRCID] == @sMainPrcid)
                # ᥤ󥿥ͥ٤᤹Υ
                set_chg_pri(cElement)
              else
                cElement.set_state_sync(get_proc_unit_info(), hProcUnitInfo[:id], KER_TTS_WAI)
              end

              # оݥθͥ٤Ƚͥ٤ۤʤ礳chg_pri
              # (Ʊ֥̿Ȥ°ͥٽäˡԤǤʤȽѤǽ)
              if (cTaskInfo.hState[TSR_PRM_TSKPRI] != cTaskInfo.hState[TSR_PRM_ITSKPRI])
                cElement.set_syscall(hMainTaskInfo, "#{API_CHG_PRI}(#{cTaskInfo.sObjectID}, #{cTaskInfo.hState[TSR_PRM_TSKPRI]})")
              end

              cElement.set_block_delimiter()
            }
          }
        end
      }

      # Ԥֺ塤ᥤ󥿥äǥåݥ
      cElement.set_checkpoint(get_proc_unit_info())

      return cElement # [IMCodeElement]Ʊ֥̿ȤˤԤ֥ν֤ꥳ
    end


    #=================================================================
    #   : Ԥ֤Ǥ륿ν֤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_waiting_fmp()
      cElement = IMCodeElement.new()

      @aTask.each{ |nPrcid, sObjectID, cObjectInfo|
        if (GRP_WAIT_NON_OBJECT.include?(cObjectInfo.hState[TSR_PRM_WOBJID]))
          # оݥإǥѥå뤿Υ
          set_act_task_fmp(cElement, cObjectInfo)

          # оݥξåݥ
          hProcUnitInfo = get_proc_unit_info(cObjectInfo)
          cElement.set_checkpoint(hProcUnitInfo)

          if (cObjectInfo.hState[TSR_PRM_WOBJID] == TSR_STT_SLEEP)
            if (cObjectInfo.hState[TSR_PRM_LEFTTMO].nil?())
              cElement.set_syscall(hProcUnitInfo, "#{API_SLP_TSK}()", nil)
            else
              cElement.set_syscall(hProcUnitInfo, "#{API_TSLP_TSK}(#{cObjectInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
            end
          elsif (cObjectInfo.hState[TSR_PRM_WOBJID] == TSR_STT_DELAY)
            cElement.set_syscall(hProcUnitInfo, "#{API_DLY_TSK}(#{cObjectInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})", nil)
          end

          if (nPrcid == @sMainPrcid)
            # ᥤ󥿥ͥ٤᤹Υ
            set_chg_pri(cElement)
          else
            cElement.set_state_sync(get_proc_unit_info(), hProcUnitInfo[:id], KER_TTS_WAI)
          end
          # Ԥֺ塤ᥤ󥿥äǥåݥȤȥ֥åڤʬ
          cElement.set_checkpoint(get_proc_unit_info())
          cElement.set_block_delimiter()
        end
      }

      return cElement # [IMCodeElement]
    end


    #=================================================================
    #   : ٻ߾֤Ǥ륿ν֤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_dormant_fmp()
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      @aTask.each{|nPrcid, sObjectID, cObjectInfo|
        if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_DMT)
          cElement.set_migrate_task(hMainTaskInfo, sObjectID, nPrcid)
        end
      }

      return cElement # [IMCodeElement]ٻ߾֤Ǥ륿ν֤ꥳ
    end


    #=================================================================
    #   : ֤Ǥ륿ν֤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_suspended_fmp()
      # ᥤ󥿥sus_tsk(оݥ)
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      @aTask.each{|nPrcid, sObjectID, cObjectInfo|
        if (GRP_SUSPENDED.include?(cObjectInfo.hState[TSR_PRM_STATE]))  # TTS_SUSTTS_WAS
          hProcUnitInfo = get_proc_unit_info(cObjectInfo)
          if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_SUS)
            # оݥإǥѥå뤿Υ
            set_act_task_fmp(cElement, cObjectInfo)

            # оݥΥåݥ
            cElement.set_checkpoint(hProcUnitInfo)

            cElement.set_syscall(hProcUnitInfo, "#{API_SLP_TSK}()")

            if (nPrcid == @sMainPrcid)
              # ᥤ󥿥ͥ٤᤹Υ
              set_chg_pri(cElement)
            else
              cElement.set_state_sync(hMainTaskInfo, sObjectID, KER_TTS_WAI)
            end
          end

          cElement.set_syscall(hMainTaskInfo, "#{API_SUS_TSK}(#{sObjectID})")

          # Ԥξ硤ƴ
          if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_SUS)
            cElement.set_syscall(hMainTaskInfo, "#{API_WUP_TSK}(#{sObjectID})")
            # refʤ褦ԤȤʤäȤǧ
            cElement.set_state_sync(hMainTaskInfo, sObjectID, KER_TTS_SUS)
          end
          # Ԥֺ塤ᥤ󥿥äǥåݥȤȥ֥åڤʬ
          cElement.set_checkpoint(hMainTaskInfo)
          cElement.set_block_delimiter()
        end
      }

      return cElement # [IMCodeElement]֤Ǥ륿ν֤ꥳ
    end

    #=================================================================
    #   : ǥ֤Ǥ륿ν֤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_ready_fmp()
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      # ᥤ󥿥鵯ơslp_tskƤ
      @aTask.each{|nPrcid, sObjectID, cObjectInfo|
        if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_RDY)
          # оݥإǥѥå뤿Υ
          set_act_task_fmp(cElement, cObjectInfo)

          # оݥξåݥ
          hProcUnitInfo = get_proc_unit_info(cObjectInfo)
          cElement.set_checkpoint(hProcUnitInfo)

          cElement.set_syscall(hProcUnitInfo, "#{API_SLP_TSK}()")

          if (nPrcid == @sMainPrcid)
            # ᥤ󥿥ͥ٤᤹Υ
            set_chg_pri(cElement)
          else
            cElement.set_state_sync(get_proc_unit_info(), hProcUnitInfo[:id], KER_TTS_WAI)
          end
          # ᥤ󥿥äǥåݥȤȥ֥åڤʬ
          cElement.set_checkpoint(get_proc_unit_info())
          cElement.set_block_delimiter()
        end
      }

      return cElement # [IMCodeElement]ǥ֤Ǥ륿ν֤ꥳ
    end

    #=================================================================
    #   : ¹Ծ֤Ǥ륿㳰ν֤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_running_texhdr_activate_fmp()
      # ¹Ծ֤ˤʤ٤Υᥤ󥿥鵯
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      # ᥤץåǸꤹ
      # (¾ץå¹Ծ֤Ȥʤ˥ᥤ󤫤refΤɤ)
      aPrcid = []
      @aPrcid.each{ |nPrcid|
        if (nPrcid != @sMainPrcid)
          aPrcid.push(nPrcid)
        end
      }
      aPrcid.push(@sMainPrcid)

      aPrcid.each{|nPrcid|
        if (!@aRunning[nPrcid].nil?())
          # ξ
          if (@aRunning[nPrcid].sObjectType == TSR_OBJ_TASK)
            hProcUnitInfo = get_proc_unit_info(@aRunning[nPrcid])
            cElement.set_syscall(hMainTaskInfo, "#{API_MACT_TSK}(#{@aRunning[nPrcid].sObjectID}, #{@aRunning[nPrcid].hState[TSR_PRM_PRCID]})")
            # α㳰װꤹ
            if (!@aRunning[nPrcid].cTex.nil?() && 
                !@aRunning[nPrcid].cTex.hState[TSR_PRM_PNDPTN].nil?() && 
                @aRunning[nPrcid].cTex.hState[TSR_PRM_PNDPTN] != 0 &&
                @aRunning[nPrcid].cTex.hState[TSR_PRM_HDLSTAT] != TSR_STT_ACTIVATE)
              cElement.set_syscall(hMainTaskInfo, "#{API_RAS_TEX}(#{@aRunning[nPrcid].sObjectID}, #{@aRunning[nPrcid].cTex.hState[TSR_PRM_PNDPTN]})")
            end

            # ͥ٤Ƚͥ٤ۤʤꤹ
            if (@aRunning[nPrcid].hState[TSR_PRM_TSKPRI] != @aRunning[nPrcid].hState[TSR_PRM_ITSKPRI])
              cElement.set_syscall(hMainTaskInfo, "#{API_CHG_PRI}(#{@aRunning[nPrcid].sObjectID}, #{@aRunning[nPrcid].hState[TSR_PRM_TSKPRI]})")
            end

            # active_sync
            if (@aRunning[nPrcid].hState[TSR_PRM_PRCID] != @sMainPrcid)
              cElement.set_checkpoint(hProcUnitInfo)
              cElement.set_wait_check_sync(hMainTaskInfo, @aRunning[nPrcid].hState[TSR_PRM_PRCID])
            end

            cElement.set_block_delimiter()

          # 㳰ξ
          else
            hRunningTask  = get_proc_unit_info(get_object_info(@aRunning[nPrcid].hState[TSR_PRM_TASK]))
            hActivateTex  = get_proc_unit_info(@aRunning[nPrcid])

            # ¹Ծ֤Υư
            cElement.set_syscall(hMainTaskInfo, "#{API_MACT_TSK}(#{@aRunning[nPrcid].hState[TSR_PRM_TASK]}, #{@aRunning[nPrcid].hState[TSR_PRM_PRCID]})")

            # ¹Ծ֤Υ㳰ư
            cElement.set_syscall(hRunningTask, "#{API_RAS_TEX}(#{TTG_TSK_SELF}, #{@aRunning[nPrcid].hState[TSR_PRM_TEXPTN]})")

            # 㳰ľ֤TTEX_DISξ硤ena_texACTIVATEˤ
            if (@aRunning[nPrcid].hState[TSR_PRM_STATE] == TSR_STT_TTEX_DIS)
              cElement.set_syscall(hRunningTask, "#{API_ENA_TEX}()")
            # 㳰ľ֤TTEX_ENAξ硤ena_texƤ뤬㳰ư˺ena_tex
            else
              cElement.set_syscall(hActivateTex, "#{API_ENA_TEX}()")
            end

            # α㳰װѥ0Ǥʤ硤ʬras_tex
            if (@aRunning[nPrcid].hState[TSR_PRM_PNDPTN] != 0)
              cElement.set_syscall(hActivateTex, "#{API_RAS_TEX}(#{TTG_TSK_SELF}, #{@aRunning[nPrcid].hState[TSR_PRM_PNDPTN]})")
            end

            # active_sync
            if (@aRunning[nPrcid].hState[TSR_PRM_PRCID] != @sMainPrcid)
              cElement.set_checkpoint(hActivateTex)
              cElement.set_wait_check_sync(hMainTaskInfo, @aRunning[nPrcid].hState[TSR_PRM_PRCID])
            end

            cElement.set_block_delimiter()
          end
        end
      }

      return cElement # [IMCodeElement]¹Ծ֤Ǥ륿㳰ν֤ꥳ
    end

    #=================================================================
    #   : Ͼ֤Ǥ륿ν֤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_running_suspended_fmp()
      cElement = IMCodeElement.new()

      @aTask.each{|nPrcid, sObjectID, cObjectInfo|
        if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_RUS)
          # Ͼ֤Ǥ륿Ȥ鶯Ԥˤ
          hProcUnitInfo = get_proc_unit_info(@aActivate[nPrcid], @aRunning[nPrcid])
          cElement.set_syscall(hProcUnitInfo, "#{FNC_SUS_TSK}(#{sObjectID})")

          if (nPrcid == @sMainPrcid)
            cElement.set_block_delimiter()
          else
            # ¾ץåξ硤ᥤץåμ¹Ծ֤νñ̤ǧ
            cElement.set_state_sync(get_proc_unit_info(@cActivate, @cRunning), sObjectID, KER_TTS_RUS)
            cElement.set_block_delimiter()
          end
        end
      }

      return cElement # [IMCodeElement]Ͼ֤Ǥ륿ν֤ꥳ
    end

    #=================================================================
    #   : ư󥿥
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_nontask_activate_fmp()
      cElement      = IMCodeElement.new()
      hProcUnitInfo = get_proc_unit_info(@cRunning)

      # ʤ٤֤ݻ
      nGainTick = 0

      # ᥤץåǸꤷʤ󥿥εưˤäƽ
      # ³Ǥʤʤ뤿ᡤᥤץåǸ˰ư
      aPrcid = []
      @aPrcid.each{|nPrcid|
        if (nPrcid != @sMainPrcid)
          aPrcid.push(nPrcid)
        end
      }
      aPrcid.push(@sMainPrcid)

      aWaitPrcid = []
      aPrcid.each{|nPrcid|
        if (!@aActivate[nPrcid].nil?())
          case @aActivate[nPrcid].sObjectType
          # 顼ϥɥ
          when TSR_OBJ_ALARM
            # 0äꤷ1ߥÿʤ
            if (@cConf.is_timer_local?())
              cElement.set_syscall(hProcUnitInfo, "#{API_MSTA_ALM}(#{@aActivate[nPrcid].sObjectID}, 0, #{nPrcid})")
            else
              cElement.set_syscall(hProcUnitInfo, "#{API_STA_ALM}(#{@aActivate[nPrcid].sObjectID}, 0)")
            end
            # STA°мȤista_alm¹Ԥ
            if (@aActivate[nPrcid].hState[TSR_PRM_STATE] == TSR_STT_TALM_STA)
              cElement.set_syscall(get_proc_unit_info(@aActivate[nPrcid]), "#{API_ISTA_ALM}(#{@aActivate[nPrcid].sObjectID}, #{@aActivate[nPrcid].hState[TSR_PRM_LEFTTMO]})")
            end
            if (nGainTick < 1)
              nGainTick = 1
            end

          # ϥɥ
          when TSR_OBJ_CYCLE
            if (@cConf.is_timer_local?())
              cElement.set_syscall(hProcUnitInfo, "#{API_MSTA_CYC}(#{@aActivate[nPrcid].sObjectID}, #{nPrcid})")
            else
              cElement.set_syscall(hProcUnitInfo, "#{API_STA_CYC}(#{@aActivate[nPrcid].sObjectID})")
            end
            # ʬ֤ʤ
            if (nGainTick < @aActivate[nPrcid].hState[TSR_PRM_CYCPHS].to_i + 1)
              nGainTick = @aActivate[nPrcid].hState[TSR_PRM_CYCPHS].to_i + 1
            end

          # ߥϥɥ顤ߥӥ롼
          when TSR_OBJ_INTHDR, TSR_OBJ_ISR
            # ߥϥɥ顤ߥӥ롼󤬵ưƤץåǼ¹νñ̤
            cObjectInfo = aRunning[@aActivate[nPrcid].hState[TSR_PRM_PRCID]]
            hObjectInfo = get_proc_unit_info(cObjectInfo)
            # ȯؿ¹ԤƵư
            cElement.set_code(hObjectInfo, "#{FNC_INT_RAISE}(#{@aActivate[nPrcid].hState[TSR_PRM_INTNO]})")

          # CPU㳰ϥɥ
          when TSR_OBJ_EXCEPTION
            # CPU㳰ưƤץåǼ¹νñ̤
            cObjectInfo = aRunning[@aActivate[nPrcid].hState[TSR_PRM_PRCID]]
            hObjectInfo = get_proc_unit_info(cObjectInfo)
            # CPU㳰ȯؿ¹ԤƵư
            cElement.set_code(hObjectInfo, "#{FNC_CPUEXC_RAISE}(#{@aActivate[nPrcid].hState[TSR_PRM_EXCNO]})")

          else
            abort(ERR_MSG % [__FILE__, __LINE__])
          end

          # ưǧѥåݥ
          if (nPrcid != @sMainPrcid)
            cElement.set_checkpoint(get_proc_unit_info(@aActivate[nPrcid]))
            aWaitPrcid.push(nPrcid)
          end
        end
      }

      # 륿ξ硤¾ץåλ֤ʤǤᥤץåʤ
      if (@cConf.is_timer_local?())
        # ¾ץåACTIVATE󥿥¸ߤ
        if (!aWaitPrcid.empty?())
          (1..nGainTick).each{|nCnt|
            if (nCnt == nGainTick)
              # ¾ץåλ֤ʤƵư
              gc_tick_gain_local_other_fmp(cElement, aWaitPrcid)
              # ᥤץåǼ¹ΥǵưȤԤ
              aWaitPrcid.each{|nPrcid|
                cElement.set_wait_check_sync(hProcUnitInfo, nPrcid)
              }
              # ᥤץåλ֤ʤƵư
              gc_tick_gain_local_main_fmp(cElement)
            else
              # λ֤ϡ礷ƿʤ
              gc_tick_gain_local_all_fmp(cElement)
            end
          }
        else
          # ᥤ󥿥Τߤξϡ礷ƻ֤ʤ
          nGainTick.times{
            gc_tick_gain_local_all_fmp(cElement)
          }
        end
      # Х륿ϥƥåζΤ߹Ԥ
      else
        nGainTick.times{
          gc_tick_gain_global_fmp(cElement, aWaitPrcid)
        }

        # ¾ץåACTIVATE󥿥ᥤץåǼ¹ΥǵưȤԤ
        if (!aWaitPrcid.empty?())
          aWaitPrcid.each{|nPrcid|
            cElement.set_wait_check_sync(hProcUnitInfo, nPrcid)
          }
        end
      end

      return cElement # [IMCodeElement]ư󥿥ꥳ
    end


    #=================================================================
    #   : ǥѥåػߤˤ
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_dis_dsp_fmp()
      cElement = IMCodeElement.new()

      @aPrcid.each{ |nPrcid|
        if (@aRunning[nPrcid] != nil)
          if (!@aCpuState[nPrcid].nil?() && !@aCpuState[nPrcid].hState[TSR_PRM_DISDSP].nil?() && (@aCpuState[nPrcid].hState[TSR_PRM_DISDSP] == true))
            hProcUnitInfo = get_proc_unit_info(@aRunning[nPrcid])
            cElement.set_syscall(hProcUnitInfo, "#{API_DIS_DSP}()")
          end
        end
      }

      return cElement # [IMCodeElement]ǥѥåػߤˤ
    end


    #=================================================================
    #   : ͥ٥ޥ0ʳˤ
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_set_ipm_fmp()
      cElement = IMCodeElement.new()

      @aPrcid.each{ |nPrcid|
        # ͥ٥ޥꤵƤΤ
        if (!@aCpuState[nPrcid].nil?() &&
            !@aCpuState[nPrcid].hState[TSR_PRM_CHGIPM].nil?() &&
            (@aCpuState[nPrcid].hState[TSR_PRM_CHGIPM] != 0) && (@aCpuState[nPrcid].hState[TSR_PRM_CHGIPM] != KER_TIPM_ENAALL))

          # ʲΤ줫Τ߳ͥ٥ޥѹ
          # 1)ACTIVATE󥿥¸ߤʤ
          # 2)ACTIVATE󥿥CPU㳰ϥɥǤ
          if (@aActivate[nPrcid].nil?() || (@aActivate[nPrcid].sObjectType == TSR_OBJ_EXCEPTION))
            hProcUnitInfo = get_proc_unit_info(@aRunning[nPrcid])
            cElement.set_syscall(hProcUnitInfo, "#{API_CHG_IPM}(#{@aCpuState[nPrcid].hState[TSR_PRM_CHGIPM]})")
          end
        end
      }

      return cElement # [IMCodeElement]ͥ٥ޥ0ʳˤ
    end


    #=================================================================
    #   : ŪSLEEPޤDELAY¹Խ֤˵
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_ready_porder_fmp()
      # ꡼פƤporderǧ
      # ¹Բǽ֤ˤ

      # ¹Ծ֤Υ  ¹Ծ֤Υ
      # ¹Ծ֤Υʤ硧󥿥
      cElement  = IMCodeElement.new()  # element饹Ѱդ

      aPriorityTemp = []  # ̤ͥΤʤݻ뤿
      aPriOrderTemp = []  # ̤ͥΤ륿ݻ뤿

      @aTask.each{|nPrcid, sObjectID, cObjectInfo|
        if (cObjectInfo.hState[TSR_PRM_STATE] == KER_TTS_RDY)
          nPOrder = cObjectInfo.hState[TSR_PRM_PORDER]

          if (aPriorityTemp[nPrcid].nil?())
            aPriorityTemp[nPrcid] = []
          end
          if (aPriOrderTemp[nPrcid].nil?())
            aPriOrderTemp[nPrcid] = []
          end

          if (nPOrder.nil?())
            aPriorityTemp[nPrcid].push(sObjectID)
          else
            aPriOrderTemp[nPrcid][nPOrder] = sObjectID  # ̤ͥν
          end
        end
      }

      aPriOrderTemp.each{ |aPriPrc|
        if (!aPriPrc.nil?())
          aPriPrc.delete(nil)  # ɬפǤϤʤnilϺ
        end
      }

      @aPrcid.each{ |nPrcid|
        if (!aPriorityTemp[nPrcid].nil?())
          aPriOrderTemp[nPrcid].concat(aPriorityTemp[nPrcid])
        end
      }

      hProcUnitInfo = get_proc_unit_info(@cActivate, @cRunning)
      aPriOrderTemp.each{|aPriPrc|
        if (!aPriPrc.nil?())
          aPriPrc.each{|sObjectID|
            if (!@cActivate.nil?())
              cElement.set_syscall(hProcUnitInfo, "#{API_IWUP_TSK}(#{sObjectID})")
            else
              cElement.set_syscall(hProcUnitInfo, "#{API_WUP_TSK}(#{sObjectID})")
            end
          }
        end
      }

      cElement.set_checkpoint(hProcUnitInfo)

      return cElement # [IMCodeElement]ŪSLEEPޤDELAY¹Խ֤˵
    end


    #=================================================================
    #   : ư׵ᥭ塼󥰤򤹤
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_task_queueing_fmp()
      cElement      = IMCodeElement.new()  # element饹Ѱդ
      hProcUnitInfo = get_proc_unit_info(@cActivate, @cRunning)

      @aTask.each{|nPrcid, sObjectID, cObjectInfo|
        # ư׵ᥭ塼󥰤FMPǤ1
        if (!cObjectInfo.hState[TSR_PRM_ACTCNT].nil?() && cObjectInfo.hState[TSR_PRM_ACTCNT] == 1)
          # եץåIDmact_tskꤹ
          if (!cObjectInfo.hState[TSR_PRM_ACTPRC].nil?())
            if (!@cActivate.nil?())
              cElement.set_syscall(hProcUnitInfo, "#{API_IMACT_TSK}(#{sObjectID}, #{cObjectInfo.hState[TSR_PRM_ACTPRC]})")
            else
              cElement.set_syscall(hProcUnitInfo, "#{API_MACT_TSK}(#{sObjectID}, #{cObjectInfo.hState[TSR_PRM_ACTPRC]})")
            end
          else
            if (!@cActivate.nil?())
              cElement.set_syscall(hProcUnitInfo, "#{API_IACT_TSK}(#{sObjectID})")
            else
              cElement.set_syscall(hProcUnitInfo, "#{API_ACT_TSK}(#{sObjectID})")
            end
          end
        end

        if(!cObjectInfo.hState[TSR_PRM_WUPCNT].nil?() && cObjectInfo.hState[TSR_PRM_WUPCNT] >= 1)
          cObjectInfo.hState[TSR_PRM_WUPCNT].times{
            if (!@cActivate.nil?())
              cElement.set_syscall(hProcUnitInfo, "#{API_IWUP_TSK}(#{sObjectID})")
            else
              cElement.set_syscall(hProcUnitInfo, "#{API_WUP_TSK}(#{sObjectID})")
            end
          }
        end
      }

      cElement.set_checkpoint(hProcUnitInfo)

      return cElement # [IMCodeElement]ư׵ᥭ塼󥰤򤹤
    end


    #=================================================================
    #   : Υ।٥ȥϥɥꤹ륳ɤ֤
    #=================================================================
    def gc_pre_time_event_stp_other_fmp()
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()
      bFlg = false

      # եץåᥤץåǤʤΧޥ졼Ȥ
      @hAllObject.each{|sObjectID, cObjectInfo|
        if ((GRP_TIME_EVENT_HDL.include?(cObjectInfo.sObjectType) == true) &&
            (GRP_TIME_EVENT_STP.include?(cObjectInfo.hState[TSR_PRM_STATE]) == true) &&
            (cObjectInfo.hState[TSR_PRM_HDLSTAT] == TSR_STT_STP))
          if (cObjectInfo.sObjectType == TSR_OBJ_ALARM)
            cElement.set_syscall(hMainTaskInfo, "#{API_MSTA_ALM}(#{sObjectID}, #{TTG_ENOUGH_MIG_TIME}, #{cObjectInfo.hState[TSR_PRM_PRCID]})")
            cElement.set_syscall(hMainTaskInfo, "#{API_STP_ALM}(#{sObjectID})")
          elsif (cObjectInfo.sObjectType == TSR_OBJ_CYCLE)
            cElement.set_syscall(hMainTaskInfo, "#{API_MSTA_CYC}(#{sObjectID}, #{cObjectInfo.hState[TSR_PRM_PRCID]})")
            cElement.set_syscall(hMainTaskInfo, "#{API_STP_CYC}(#{sObjectID})")
          end

          bFlg = true
        end
      }

      cElement.set_checkpoint(hMainTaskInfo)

      if (bFlg == false)
        return nil # [nil]ɲäɬפʤ
      else
        return cElement # [IMCodeElement]Υ।٥ȥϥɥꤹ륳
      end
    end


    #=================================================================
    #   : ư(Txxx_STA)Υ।٥ȥϥɥꤹ
    #         ɤ֤
    #=================================================================
    def gc_pre_time_event_sta_fmp()
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      @hAllObject.each{|sObjectID, cObjectInfo|
        if ((GRP_TIME_EVENT_HDL.include?(cObjectInfo.sObjectType) == true) &&
            (GRP_TIME_EVENT_STA.include?(cObjectInfo.hState[TSR_PRM_STATE]) == true) &&
            (cObjectInfo.hState[TSR_PRM_HDLSTAT] != TSR_STT_ACTIVATE))
          if (cObjectInfo.sObjectType == TSR_OBJ_ALARM)
            if (@cConf.is_timer_local?())
              cElement.set_syscall(hMainTaskInfo, "#{API_MSTA_ALM}(#{sObjectID}, #{cObjectInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick}, #{cObjectInfo.hState[TSR_PRM_PRCID]})")
            else
              cElement.set_syscall(hMainTaskInfo, "#{API_STA_ALM}(#{sObjectID}, #{cObjectInfo.hState[TSR_PRM_LEFTTMO].to_i + @nPreGainTick})")
            end
          elsif (cObjectInfo.sObjectType == TSR_OBJ_CYCLE)
            if (@cConf.is_timer_local?())
              cElement.set_syscall(hMainTaskInfo, "#{API_MSTA_CYC}(#{sObjectID}, #{cObjectInfo.hState[TSR_PRM_PRCID]})")
            else
              cElement.set_syscall(hMainTaskInfo, "#{API_STA_CYC}(#{sObjectID})")
            end
          end
        end
      }

      cElement.set_checkpoint(hMainTaskInfo)

      return cElement # [IMCodeElement]ư(Txxx_STA)Υ।٥ȥϥɥꤹ륳
    end


    #=================================================================
    #   : ԥå֤(ꤵ줿ñ̤)
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_spin_loc_fmp()
      cElement = IMCodeElement.new()

      # ᥤץåλǧѥåݥ
      cElement.set_checkpoint(get_proc_unit_info(@cActivate, @cRunning))
      bFlg = false

      @hAllObject.each{|sObjectID, cObjectInfo|
        if ((cObjectInfo.sObjectType == TSR_OBJ_SPINLOCK) && (cObjectInfo.hState[TSR_PRM_SPNSTAT] == TSR_STT_TSPN_LOC))
          cObject = get_object_info(cObjectInfo.hState[TSR_PRM_PROCID])
          hProcUnitInfo = get_proc_unit_info(cObject)

          # ᥤץå¾νλȤԤäƤå
          # (CPUåȤʤȻ֤ʤʤ)
          cElement.set_wait_check_sync(hProcUnitInfo, @sMainPrcid)

          if (GRP_NON_CONTEXT.include?(cObject.sObjectType))
            cElement.set_syscall(hProcUnitInfo, "#{API_ILOC_SPN}(#{sObjectID})")
          else
            cElement.set_syscall(hProcUnitInfo, "#{API_LOC_SPN}(#{sObjectID})")
          end
          cElement.set_checkpoint(hProcUnitInfo)

          # ¾ץåξ硤ԥåȤᥤץåǤԤ
          # (refΤɤ)
          if (cObject.hState[TSR_PRM_PRCID] != @sMainPrcid)
            cElement.set_wait_check_sync(get_proc_unit_info(@cActivate, @cRunning), cObject.hState[TSR_PRM_PRCID])
          end

          # CPUåʣƼ¹ԤʤᡤݻƤ
          @aSpinProcID.push(cObject.sObjectID)

          bFlg = true
        end
      }

      if (bFlg == false)
        return nil # [nil]ɲäɬפʤ
      else
        return cElement # [IMCodeElement]ԥå֤(ꤵ줿ñ̤)
      end
    end


    #=================================================================
    #   : CPUå֤(¹νñ̤)
    #         IMCodeElement饹ˤޤȤ֤
    #=================================================================
    def gc_pre_cpu_loc_fmp()
      # ư֤󥿥硤顼ࡦϥɥξ
      # ϥ顼ˤ
      # ޤư֤󥿥ʤļ¹Ծ֤Υ
      # ϡˤ

      cElement = IMCodeElement.new()

      # ᥤץåλǧѥåݥ
      cElement.set_checkpoint(get_proc_unit_info(@cActivate, @cRunning))
      bFlg = false

      @aPrcid.each{ |nPrcid|
        # checkͤƹԤ
        if (!@aCpuState[nPrcid].nil?() && !@aCpuState[nPrcid].hState[TSR_PRM_LOCCPU].nil?() && (@aCpuState[nPrcid].hState[TSR_PRM_LOCCPU] == true))
          hProcUnitInfo = get_proc_unit_info(@aActivate[nPrcid], @aRunning[nPrcid])

          # ԥåˤCPUåϽ
          if (!@aSpinProcID.include?(hProcUnitInfo[:id]))
            # ᥤץå¾νλȤԤäƤå
            # (CPUåȤʤȻ֤ʤʤ)
            cElement.set_wait_check_sync(hProcUnitInfo, @sMainPrcid)
            bFlg = true

            if (!@aActivate[nPrcid].nil?())
              cElement.set_syscall(hProcUnitInfo, "#{API_ILOC_CPU}()")
            else
              cElement.set_syscall(hProcUnitInfo, "#{API_LOC_CPU}()")
            end
            cElement.set_checkpoint(hProcUnitInfo)
          end
        end
      }

      if (bFlg == false)
        return nil # [nil]ɲäɬפʤ
      else
        return cElement # [IMCodeElement]CPUå֤(¹νñ̤)
      end
    end

    #=================================================================
    #   : ľ֤γߤꤹ륳ɤ֤
    #=================================================================
    def gc_pre_interrupt_ena_fmp()
      cElement      = IMCodeElement.new()
      hMainTaskInfo = get_proc_unit_info()

      # ena_intɬפΤֹȥץåID
      aEnaIntNoID = []
      @hAllObject.each{|sObjectID, cObjectInfo|
        if ((GRP_INTERRUPT.include?(cObjectInfo.sObjectType) == true) &&
            (cObjectInfo.hState[TSR_PRM_STATE] == KER_TA_ENAINT))
          aEnaIntNoID.push([cObjectInfo.hState[TSR_PRM_INTNO], cObjectInfo.hState[TSR_PRM_PRCID]])
        end
      }

      # ʣƤ٤ena_int¹Ԥ
      nMainPrcid = @sMainPrcid
      aEnaIntNoID.uniq!()
      aEnaIntNoID.each{|snIntNoID|
        # ᥤ󥿥оIntHdr/ISRΥץåۤʤϥᥤ󥿥ư
        if (nMainPrcid != snIntNoID[1])
          cElement.set_syscall(hMainTaskInfo, "#{API_MIG_TSK}(#{TTG_TSK_SELF}, #{snIntNoID[1]})")
          nMainPrcid = snIntNoID[1]
        end

        cElement.set_syscall(hMainTaskInfo, "#{API_ENA_INT}(#{snIntNoID[0]})")
      }

      # Ǹɬᥤץå
      if (nMainPrcid != @sMainPrcid)
        cElement.set_syscall(hMainTaskInfo, "#{API_MIG_TSK}(#{TTG_TSK_SELF}, #{@sMainPrcid})")
      end

      cElement.set_checkpoint(hMainTaskInfo)

      return cElement # [IMCodeElement]ľ֤γߤꤹ륳
    end

  end
end
