#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: TestScenario.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: TestScenario
  #     : PreConditionDoPostConditionΥǡݻ
  #===================================================================
  class TestScenario

    #=================================================================
    #   : Ͼ֤Υ̵ͭǧ
    #=================================================================
    def exist_pre_task_running_suspended_fmp()
      return @cPreCondition.exist_pre_task_running_suspended_fmp()  # [Bool]Ͼ֤Υ̵ͭ
    end

    #=================================================================
    #   : ͥ٤Ƚͥ٤ۤʤ륿̵ͭǧ
    #=================================================================
    def exist_pre_task_pri_chg_fmp()
      return @cPreCondition.exist_pre_task_pri_chg_fmp()  # [Bool]ͥ٤Ƚͥ٤ۤʤ륿̵ͭ
    end

    #=================================================================
    #   : ¹Ծ֤Υ̵ͭǧ
    #=================================================================
    def exist_task_running_fmp(nIndex = nil)
      check_class(Integer, nIndex, true)  # do/postΥֹ

      if (nIndex.nil?())
        return @cPreCondition.exist_task_running_fmp()  # [Bool]¹Ծ֤Υ̵ͭ
      else
        return @aDo_PostCondition[nIndex].exist_task_running_fmp()  # [Bool]¹Ծ֤Υ̵ͭ
      end
    end

    #=================================================================
    #   : ư󥿥̵ͭǧ
    #=================================================================
    def exist_nontask_activate_fmp(nIndex = nil)
      check_class(Integer, nIndex, true)  # do/postΥֹ

      if (nIndex.nil?())
        return @cPreCondition.exist_nontask_activate_fmp()  # [Bool]ư󥿥̵ͭ
      else
        return @aDo_PostCondition[nIndex].exist_nontask_activate_fmp()  # [Bool]ư󥿥̵ͭ
      end
    end

    #=================================================================
    #   : ԥåԤ֤νñ̵̤ͭǧ
    #=================================================================
    def exist_wait_spinlock_fmp(nIndex)
      check_class(Integer, nIndex)  # do/postΥֹ

      return @aDo_PostCondition[nIndex].exist_wait_spinlock_fmp()  # [Bool]ԥåԤ֤νñ̵̤ͭ
    end

    #=================================================================
    #   : ٻ߾֤ΥΤΥɤ֤
    #=================================================================
    def gc_pre_task_dormant_fmp()
      return @cPreCondition.gc_pre_task_dormant_fmp()  # [IMCodeElement]ٻ߾֤ΥΤΥ
    end

    #=================================================================
    #   : ֥ԤΤΥɤ֤
    #=================================================================
    def gc_pre_task_scobj_waiting_fmp()
      return @cPreCondition.gc_pre_task_scobj_waiting_fmp()  # [IMCodeElement]֥ԤΤΥ
    end

    #=================================================================
    #   : Ԥ(꡼סǥ쥤)ΥȡԤ֤
    #         Ԥ֤Υꤹ륳ɤ֤
    #         Ԥ֤Ԥ(꡼סǥ쥤)ޤ
    #=================================================================
    def gc_pre_task_waiting_fmp()
      return @cPreCondition.gc_pre_task_waiting_fmp()  # [IMCodeElement]Ԥ֤Υꤹ륳
    end

    #=================================================================
    #   : ԤԤ֤ꤹ륳ɤ֤
    #         Ԥ֤ζԤޤ
    #=================================================================
    def gc_pre_task_suspended_fmp()
      return @cPreCondition.gc_pre_task_suspended_fmp()  # [IMCodeElement]ԤԤ֤ꤹ륳
    end

    #=================================================================
    #   : ¹Բǽ֤Υꤹ륳ɤ֤
    #         ºݤϵˡΧԤ֤ˤƤ
    #         (Ϥλǡ㳰ĤƤ)
    #=================================================================
    def gc_pre_task_ready_fmp()
      return @cPreCondition.gc_pre_task_ready_fmp()  # [IMCodeElement]¹Բǽ֤Υꤹ륳
    end

    #=================================================================
    #   : ¹Ծ֤Υ㳰򤹤륳ɤ֤
    #=================================================================
    def gc_pre_task_running_texhdr_activate_fmp()
      return @cPreCondition.gc_pre_task_running_texhdr_activate_fmp()  # [IMCodeElement]¹Ծ֤Υ㳰򤹤륳
    end

    #=================================================================
    #   : ư󥿥ꥳɤ֤
    #=================================================================
    def gc_pre_nontask_activate_fmp()
      return @cPreCondition.gc_pre_nontask_activate_fmp()  # [IMCodeElement]ư󥿥ꥳ
    end

    #=================================================================
    #   : ꡼פƤ¹Բǽ֤ˤ륳ɤ֤
    #=================================================================
    def gc_pre_task_ready_porder_fmp()
      return @cPreCondition.gc_pre_task_ready_porder_fmp()  # [IMCodeElement]꡼פƤ¹Բǽ֤ˤ륳
    end

    #=================================================================
    #   : ư׵ᥭ塼󥰤򤹤륳ɤ֤
    #=================================================================
    def gc_pre_task_queueing_fmp()
      return @cPreCondition.gc_pre_task_queueing_fmp()  # [IMCodeElement]ư׵ᥭ塼󥰤򤹤륳
    end

    #=================================================================
    #   : Υ।٥ȥϥɥꤹ륳ɤ֤
    #=================================================================
    def gc_pre_time_event_stp_other_fmp()
      return @cPreCondition.gc_pre_time_event_stp_other_fmp()  # [IMCodeElement]Υ।٥ȥϥɥꤹ륳
    end

    #=================================================================
    #   : ư֡Txxx_STAˤΥ।٥ȥϥɥꤹ
    #         ɤ֤
    #=================================================================
    def gc_pre_time_event_sta_fmp()
      return @cPreCondition.gc_pre_time_event_sta_fmp()  # [IMCodeElement]ư֡Txxx_STAˤΥ।٥ȥϥɥꤹ륳
    end

    #=================================================================
    #   : ǥѥåػߤˤ륳ɤ֤
    #=================================================================
    def gc_pre_dis_dsp_fmp()
      return @cPreCondition.gc_pre_dis_dsp_fmp()  # [IMCodeElement]ǥѥåػߤˤ륳
    end

    #=================================================================
    #   : ͥ٥ޥ0ʳˤ륳ɤ֤
    #=================================================================
    def gc_pre_set_ipm_fmp()
      return @cPreCondition.gc_pre_set_ipm_fmp()  # [IMCodeElement]ͥ٥ޥ0ʳˤ륳
    end

    #=================================================================
    #   : ԥå֤ꤹ륳ɤ֤
    #=================================================================
    def gc_pre_spin_loc_fmp()
      return @cPreCondition.gc_pre_spin_loc_fmp()  # [IMCodeElement]ԥå֤ꤹ륳
    end

    #=================================================================
    #   : CPUå֤ꤹ륳ɤ֤
    #=================================================================
    def gc_pre_cpu_loc_fmp()
      return @cPreCondition.gc_pre_cpu_loc_fmp()  # [IMCodeElement]CPUå֤ꤹ륳
    end

    #=================================================================
    #   : Ͼ֤ꤹ륳ɤ֤
    #=================================================================
    def gc_pre_task_running_suspended_fmp()
      return @cPreCondition.gc_pre_task_running_suspended_fmp()  # [IMCodeElement]Ͼ֤ꤹ륳
    end

    #=================================================================
    #   : ֥ref_code֤
    #=================================================================
    def gc_obj_ref_fmp(nIndex = nil)
      check_class(Integer, nIndex, true)  # do/postΥֹ

      if (nIndex.nil?())
        return @cPreCondition.gc_obj_ref_fmp()  # [IMCodeElement]֥ref_code
      else
        return @aDo_PostCondition[nIndex].gc_obj_ref_fmp()  # [IMCodeElement]֥ref_code
      end
    end

    #=================================================================
    #   : doΥɤ֤
    #=================================================================
    def gc_do_fmp(nIndex)
      check_class(Integer, nIndex)  # do/postΥֹ

      if (nIndex == 0)
        aPrevObjectInfo = @cPreCondition.get_actvate_running_fmp()
      else
        aPrevObjectInfo = @aDo_PostCondition[nIndex - 1].get_actvate_running_fmp()
      end

      return @aDo_PostCondition[nIndex].gc_do_fmp(aPrevObjectInfo)  # [IMCodeElement]doΥ
    end

    #=================================================================
    #   : ǥѥåǽˤ륳ɤ֤
    #=================================================================
    def gc_lastpost_ena_dsp_fmp()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_ena_dsp_fmp()  # [IMCodeElement]ǥѥåǽˤ륳
    end

    #=================================================================
    #   : ͥ٥ޥ륳ɤ֤
    #=================================================================
    def gc_lastpost_set_ini_ipm_fmp()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_set_ini_ipm_fmp()  # [IMCodeElement]ͥ٥ޥ륳
    end

    #=================================================================
    #   : ԥåΥɤ֤
    #=================================================================
    def gc_lastpost_spin_unl_fmp()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_spin_unl_fmp()  # [IMCodeElement]ԥåΥ
    end

    #=================================================================
    #   : CPUå֤βΥɤ֤
    #=================================================================
    def gc_lastpost_cpu_unl_fmp()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_cpu_unl_fmp()  # [IMCodeElement]CPUå֤βΥ
    end

    #=================================================================
    #   : ¾λ륳ɤ֤
    #=================================================================
    def gc_lastpost_all_task_ter_fmp()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_all_task_ter_fmp()  # [IMCodeElement]¾λ륳
    end

    #=================================================================
    #   : BarrierSyncԤɤ֤
    #=================================================================
    def gc_barrier_sync(nIndex = nil)
      check_class(Integer, nIndex, true)  # do/postΥֹ

      if (nIndex.nil?())
        return @cPreCondition.gc_barrier_sync()  # [IMCodeElement]BarrierSyncԤ
      else
        return @aDo_PostCondition[nIndex].gc_barrier_sync()  # [IMCodeElement]BarrierSyncԤ
      end
    end

    #=================================================================
    #   : DoStartSyncԤɤ֤
    #=================================================================
    def gc_do_start_sync(nIndex)
      check_class(Integer, nIndex)  # do/postΥֹ

      if (nIndex == 0)
        cPrev = @cPreCondition
      else
        cPrev = @aDo_PostCondition[nIndex - 1]
      end

      return @aDo_PostCondition[nIndex].gc_do_start_sync(cPrev)  # [IMCodeElement]DoStartSyncԤ
    end

    #=================================================================
    #   : DoFinishSyncԤɤ֤
    #=================================================================
    def gc_do_finish_sync(nIndex)
      check_class(Integer, nIndex)  # do/postΥֹ

      if (nIndex == 0)
        cPrev = @cPreCondition
      else
        cPrev = @aDo_PostCondition[nIndex - 1]
      end

      return @aDo_PostCondition[nIndex].gc_do_finish_sync(cPrev)  # [IMCodeElement]DoFinishSyncԤ
    end

    #=================================================================
    #   : Ǹrefλޤ¾ץåθߤƤ
    #         ƱԤɤ֤
    #=================================================================
    def gc_last_running_sync()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_last_running_sync()  # [IMCodeElement]Ǹrefλޤ¾ץåθߤƤƱԤ
    end

    #=================================================================
    #   : readyΥslp_tsk륳ɤ֤
    #=================================================================
    def gc_lastpost_ready_sleep_fmp()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_ready_sleep_fmp()  # [IMCodeElement]readyΥslp_tsk륳
    end

    #=================================================================
    #   : ֿʤ륳ɤ֤
    #=================================================================
    def gc_tick_gain_fmp(nIndex)
      check_class(Integer, nIndex)  # do/postΥֹ

      cElement = IMCodeElement.new()
      nGainTick = get_post_time(nIndex)

      @aDo_PostCondition[nIndex].gc_tick_gain_fmp(cElement, @aDo_PostCondition[nIndex + 1].aActivate, @aDo_PostCondition[nIndex + 1].cRunning, nGainTick)

      return cElement  # [IMCodeElement]ֿʤ륳
    end

    #=================================================================
    #   : ԥåԤΤٱ륳ɤ֤
    #=================================================================
    def gc_delay_wait_spin_fmp(nIndex)
      check_class(Integer, nIndex)  # do/postΥֹ

      # ᥤ󥿥ξ֤ϤΤޤޤȤ뤿ᡤϤ
      if (nIndex == 0)
        cPrevCondition = @cPreCondition
      else
        cPrevCondition = @aDo_PostCondition[nIndex - 1]
      end

      return @aDo_PostCondition[nIndex].gc_delay_wait_spin_fmp(cPrevCondition.lMainTaskState)  # [IMCodeElement]ԥåԤΤٱ륳
    end

    #=================================================================
    #   : ľ֤γߤꤹ륳ɤ֤
    #=================================================================
    def gc_pre_interrupt_ena_fmp()
      return @cPreCondition.gc_pre_interrupt_ena_fmp()  # [IMCodeElement]ľ֤γߤꤹ륳
    end

    #=================================================================
    #   : Ʊgcov_pauseѥɤ֤
    #=================================================================
    def gc_gcov_pause_after_sync(nIndex)
      check_class(Integer, nIndex)  # do/postΥֹ

      return @aDo_PostCondition[nIndex].gc_gcov_pause_after_sync()  # [IMCodeElement]Ʊgcov_pauseѥ
    end

    #=================================================================
    #   : ¹Խ뤿Ʊѥɤ֤
    #=================================================================
    def gc_exec_sequence_sync(nIndex = nil)
      check_class(Integer, nIndex, true)  # do/postΥֹ

      if (nIndex.nil?())
        # pre_conditionpost_conditionˤ¹ԽθФ褤
        return @cPreCondition.gc_exec_sequence_sync()  # [IMCodeElement]¹Խ뤿Ʊѥ
      end

      # post_conditionξ֤ACTIVATE󥿥̵ͭԤĽñ̤Ѥ
      if (nIndex == 0)
        cPrev = @cPreCondition
      else
        cPrev = @aDo_PostCondition[nIndex - 1]
      end

      return @aDo_PostCondition[nIndex].gc_exec_sequence_sync(cPrev)  # [IMCodeElement]¹Խ뤿Ʊѥ
    end

    #=================================================================
    #   : ػ߾֤γߤꤹ륳ɤ֤
    #=================================================================
    def gc_lastpost_interrupt_dis_fmp()
      return @aDo_PostCondition[TTG_IDX_LAST].gc_lastpost_interrupt_dis_fmp()  # [IMCodeElement]ػ߾֤γߤꤹ륳
    end

  end
end
