#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Dataqueue.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/sc_object/SCObject.rb"
require "ttc/bin/sc_object/Dataqueue.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: Dataqueue
  #     : ǡ塼ξ륯饹
  #===================================================================
  class Dataqueue < SCObject
    #=================================================================
    #   : ǡ塼ν
    #=================================================================
    def initialize(sObjectID, hObjectInfo, aPath, bIsPre)
      check_class(String, sObjectID)  # ֥ID
      check_class(Hash, hObjectInfo)  # ֥Ⱦ
      check_class(Array, aPath)       # 롼ȤΥѥ
      check_class(Bool, bIsPre)       # pre_condition⤫

      super(sObjectID, hObjectInfo, TSR_OBJ_DATAQUEUE, aPath, bIsPre)

      @sRefAPI       = FNC_REF_DTQ
      @sRefSWaitAPI  = FNC_REF_SWAIT_DTQ
      @sRefRWaitAPI  = FNC_REF_RWAIT_DTQ
      @sRefStrType   = TYP_T_TTSP_RDTQ
      @sRefStrVar    = GRP_VAR_TYPE[TYP_T_TTSP_RDTQ]
      @sRefAtr       = STR_DTQATR
      @sRefDataCnt   = STR_DTQCNT
      @sRefDataList  = STR_SDTQCNT
      @sRefSWaitList = STR_SWAITCNT
      @sRefRWaitList = STR_RWAITCNT
    end

    #=================================================================
    #   : եե˽Ϥ륳ɺ
    #=================================================================
    def gc_config(cElement)
      check_class(IMCodeElement, cElement) # 

      cElement.set_config("#{API_CRE_DTQ}(#{@sObjectID}, {#{@hState[TSR_PRM_ATR]}, #{@hState[TSR_PRM_DATACNT]}, NULL});", @hState[TSR_PRM_CLASS]) #[IMCodeElement] ǡ塼ŪAPI
    end
  end
end
