#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Graduate School of Information Science,
#                             Aichi Prefectural Univ., JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Do_PostCondition.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: Do_PostCondition
  #     : dopost_conditionξ륯饹
  #===================================================================
  class Do_PostCondition < Condition
    #=================================================================
    # : post_conditionι¤å
    #=================================================================
    def basic_post_check(hScenarioPost)
      check_class(Hash, hScenarioPost, true)  # post_condition

      # ֥Ȥι¤å
      if (hScenarioPost.is_a?(Hash))
        aErrors = []
        aPath = get_condition_path()
        hScenarioPost.each{|sObjectID, hObjectInfo|
          begin
            ### T1_019: post_conditionǾѲΤʤ֥ȤҤƤ
            if (hObjectInfo.nil?())
              sErr = sprintf("T1_019: " + ERR_OBJECT_NOCHANGE, sObjectID)
              aErrors.push(YamlError.new(sErr, aPath + [sObjectID]))
            else
              common_basic_check(sObjectID, hObjectInfo, aPath)
              ### T1_020: post_conditionΥ֥Ȥtype°Ƥ
              if (hObjectInfo.has_key?(TSR_PRM_TYPE))
                sErr = sprintf("T1_020: " + ERR_ONLY_PRE_ATR, TSR_PRM_TYPE)
                aErrors.push(YamlError.new(sErr, aPath + [sObjectID]))
              end
            end
          rescue TTCMultiError
            aErrors.concat($!.message())
          end
        }

        check_error(aErrors)
      end
    end

    #=================================================================
    # : °å(°ꤷå)
    #=================================================================
    def pre_attribute_check(hScenarioDo)
      check_class(Hash, hScenarioDo)  # do

      aPath       = get_do_path()
      aAtrDefList = get_do_attribute_list().keys()

      check_defined_attribute(hScenarioDo.keys(), aAtrDefList, aPath)
    end

    #=================================================================
    #   : °å
    #=================================================================
    def attribute_check()
      aErrors = []

      aPath = get_do_path()
      # ֥Ȥ°å
      begin
        super()
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      ### T3_DO001: syscallcodeꤵƤȯԸ֥IDҤƤʤ
      if ((!@hDo[TSR_PRM_SYSCALL].nil?() || !@hDo[TSR_PRM_CODE].nil?()) && @hDo[TSR_PRM_ID].nil?())
        sErr = sprintf("T3_DO001: " + ERR_REQUIRED_KEY, TSR_PRM_ID)
        aErrors.push(YamlError.new(sErr, aPath + [TSR_PRM_ID]))
      end

      ### T2: do°å
      check_do_attribute(@hDo, @aSpecifiedDoAttributes, aPath)

      check_error(aErrors)
    end

    #=================================================================
    #   : ǥå
    #=================================================================
    def condition_check()
      aErrors = []

      begin
        super()
      rescue TTCMultiError
        aErrors.concat($!.message())
      end

      # doΥå
      aPath = get_do_path()
      ### T4_036: docodeꤵƤͤꤵƤ
      if (!@hDo[TSR_PRM_CODE].nil?() && exist_error_code?())
        aErrors.push(YamlError.new("T4_036: " + ERR_SET_ERRCODE_SET_CODE, aPath))
      end
      ### T4_037: dosyscallcodeƱ˻ꤵƤ
      if (!@hDo[TSR_PRM_SYSCALL].nil?() && !@hDo[TSR_PRM_CODE].nil?())
        aErrors.push(YamlError.new("T4_037: " + ERR_SET_SYSCALL_AND_CODE, aPath))
      end

      # post_conditionΥå
      aPath = get_condition_path()
      # 롼󡤽λ롼Υå
      hObjects = get_objects_by_type([TSR_OBJ_INIRTN, TSR_OBJ_TERRTN])
      hObjects.each{|sObjectID, cObjectInfo|
        ### T4_005: 롼󡤽λ롼pre_conditionʳǻꤵƤ
        sErr = sprintf("T4_005: " + ERR_CANNNOT_DEFINED_IN_POST, cObjectInfo.sObjectType)
        aErrors.push(YamlError.new(sErr, aPath + [sObjectID]))
      }

      check_error(aErrors)
    end

    #=================================================================
    # : ǥƤΥޥִ
    #=================================================================
    def convert_macro()
      super()

      hMacro = @cConf.get_macro()
      @hDo.each{|sAtr, val|
        @hDo[sAtr] = calc_all_expr(@hDo[sAtr], hMacro)
      }
    end

    #=================================================================
    # : 䴰¹Ԥ
    #=================================================================
    def complement(cPrevCondition)
      check_class(Condition, cPrevCondition)  # ľΥǥ

      # gcovdoΤߡ
      if (!@hDo.empty?() && !@aSpecifiedDoAttributes.include?(TSR_PRM_GCOV))
        @hDo[TSR_PRM_GCOV] = true
      end

      cPrevCondition.hAllObject.each{|sObjectID, cObjectInfo|
        # 䴰ʤ֥Ȱʳ䴰¹
        unless (GRP_NOT_COMPLEMENT_TYPE.include?(cObjectInfo.sObjectType))
          # post˵ҤƤά줿°䴰
          unless (@hAllObject[sObjectID].nil?())
            @hAllObject[sObjectID].complement(cObjectInfo)
          # post_condition˵ҤƤʤpre_condition饳ԡ
          else
            cNewObjectInfo = cObjectInfo.dup()
            cNewObjectInfo.aSpecifiedAttributes = []
            cNewObjectInfo.set_path(get_condition_path() + [cNewObjectInfo.sObjectID])
            @hAllObject[sObjectID] = cNewObjectInfo
          end
        end
      }
    end

    #=================================================================
    # : ꥢ¹Ԥ
    #=================================================================
    def alias(hAlias)
      check_class(Hash, hAlias)   # ꥢѴơ֥

      # post_conditionΥꥢ
      super(hAlias)

      # doΥꥢ
      @hDo.each_key{|sAtr, val|
        @hDo[sAtr] = alias_replace(@hDo[sAtr], hAlias)
      }
    end

    #=================================================================
    # : doΥѥ֤
    #=================================================================
    def get_do_path()
      return [@sTestID, "#{TSR_UNS_DO}#{@nSeqNum}", @nTimeTick]  # [Array]doΥѥ
    end

    #=================================================================
    # : post_conditionΥѥ֤
    #=================================================================
    def get_condition_path()
      return [@sTestID, "#{TSR_UNS_POST}#{@nSeqNum}", @nTimeTick]  # [Array]post_conditionΥѥ
    end

    #=================================================================
    #   : ХбΤѥ᡼Ѵ¹Ԥ
    #=================================================================
    def convert_global(hTable, hClassTable)
      check_class(Hash, hTable)       # Ѵơ֥
      check_class(Hash, hClassTable)  # 饹ִбɽ

      super(hTable, hClassTable)

      # syscallcode
      [TSR_PRM_SYSCALL, TSR_PRM_CODE].each{|sAtr|
        if (@hDo[sAtr].is_a?(String))
          @hDo[sAtr] = convert_global_params(@hDo[sAtr], hTable)
        end
      }
    end

    #=================================================================
    #   : 顼ɤꤵƤ뤫֤
    #=================================================================
    def exist_error_code?()
      return (!@hDo[TSR_PRM_ERCD].nil?() || !@hDo[TSR_PRM_ERUINT].nil?() || !@hDo[TSR_PRM_BOOL].nil?())  # [Bool]顼ɤꤵƤ뤫
    end
  end
end
