#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Digital Craft Inc.
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: dictionary.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/CommonModule.rb"

#=====================================================================
# TTJModule
#=====================================================================
module TTJModule
  include CommonModule

  #===================================================================
  # Variation
  #===================================================================
  GRP_TTJ_VARIATION = {
    TSR_PRM_GAIN_TIME       => "ư",
    TSR_PRM_TIMER_ARCH      => "ޡƥ",
    TSR_PRM_ENA_EXC_LOCK    => "CPUåCPU㳰ȯ",
    TSR_PRM_IRC_ARCH        => "IRCƥ",
    TSR_PRM_GCOV_ALL        => "GCOV",
    TSR_PRM_SUPPORT_GET_UTM => "APIget_utm",
    TSR_PRM_SUPPORT_ENA_INT => "APIena_int",
    TSR_PRM_SUPPORT_DIS_INT => "APIdis_int"
  }

  #===================================================================
  # Condition
  #===================================================================
  GRP_TTJ_CONDITION = {
    TSR_LBL_VARIATION => "Хꥨ",
    TSR_LBL_PRE       => "",
    TSR_LBL_DO        => "",
    TSR_LBL_POST      => ""
  }

  #===================================================================
  # Object
  #===================================================================
  GRP_TTJ_OBJECT = [
    {TSR_OBJ_INIRTN      => "롼"        },
    {TSR_OBJ_TERRTN      => "λ롼"          },

    {TSR_OBJ_ALARM       => "顼ϥɥ"      },
    {TSR_OBJ_CYCLE       => "ϥɥ"          },
    {TSR_OBJ_TASK        => ""                },
    {TSR_OBJ_TASK_EXC    => "㳰롼"},

    {TSR_OBJ_EXCEPTION   => "CPU㳰ϥɥ"       },
    {TSR_OBJ_INTHDR      => "ߥϥɥ"        },
    {TSR_OBJ_ISR         => "ߥӥ롼"},

    {TSR_OBJ_SEMAPHORE   => "ޥե"              },
    {TSR_OBJ_EVENTFLAG   => "٥ȥե饰"        },
    {TSR_OBJ_DATAQUEUE   => "ǡ塼"          },
    {TSR_OBJ_P_DATAQUEUE => "ͥ٥ǡ塼"    },
    {TSR_OBJ_MAILBOX     => "᡼ܥå"        },
    {TSR_OBJ_MEMORYPOOL  => "Ĺס"    },
    {TSR_OBJ_SPINLOCK    => "ԥå"          },

    {TSR_OBJ_CPU_STATE   => "CPU"               }
  ]

  #===================================================================
  # Attribute
  #===================================================================
  GRP_TTJ_ATTRIBUTE = [
    # TTJID
    {TTJ_STT_ID       => TTJ_STT_ID                    },
    
    # ñ
    {TSR_PRM_TYPE     => ""                      },
    {TSR_PRM_ATR      => "°"                        },
    {TSR_PRM_EXINF    => "ĥ"                    },

    {TSR_PRM_STATE    => ""                        },
    {TSR_PRM_SPNSTAT  => ""                        },

    {TSR_PRM_HDLSTAT  => "¹Ծ"                    },
    {TSR_PRM_WOBJID   => "Ԥװ"                    },
    {TSR_PRM_LEFTTMO  => "ॢ"              },

    {TSR_PRM_ITSKPRI  => "ͥ"                  },
    {TSR_PRM_TSKPRI   => "ͥ"                      },

    {TSR_PRM_ACTCNT   => "ư׵ᥭ塼"        },
    {TSR_PRM_WUPCNT   => "׵ᥭ塼"        },
    {TSR_PRM_PORDER   => "ͥ"                    },
    {TSR_PRM_ACTPRC   => "ưդץå"  },
    {TSR_PRM_BOOTCNT  => "ư"                    },
    {TSR_PRM_PRCID    => "դץå"            },
    {TSR_PRM_VAR      => "ѿ"                        },

    {TSR_PRM_CYCATR   => "°"                        },
    {TSR_PRM_CYCTIM   => ""                        },
    {TSR_PRM_CYCPHS   => ""                        },

    {TSR_PRM_TASK     => "оݥID"                },
    {TSR_PRM_TEXPTN   => "㳰װ"              },
    {TSR_PRM_PNDPTN   => "α㳰װ"                },

    # Ʊ֥̿
    {TSR_PRM_MAXSEM   => "񸻿"                  },
    {TSR_PRM_ISEMCNT  => "񸻿"                  },
    {TSR_PRM_SEMCNT   => "߻񸻿"                  },

    {TSR_PRM_IFLGPTN  => "ӥåȥѥ"          },
    {TSR_PRM_FLGPTN   => "ߥӥåȥѥ"          },

    {TSR_PRM_DATACNT  => "ǼǤǡ"          },
    {TSR_PRM_MAXDPRI  => "ǡͥ٤κ"        },

    {TSR_PRM_MAXMPRI  => "åͥ٤κ"    },
    {TSR_PRM_MSGLIST  => "ԤåΥꥹ"  },

    {TSR_PRM_BLKCNT   => "Ǥ֥åν"  },
    {TSR_PRM_FBLKCNT  => "Ǥ֥åθ߿"  },
    {TSR_PRM_BLKSZ    => "֥åΥ"            },
    {TSR_PRM_MPF      => "ĹסƬ"},

    {TSR_PRM_WTSKLIST => "ԤΥꥹ"          },
    {TSR_PRM_STSKLIST => "ԤΥꥹ"      },
    {TSR_PRM_RTSKLIST => "ԤΥꥹ"      },
    {TSR_PRM_DATALIST => "ΰΥǡΥꥹ"    },

    {TSR_PRM_LOCCPU   => "CPUå"                   },
    {TSR_PRM_DISDSP   => "ǥѥåػ"            },
    {TSR_PRM_CHGIPM   => "ͥ٥ޥ"          },

    {TSR_PRM_SPINID   => "׵᥹ԥå"        },
    {TSR_PRM_PROCID   => ""                      },

    {TSR_PRM_EXCNO    => "㳰ֹ"                    },

    {TSR_PRM_INTNO    => "ֹ"                  },
    {TSR_PRM_INHNO    => "ߥϥɥֹ"          },
    {TSR_PRM_INTPRI   => "ͥ"                },

    {TSR_PRM_ISRPRI   => "ߥӥ롼ͥ"},

    {TSR_PRM_DO       => ""                        },
    {TSR_PRM_GLOBAL   => "Х"                  },

    {TSR_PRM_CLASS    => "°饹"                  }
  ]

  #===================================================================
  # Status
  #===================================================================
  GRP_TTJ_STATUS = {
    # ֥Ȥξ
    KER_TTS_RUN       => "¹",
    KER_TTS_RDY       => "¹Բǽ",
    KER_TTS_WAI       => "Ԥ",
    KER_TTS_SUS       => "Ԥ",
    KER_TTS_WAS       => "Ԥ",
    KER_TTS_RUS       => "Ԥ[¹Է³]",
    KER_TTS_DMT       => "ٻ",
    TSR_STT_R_WAITSPN => "ԥåԤ[¹Է³]",
    TSR_STT_A_WAITSPN => "ԥåԤ[¹Է³]",

    TSR_PRM_STATE => {
      TSR_OBJ_TASK     => "",
      TSR_OBJ_ALARM    => "ư",
      TSR_OBJ_CYCLE    => "ư",
      TSR_OBJ_TASK_EXC => "㳰ػߥե饰",
      TSR_OBJ_INTHDR   => "߶ػߥե饰",
      TSR_OBJ_ISR      => "߶ػߥե饰"
    },

    # 
    TSR_STT_TALM_STA  => "ư",
    TSR_STT_TALM_STP  => "",
    TSR_STT_TCYC_STA  => "ư",
    TSR_STT_TCYC_STP  => "",
    TSR_STT_TTEX_ENA  => "ľ",
    TSR_STT_TTEX_DIS  => "ػ߾",
    TSR_STT_TA_ENAINT => "ꥢ",
    TSR_STT_TA_DISINT => "å",
    TSR_STT_ACTIVATE  => "¹",
    TSR_STT_STP       => "",
    TSR_STT_SLEEP     => "Ԥ",
    TSR_STT_DELAY     => "ַвԤ",

    # °
    TSR_PRM_ATR => {
      KER_TA_NULL   => "֥°ꤷʤ",
      KER_TA_TPRI   => "Ԥ򥿥ͥٽˤ롥",
      KER_TA_WMUL   => "ʣԤĤΤ",
      KER_TA_CLR    => "Ԥ˥٥ȥե饰򥯥ꥢ롥",
      KER_TA_MPRI   => "å塼åͥٽˤ롥",
      KER_TA_STA    => "ϥɥ˼ϥɥưϤ롥",
      KER_TA_ENAINT => "׵ػߥե饰򥯥ꥢ롥",
      KER_TA_DISINT => "׵ػߥե饰򥻥åȤ롥"
    },

    TSR_PRM_SYSCALL => "ƥॳ",
    TSR_PRM_BOOL    => "ͥư",

    # trueζ
    TSR_STT_TRUE => {
      TSR_PRM_LOCCPU          => "å",
      TSR_PRM_DISDSP          => "ػ߾",
      TSR_PRM_GAIN_TIME       => "ֿʹ",
      TSR_PRM_ENA_EXC_LOCK    => "CPUåCPU㳰ȯ",
      TSR_PRM_DO              => "ͥư",
      TSR_PRM_GLOBAL          => {TSR_OBJ_INIRTN => "Х롼ˤ롥",
                                  TSR_OBJ_TERRTN => "Х뽪λ롼ˤ롥"},
      TSR_PRM_GCOV_ALL        => "٤Ƥν",
      TSR_PRM_GCOV            => "롥",
      TSR_PRM_SUPPORT_GET_UTM => "APIget_utm򥵥ݡȤ롥",
      TSR_PRM_SUPPORT_ENA_INT => "APIena_int򥵥ݡȤ롥",
      TSR_PRM_SUPPORT_DIS_INT => "APIdis_int򥵥ݡȤ롥"
    },

    # falseζ
    TSR_STT_FALSE => {
      TSR_PRM_LOCCPU          => "å",
      TSR_PRM_DISDSP          => "ػ߲",
      TSR_PRM_GAIN_TIME       => "",
      TSR_PRM_ENA_EXC_LOCK    => "CPUåCPU㳰ȯػ",
      TSR_PRM_DO              => "ͥư",
      TSR_PRM_GLOBAL          => {TSR_OBJ_INIRTN => "Х롼ˤʤ",
                                  TSR_OBJ_TERRTN => "Х뽪λ롼ˤʤ"},
      TSR_PRM_GCOV_ALL        => "νΤ߼",
      TSR_PRM_GCOV            => "ʤ",
      TSR_PRM_SUPPORT_GET_UTM => "APIget_utm򥵥ݡȤʤ",
      TSR_PRM_SUPPORT_ENA_INT => "APIena_int򥵥ݡȤʤ",
      TSR_PRM_SUPPORT_DIS_INT => "APIdis_int򥵥ݡȤʤ"
    },

    # ͥ٥ޥξ
    TSR_PRM_CHGIPM => {
      KER_TIPM_ENAALL => "",
      0               => ""
    },

    # variationΥޡȳߤξ
    TSR_PRM_TIMER_GLOBAL    => "Х",
    TSR_PRM_TIMER_LOCAL     => "",
    TSR_PRM_IRC_GLOBAL      => "Х",
    TSR_PRM_IRC_LOCAL       => "",
    TSR_PRM_IRC_COMBINATION => "Хȥ",

    # 㳰ξ
    TSR_STT_TTEX_DIS => "ػ߾",
    TSR_STT_TTEX_ENA => "ľ",

    # ԥåξ
    TSR_STT_TSPN_LOC => "Ƥ",
    TSR_STT_TSPN_UNL => "Ƥʤ",

    # ץå
    CFG_MCR_PRC_SELF    => "ץå",
    CFG_MCR_PRC_OTHER   => "¾ץå",
    CFG_MCR_PRC_OTHER_1 => "¾ץå_1",
    CFG_MCR_PRC_OTHER_2 => "¾ץå_2",

    # ٥ȥե饰Ԥ⡼
    KER_TWF_ORW  => "OR",
    KER_TWF_ANDW => "AND",

    # ѿ
    TYP_VOID_P      => "Ĺ֥åƬ(void*)",
    TYP_INTPTR_T    => "ݥ󥿤ǼǤդ(intptr_t)",
    TYP_PRI         => "ͥ(PRI)",
    TYP_ID          => "IDΰؤΥݥ(ID)",
    TYP_FLGPTN      => "٥ȥե饰Υӥåȥѥ(FLGPTN)",
    TYP_T_RALM      => "顼ϥɥθ߾֤ѥå(T_RALM)",
    TYP_T_RCYC      => "ϥɥθ߾֤ѥå(T_RCYC)",
    TYP_T_RTSK      => "θ߾֤ѥå(T_RTSK)",
    TYP_T_TTSP_RTSK => "θ߾֤ѥå(T_TTSP_RTSK)",
    TYP_T_RTEX      => "㳰θ߾֤ѥå(T_RTEX)",
    TYP_T_RSEM      => "ޥեθ߾֤ѥå(T_RSEM)",
    TYP_T_RFLG      => "٥ȥե饰θ߾֤ѥå(T_RFLG)",
    TYP_T_RDTQ      => "ǡ塼θ߾֤ѥå(T_RDTQ)",
    TYP_T_RPDQ      => "ͥ٥ǡ塼θ߾֤ѥå(T_RPDQ)",
    TYP_T_RMBX      => "᡼ܥåθ߾֤ѥå(T_RMBX)",
    TYP_T_RMPF      => "Ĺסθ߾֤ѥå(T_RMPF)",
    TYP_T_RSPN      => "ԥåθ߾֤򤤤ѥå(T_RSPN)",
    TYP_T_MSG       => "᡼ܥåΥåإå(T_MSG)",
    TYP_T_P_MSG     => "᡼ܥåΥåإåݥ(T_MSG*)",
    TYP_T_MSG_PRI   => "ͥդåإå(T_MSG_PRI)",
    TYP_SYSTIM      => "ƥΰ(SYSTIM)",
    TYP_SYSUTM      => "ƥΰ(SYSUTM)"
  }
end
