#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Digital Craft Inc.
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: Condition.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "ttj/bin/class/TTJModule.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: Condition
  #     : pre_condition, post_conditionξ륯饹
  #===================================================================
  class Condition
    include TTJModule

    #=================================================================
    # : pre_conditionޤpost_conditionγƥ֥Ȥξ
    #         ܸ첽塤ƤΥ֥ȤξĤʤ֤
    #=================================================================
    def japanize_condition_info(sAllCond, sIndent, sCondition)
      check_class(String, sAllCond)    # pre_conditionpost_conditionΥ٥
      check_class(String, sIndent)     # pre_conditionpost_conditionδܥǥ
      check_class(String, sCondition)  # pre_conditionpost_conditionξ

      @hExistState  = {}       # nil°State
      @sBlankIndent = sIndent  # °Ĺ׻ݤ˻Ȥǥ
      bChangeFlag   = false    # ֤ѲΤʤcondition򼨤

      # ֥IDǽϤ뤿֥ȤΥפ򥽡Ȥݻ
      aAllObject = hAllObject.keys()
      aAllObject = aAllObject.sort()

      # ֥Ƚ硤˥֥IDܸ첽»ܤ
      GRP_TTJ_OBJECT.each{|hObject|
        aAllObject.each{|sObjectID|
          if (hObject.keys[0] == hAllObject[sObjectID].sObjectType)
            sObjectType = hAllObject[sObjectID].sObjectType  # ֥ȤΥ
            sObjectID   = hAllObject[sObjectID].sObjectID    # ƥID

            # ͤnilǤʤ°Ф
            @hExistState = hAllObject[sObjectID].hState.reject{|key, val|
              hAllObject[sObjectID].aNilAttributes.include?(key)
            }

            # ѲΤʤpost_conditionܸ첽
            next if ((sCondition == TSR_LBL_POST) && (@hExistState.empty?() == true))

            # ܸ첽
            bChangeFlag = true
            sAllCond += japanize_condition(sObjectType, sObjectID)
          end
        }
      }

      # ֤ѲΤʤconditionξ
      if (bChangeFlag == false)
        sAllCond += "#{sIndent}#{TTJ_POST_EMPTY}#{TTJ_NEW_LINE}#{TTJ_NEW_LINE}"
      end

      # ꤵƤʤ֥ȤΥ顼
      aObjectErr= []

      GRP_TTJ_OBJECT.each{|hTTJObject|
        aObjectErr.push(hTTJObject.keys[0])  # ֥ȤΥפ
      }

      aAllObject.each{|sObjectID|
        # TESTYɤTTJ֥ȥޥӤƹʤϥ顼åȿǤ
        if (aObjectErr.include?(hAllObject[sObjectID].sObjectType) == false)
          $sAttrErr += "[#{sCondition}/#{sObjectID.gsub("#{@sTestID}_", "")} : #{hAllObject[sObjectID].sObjectType}] #{@sTestID}#{TTJ_NEW_LINE}"  # ꤵƤʤ֥ȤΥ顼
        end
      }

      return sAllCond  # [String]pre_conditionޤpost_conditionܸ첽ʸ
    end

    #=================================================================
    # : ƥ֥Ȥξܸ첽֤
    #=================================================================
    def japanize_condition(sObjectType, sObjectID)
      check_class(String, sObjectType)  # ֥ȤΥ
      check_class(String, sObjectID)    # ֥ȤID

      # IDtypeɲ
      @hExistState.store(TTJ_STT_ID,   sObjectID)
      @hExistState.store(TSR_PRM_TYPE, sObjectType)

      # Blank
      @nBlankSize = 1
      @hExistState.each_key{|key|
        if (key == TSR_PRM_STATE)
          blank_size(GRP_TTJ_STATUS[key][sObjectType])
        else
          blank_size($hTTJAttribute[key])
        end
      }

      sReturnState = ""

      # °ˤܸ첽򳫻Ϥ
      GRP_TTJ_ATTRIBUTE.each{|hAttribute|
        @hExistState.each{|key, val|
          if (hAttribute.keys[0] == key)
            case key
            when TTJ_STT_ID
              val = val.gsub("#{@sTestID}_", "")     # Alias
              sReturnState += "#{blank(hAttribute[key])}#{val}"  # ֥ȤID

            when TSR_PRM_TYPE
              GRP_TTJ_OBJECT.each{|hObject|  # dictionaryΥ֥ȽѴ
                if (hObject.keys[0] == val)
                  sReturnState += "#{blank(hAttribute[key])}#{hObject.values[0]}"  # ֥ȤID
                end
              }

            # ƥ֥Ȥstate
            when TSR_PRM_STATE
              sReturnState += "#{blank(GRP_TTJ_STATUS[key][sObjectType])}#{GRP_TTJ_STATUS[val]}"

            # ƥ֥Ȥ°
            when TSR_PRM_ATR
              sAtr = ""

              if (val.include?(KER_TA_NULL))
                sAtr += "#{GRP_TTJ_STATUS[TSR_PRM_ATR][KER_TA_NULL]}"
              else
                if (val.include?(KER_TA_TPRI))
                  sAtr += "#{GRP_TTJ_STATUS[TSR_PRM_ATR][KER_TA_TPRI]}#{TTJ_PAUSE}"
                end

                if (val.include?(KER_TA_WMUL))
                  sAtr += "#{GRP_TTJ_STATUS[TSR_PRM_ATR][KER_TA_WMUL]}#{TTJ_PAUSE}"
                end

                if (val.include?(KER_TA_CLR))
                  sAtr += "#{GRP_TTJ_STATUS[TSR_PRM_ATR][KER_TA_CLR]}#{TTJ_PAUSE}"
                end

                if (val.include?(KER_TA_MPRI))
                  sAtr += "#{GRP_TTJ_STATUS[TSR_PRM_ATR][KER_TA_MPRI]}#{TTJ_PAUSE}"
                end

                if (val.include?(KER_TA_STA))
                  sAtr += "#{GRP_TTJ_STATUS[TSR_PRM_ATR][KER_TA_STA]}#{TTJ_PAUSE}"
                end

                if (val.include?(KER_TA_ENAINT))
                  sAtr += "#{GRP_TTJ_STATUS[TSR_PRM_ATR][KER_TA_ENAINT]}#{TTJ_PAUSE}"
                end

                if (val.include?(KER_TA_DISINT))
                  sAtr += "#{GRP_TTJ_STATUS[TSR_PRM_ATR][KER_TA_DISINT]}#{TTJ_PAUSE}"
                end
              end

              sAtr = sAtr.gsub(/, \z/, "")
              sReturnState += "#{blank(hAttribute[key])}#{sAtr}"

            # Ԥװ
            when TSR_PRM_WOBJID
              if (GRP_TTJ_STATUS[val].nil?() == true)
                val = val.gsub("#{@sTestID}_", "")  # Alias
                sReturnState += "#{blank(hAttribute[key])}#{val}"
              else
                sReturnState += "#{blank(hAttribute[key])}#{GRP_TTJ_STATUS[val]}"
              end

            # cpuåǥѥå
            when TSR_PRM_LOCCPU, TSR_PRM_DISDSP
              sReturnState += "#{blank(hAttribute[key])}#{GRP_TTJ_STATUS[val][key]}"

            # ͥ٥ޥ
            when TSR_PRM_CHGIPM
              if (GRP_TTJ_STATUS[key][val].nil?() == true)
                sReturnState += "#{blank(hAttribute[key])}#{val}"
              else
                sReturnState += "#{blank(hAttribute[key])}#{GRP_TTJ_STATUS[key][val]}"
              end

            # Ԥꥹ
            when TSR_PRM_STSKLIST
              if (val.empty?() == false)
                sSendTaskList = ""

                val.each{|hVal|
                  sSendTaskList += "#{TTJ_BLOCK_OPEN}#{hVal.keys[0]}#{TTJ_PAUSE}#{hVal[hVal.keys[0]][TSR_VAR_DATA]}#{TTJ_BLOCK_CLOSE}#{TTJ_PAUSE}"
                }

                sSendTaskList = sSendTaskList.gsub(/, \z/, "")
                sSendTaskList = sSendTaskList.gsub("#{@sTestID}_", "")  # Alias
                sReturnState += "#{blank(hAttribute[key])}#{sSendTaskList}"
              else
                sReturnState += "#{blank(hAttribute[key])}#{TTJ_ATTR_EMPTY}"
              end

            # Ԥꥹ
            when TSR_PRM_RTSKLIST
              if (val.empty?() == false)
                sRcvTaskList = ""

                val.each{|hVal|
                  sRcvTaskList += "#{TTJ_BLOCK_OPEN}#{hVal.keys[0]}"

                  if ((hVal[hVal.keys[0]].nil?() == false) && (sObjectType == TSR_OBJ_DATAQUEUE))  # ǡ塼ξ
                    sRcvTaskList += "#{TTJ_PAUSE}#{hVal[hVal.keys[0]][TSR_VAR_VAR]}"
                  elsif ((hVal[hVal.keys[0]].nil?() == false) && (sObjectType == TSR_OBJ_P_DATAQUEUE))  # ͥ٥ǡ塼ξ
                    sRcvTaskList += "#{TTJ_PAUSE}#{hVal[hVal.keys[0]][TSR_VAR_VARPRI]}#{TTJ_PAUSE}#{hVal[hVal.keys[0]][TSR_VAR_VARDATA]}"
                  end

                  sRcvTaskList += "#{TTJ_BLOCK_CLOSE}#{TTJ_PAUSE}"
                }

                sRcvTaskList = sRcvTaskList.gsub(/, \z/, "")
                sRcvTaskList = sRcvTaskList.gsub("#{@sTestID}_", "")  # Alias
                sReturnState += "#{blank(hAttribute[key])}#{sRcvTaskList}"
              else
                sReturnState += "#{blank(hAttribute[key])}#{TTJ_ATTR_EMPTY}"
              end

            # ǡΰΥǡꥹ
            when TSR_PRM_DATALIST
              if (val.empty?() == false)
                sDataList = "#{TTJ_BLOCK_OPEN}"

                val.each{|hVal|
                  sDataList += "#{hVal[TSR_VAR_DATA]}"#{TTJ_PAUSE}"
                }

                sDataList += "#{TTJ_BLOCK_CLOSE}"
                sDataList = sDataList.gsub(/, \}/, TTJ_BLOCK_CLOSE)
                sReturnState += "#{blank(hAttribute[key])}#{sDataList}"
              else
                sReturnState += "#{blank(hAttribute[key])}#{TTJ_ATTR_EMPTY}"
              end

            # Ԥꥹ
            when TSR_PRM_WTSKLIST
              if (val.empty?() == false)
                sWaitTaskList = ""

                val.each{|hVal|
                  sWaitTaskList += "#{TTJ_BLOCK_OPEN}"

                  if (sObjectType == TSR_OBJ_SEMAPHORE)  # ޥեξ
                    sWaitTaskList += "#{hVal.keys[0]}"
                  elsif (sObjectType == TSR_OBJ_EVENTFLAG)  # ٥ȥե饰ξ
                    hVal.each{|wtlKey, wtlVal|
                      sWaitTaskList += "#{wtlKey}"
                      sWaitTaskList += "#{TTJ_PAUSE}#{wtlVal[TSR_VAR_WAIPTN]}"
                      sWaitTaskList += "#{TTJ_PAUSE}#{wtlVal[TSR_VAR_WFMODE]}"

                      if (wtlVal[TSR_VAR_VAR].nil?() == false)
                        sWaitTaskList += "#{TTJ_PAUSE}#{wtlVal[TSR_VAR_VAR]}"
                      end
                    }
                  elsif (sObjectType == TSR_OBJ_MAILBOX) ||  # ᡼ܥåξ
                        (sObjectType == TSR_OBJ_MEMORYPOOL)  #Ĺסξ
                    hVal.each{|wtlKey, wtlVal|
                      sWaitTaskList += "#{wtlKey}"

                      if (wtlVal.nil?() == false)
                        sWaitTaskList += "#{TTJ_PAUSE}#{wtlVal[TSR_VAR_VAR]}"
                      end
                    }
                  end

                  sWaitTaskList += "#{TTJ_BLOCK_CLOSE}#{TTJ_PAUSE}"
                }

                sWaitTaskList = sWaitTaskList.gsub(/, \z/, "")
                sWaitTaskList = sWaitTaskList.gsub("#{@sTestID}_", "")  # Alias
                sReturnState += "#{blank(hAttribute[key])}#{sWaitTaskList}"
              else
                sReturnState += "#{blank(hAttribute[key])}#{TTJ_ATTR_EMPTY}"
              end

            # åꥹ
            when TSR_PRM_MSGLIST
              if (val.empty?() == false)
                sMsgList = ""

                val.each{|hVal|
                  sMsgList += "#{TTJ_BLOCK_OPEN}#{hVal[TSR_VAR_MSG]}"

                  if (hVal[TSR_VAR_MSGPRI].nil?() == false)
                    sMsgList += "#{TTJ_PAUSE}#{hVal[TSR_VAR_MSGPRI]}"
                  end

                  sMsgList += "#{TTJ_BLOCK_CLOSE}#{TTJ_PAUSE}"
                }

                sMsgList = sMsgList.gsub(/, \z/, "")
                sMsgList = sMsgList.gsub("#{@sTestID}_", "")  # Alias
                sReturnState += "#{blank(hAttribute[key])}#{sMsgList}"
              else
                sReturnState += "#{blank(hAttribute[key])}#{TTJ_ATTR_EMPTY}"
              end

            # ѿ
            when TSR_PRM_VAR
              sVar = ""

              # ѿβԤˤ륤ǥȷ׻
              sVarBlank     = blank(hAttribute[key])
              nVarTabCount  = sVarBlank.count("\t")
              sVarBlank     = sVarBlank.gsub(TTJ_TAB, "")
              nVarBlankSize = sVarBlank.size()
              sVarBlank     = "#{(TTJ_TAB * nVarTabCount)}#{(TTJ_BLINK_INDEX * nVarBlankSize)}"

              val.each_value{|cVarInfo|
                if (cVarInfo.hMember.nil?() == false)  # ¤Τξ(ref)
                  sVar += "#{cVarInfo.sVarName}#{TTJ_PAUSE}#{GRP_TTJ_STATUS[cVarInfo.sType]}#{TTJ_NEW_LINE}"  # ѿ̾ѿΥ

                  # ¤Τ°Υǥ
                  nBlankSizeTemp = 1

                  cVarInfo.hMember.each_key{|blankSizeKey|
                    if (nBlankSizeTemp < blankSizeKey.size())
                      nBlankSizeTemp = blankSizeKey.size()
                    end
                  }

                  # ¤Τܸ첽
                  GRP_TTJ_STRUCT_SEQUENCE.each{|sStruct|
                    cVarInfo.hMember.each{|memKey, memVal|
                      if (sStruct == memKey)
                        sVar += "#{sVarBlank}#{TTJ_BLOCK_OPEN}#{memKey}#{(TTJ_BLINK_INDEX * (nBlankSizeTemp - memKey.size()))}#{TTJ_PARTITION}#{memVal}#{TTJ_BLOCK_CLOSE}#{TTJ_NEW_LINE}"  # ¤Τ
                      end

                      if (GRP_TTJ_STRUCT_SEQUENCE.include?(memKey) == false)
                        $sAttrErr += "Struct [#{sObjectType} : #{memKey}] #{@sTestID}#{TTJ_NEW_LINE}"  # ꤵƤʤ°Υ顼
                      end
                    }
                  }

                  sVar[sVar.rindex(TTJ_NEW_LINE)] = ""  # ǸβԤ
                  sVar = sVar.gsub(/, \}/, TTJ_BLOCK_CLOSE)
                else
                  # valʣξϳ̤ǰϤǶ̤
                  if (val.size() > 1)
                    sVar += "#{TTJ_BLOCK_OPEN}"
                  end

                  sVar += "#{cVarInfo.sVarName}#{TTJ_PAUSE}#{GRP_TTJ_STATUS[cVarInfo.sType]}"  # ѿ̾ѿΥ

                  if (cVarInfo.snValue.nil?() == false)
                    sVar += "#{TTJ_PAUSE}#{cVarInfo.snValue}"  # ѿ
                  end

                  # valʣξϳ̤ǰϤǶ̤
                  if (val.size() > 1)
                    sVar += "#{TTJ_BLOCK_CLOSE}"
                  end

                  sVar += "#{TTJ_NEW_LINE}#{sVarBlank}"
                end
              }

              sVar = sVar.gsub(/, \z/, "")
              sVar = sVar.gsub(/#{TTJ_NEW_LINE}#{sVarBlank}\z/, "")
              sVar = sVar.gsub("#{@sTestID}_", "")  # Alias
              sReturnState += "#{blank(hAttribute[key])}#{sVar}"

            # sns_kerdo
            when TSR_PRM_DO
              sVar = ""

              sDoIndent = "#{@sBlankIndent}#{(TTJ_BLINK_INDEX * (blank(hAttribute[key]).size() - 1))}"
              sVar = japanize_do(blank(hAttribute[key]), sDoIndent, val)

              sReturnState += "#{sVar}"

            # sns_kerglobal
            when TSR_PRM_GLOBAL
              sReturnState += "#{blank(hAttribute[key])}#{GRP_TTJ_STATUS[val][key][@hExistState[TSR_PRM_TYPE]]}"

            # ΰʳ°ܸѴ(Ӥνפʤ°)
            else
              # val : prcid, wupcnt, tskpri, actprc, actcnt, bootcnt, pndptn, itskpri, cyctim,
              #           cycphs, exinf, texptn, procid, class, spinid, excno, intno, inhno, intpri
              #           maxsem, isemcnt, semcnt, maxmpri, flgptn, iflgptn, dtqcnt, maxdpri, pdqcnt,
              #           fblkcnt, blkcnt, lefttim, porder, lefttmo, blksz
              # GRP_TTJ_STATUS[val]task
              if (GRP_TTJ_STATUS[val].nil?())
                val = val.to_s.gsub("#{@sTestID}_", "")  # Alias
                sReturnState += "#{blank(hAttribute[key])}#{val}"
              elsif ((val == TSR_STT_TRUE) || (val == TSR_STT_FALSE))
                $sAttrErr += "[#{sObjectType} : #{key}°#{val}] #{@sTestID}#{TTJ_NEW_LINE}"  # ꤵƤʤ°Υ顼
              else
                sReturnState += "#{blank(hAttribute[key])}#{GRP_TTJ_STATUS[val]}"
              end
            end

            sReturnState += "#{TTJ_NEW_LINE}"
          end
        }
      }

      # ꤵƤʤ°Υ顼
      aAttrErr= []

      GRP_TTJ_ATTRIBUTE.each{|hAttribute|
        aAttrErr.push(hAttribute.keys[0])
      }

      @hExistState.each{|key, val|
        if (aAttrErr.include?(key) == false)
          $sAttrErr += "[#{sObjectType} : #{key}] #{@sTestID}#{TTJ_NEW_LINE}"  # ꤵƤʤ°Υ顼
        end
      }

      # ƥ֥Ȥβ
      sReturnState += "#{TTJ_NEW_LINE}"

      return sReturnState  # [String]ƥ֥Ȥܸ첽ʸ
    end

    #=================================================================
    # : doξܸ첽֤
    #=================================================================
    def japanize_do(sAllDo, sIndent, hVal = nil)
      check_class(String, sAllDo)    # doݻƤ
      check_class(String, sIndent)   # doδܥǥ
      check_class(Hash, hVal, true)  # doƤФ줺sns_kerƤФ줿

      # doνܸ첽
      if (hVal.nil?() == true)
        hDoInfo = @hDo
        sAllDo += "#{sIndent}#{hDoInfo[TSR_PRM_ID]}"
      else
        hDoInfo = hVal  # sns_kerΥ֥doν
      end

      if (hDoInfo[TSR_PRM_CODE].nil?() == false)  # code
        sAllDo += "#{hDoInfo[TSR_PRM_CODE]}¹Ԥ롥"
      elsif (hDoInfo[TSR_PRM_ERUINT].nil?() == false)  # eruint
        if (hDoInfo[TSR_PRM_ERUINT].is_a?(Integer) == false)  # eruint顼ɤξ
          sAllDo += "#{hDoInfo[TSR_PRM_SYSCALL]}ȯԤ#{TTJ_NEW_LINE}"
          sAllDo += "#{sIndent}顼ɤȤ#{hDoInfo[TSR_PRM_ERUINT]}֤롥"
        else
          sAllDo += "#{hDoInfo[TSR_PRM_SYSCALL]}ȯԤ#{TTJ_NEW_LINE}"
          sAllDo += "#{sIndent}塼󥰿Ȥ#{hDoInfo[TSR_PRM_ERUINT]}֤롥"
        end
      elsif (hDoInfo[TSR_PRM_BOOL].nil?() == false)  # bool
        sAllDo += "#{hDoInfo[TSR_PRM_SYSCALL]}ȯԤ#{TTJ_NEW_LINE}"
        sAllDo += "#{sIndent}ȷ̤Ȥ#{hDoInfo[TSR_PRM_BOOL]}֤롥"
      elsif (hDoInfo[TSR_PRM_ERCD].nil?() == false)  # ercd
        sAllDo += "#{hDoInfo[TSR_PRM_SYSCALL]}ȯԤ#{TTJ_NEW_LINE}"
        sAllDo += "#{sIndent}顼ɤȤ#{hDoInfo[TSR_PRM_ERCD]}֤롥"
      else
        sAllDo += "#{hDoInfo[TSR_PRM_SYSCALL]}ȯԤ롥"
      end

      if (hDoInfo[TSR_PRM_GCOV].nil?() == false)  # gcov
        sAllDo += "#{TTJ_NEW_LINE}#{sIndent}#{TSR_PRM_GCOV}#{GRP_TTJ_STATUS[hDoInfo[TSR_PRM_GCOV]][TSR_PRM_GCOV]}"
      end

      sAllDo = sAllDo.gsub("#{@sTestID}_", "")  # Alias

      return sAllDo  # [String]doܸ첽ʸ
    end

    #=================================================================
    # : BlankΥ׻
    #=================================================================
    def blank_size(sAttr)
      check_class(String, sAttr)  # ֥Ȥγ°

      if (@nBlankSize < sAttr.size())
        @nBlankSize = sAttr.size()
      end
    end

    #=================================================================
    # : °Ĺ碌뤿˥ǥȤ֤
    #=================================================================
    def blank(sAttr)
      check_class(String, sAttr)  # ֥Ȥγ°

      sRetAtt = "#{@sBlankIndent}#{sAttr}"

      (@nBlankSize - sAttr.size()).times{
        sRetAtt += "#{TTJ_BLINK_INDEX}"
      }

      sRetAtt += "#{TTJ_PARTITION}"

      return sRetAtt  # [String]°Ĺ碌ʸ
    end

  end
end
