#!ruby
#
#  TTG
#      TOPPERS Test Generator
#
#  Copyright (C) 2009-2011 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2010-2011 by Digital Craft Inc.
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: TestScenario.rb 2 2012-05-09 02:23:52Z nces-shigihara $
#
require "common/bin/test_scenario/TestScenario.rb"
require "ttj/bin/class/TTJModule.rb"

#=====================================================================
# CommonModule
#=====================================================================
module CommonModule
  #===================================================================
  # 饹̾: TestScenario
  #     : PreConditionDoPostConditionΥǡݻ
  #===================================================================
  class TestScenario
    include CommonModule
    include TTJModule

    #=================================================================
    # : TestScenarioTESRYɾܸ첽ƥƥID
    #         ֤
    #=================================================================
    def japanize_tesry_info()
      sVariation = ""
      sTTJPre    = ""
      sTTJDoPost = ""

      # Variation
      if (hVariation.empty?() == false)
        sVariation = japanize_variation_info()
      end

      # pre_condition
      sTTJPre = cPreCondition.japanize_pre_info()

      # dopost_conditionΥֹȥƥå
      # 2ǹԤϥֹϥƥå򼨤
      aSteps = []

      aDo_PostCondition.each{|cDo_PostCondition|
        if (aSteps[cDo_PostCondition.nSeqNum].nil?() == true)
          aSteps[cDo_PostCondition.nSeqNum] = []  # ֹμ
        end

        aSteps[cDo_PostCondition.nSeqNum].push(cDo_PostCondition.nTimeTick)  # ƥåμ
      }

      # ֹȥƥå񤯤ν
      # ֹȥƥåˤdopost_conditionξܸ첽
      bSeqNum   = false  # ֹ椬ʣ뤫ñ줢뤫򼨤ե饰
      bTickFlag = false  # ƥåȯԸ夫ξˤɬƥå񤯤Ȥ򼨤ե饰
      bCondFlag = true   # conditiondo񤯤񤫤ʤ򼨤ե饰

      if (aSteps.size() > 1)
        bSeqNum = true  # ֹ椬ʣϥֹ椬ʣ뤳Ȥ򼨤ե饰
      end

      aSteps.each_index{|nSeq|
        if (aSteps[nSeq].size() > 1) || (bTickFlag == true)  # 륷ֹ˾ʣξ
          aSteps[nSeq].each{|nTick|  # doν
            bTimeTick = search_do_info(nSeq)  # doʣν뤫å
            cDo_PostCondition = search_do_post_condition(nSeq, nTick)  # do
            sTTJDoPost += cDo_PostCondition.japanize_do_info(bSeqNum, (bTickFlag == true) ? bTickFlag : bTimeTick, bCondFlag)  # ܸ첽
            bCondFlag = false  # ֽפ񤫤ʤ褦ˤ뤿
          }

          bCondFlag = true

          aSteps[nSeq].each{|nTick|  # post_conditionν
            cDo_PostCondition = search_do_post_condition(nSeq, nTick)  # post_condition
            sTTJDoPost += cDo_PostCondition.japanize_post_info(bSeqNum, true, bCondFlag)  # ܸ첽
            bCondFlag = false  # ָ֡פ񤫤ʤ褦ˤ뤿
          }

          bCondFlag = true
          bTickFlag = true
        else  # 륷ֹ˾󤬰ĤΤߤξ
          cDo_PostCondition = search_do_post_condition(nSeq)
          sTTJDoPost += cDo_PostCondition.japanize_do_info(bSeqNum, false, bCondFlag)
          sTTJDoPost += cDo_PostCondition.japanize_post_info(bSeqNum, false, bCondFlag)
        end
      }

      # ܸ첽TESRYɤξϥåˤޤȤ
      hJapanizeInfo = {@sTestID => sVariation + sTTJPre + sTTJDoPost}

      return hJapanizeInfo  # [Hash]ƥID(key)ܸ첽(val)ϥåˤ֤
    end

    #=================================================================
    # : variationܸ첽
    #=================================================================
    def japanize_variation_info()
      sIndent       = "#{TTJ_TAB}"
      sAllVariation = "#{GRP_TTJ_CONDITION[TSR_LBL_VARIATION]}#{TTJ_NEW_LINE}"

      # BlankΥ׻
      blank_size = 1

      @hVariation.each{|key, val|
        if (GRP_TTJ_VARIATION[key].nil?() == true)
          $sAttrErr += "[variation : #{key}] #{@sTestID}#{TTJ_NEW_LINE}"  # ꤵƤʤ°Υ顼
        elsif (GRP_TTJ_STATUS[val].nil?() == true)
          $sAttrErr += "[variation/#{key} : #{val}] #{@sTestID}#{TTJ_NEW_LINE}"  # ꤵƤʤ°Υ顼
        elsif (blank_size < GRP_TTJ_VARIATION[key].size())
          blank_size = GRP_TTJ_VARIATION[key].size()  # Ĺ°Υ
        end
      }

      # Variationܸ첽
      @hVariation.each{|key, val|
        blank = ""

        if (GRP_TTJ_VARIATION[key].nil?() == true)
          next
        else
          (blank_size - GRP_TTJ_VARIATION[key].size()).times {
            blank += TTJ_BLINK_INDEX  # Blank
          }
        end

        # °ͤtruefalseξ
        if ((key == TSR_PRM_GAIN_TIME)       || (key == TSR_PRM_ENA_EXC_LOCK)    || (key == TSR_PRM_GCOV_ALL) ||
            (key == TSR_PRM_SUPPORT_GET_UTM) || (key == TSR_PRM_SUPPORT_ENA_INT) || (key == TSR_PRM_SUPPORT_DIS_INT))
          sAllVariation += "#{sIndent}#{GRP_TTJ_VARIATION[key]}#{blank}#{TTJ_PARTITION}#{GRP_TTJ_STATUS[val][key]}#{TTJ_NEW_LINE}"
        else
          sAllVariation += "#{sIndent}#{GRP_TTJ_VARIATION[key]}#{blank}#{TTJ_PARTITION}#{GRP_TTJ_STATUS[val]}#{TTJ_NEW_LINE}"
        end
      }

      sAllVariation += "#{TTJ_NEW_LINE}"

      return sAllVariation  # [String]Хꥨܸ첽ʸ
    end

    #=================================================================
    # : nSeqNumnTimeTick˳cDo_PostCondition
    #         ƾä
    #=================================================================
    def search_do_post_condition(nSeq, nTick = nil)
      check_class(Integer, nSeq)         # ֹ
      check_class(Integer, nTick, true)  # ƥå

      aDo_PostCondition.each{|cDo_PostCondition|
        if ((nTick.nil?() == true) && (cDo_PostCondition.nSeqNum == nSeq))
          return cDo_PostCondition  # [cDo_PostCondition]DoPostConditionΥ饹
        elsif ((cDo_PostCondition.nSeqNum == nSeq) && (cDo_PostCondition.nTimeTick == nTick))
          return cDo_PostCondition  # [cDo_PostCondition]DoPostConditionΥ饹
        end
      }
    end

    #=================================================================
    # : nSeqNumdoξʣ뤫ɤ֤
    #=================================================================
    def search_do_info(nSeq)
      check_class(Integer, nSeq)  # ֹ

      # doʣν뤫å
      # ʣξtrueñξfalse֤
      aDoInfo = []

      aDo_PostCondition.each{|cDo_PostCondition|
        if ((cDo_PostCondition.nSeqNum == nSeq) && (cDo_PostCondition.hDo.empty?() == false))
          aDoInfo.push(cDo_PostCondition.nTimeTick)
        end
      }

      bDoFlag = (aDoInfo.size() > 1) ? true : false

      return bDoFlag  # [Bool]DoξʣξtrueʣǤϤʤfalse֤
    end

  end
end
